/*
 * PHP-GTK - The PHP language bindings for GTK+
 *
 * Copyright (C) 2001,2002 Andrei Zmievski <andrei@php.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
/* $Id: php_gdk.c,v 1.5 2002/04/11 02:19:46 andrei Exp $: */

#include "php_gtk.h"
#if HAVE_PHP_GTK

#include "php_gtk+.h"

#include <gdk/gdkkeysyms.h>
void php_gdk_register_keysyms(int module_number TSRMLS_DC)
{
	REGISTER_LONG_CONSTANT("GDK_KEY_VoidSymbol", GDK_VoidSymbol, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_BackSpace", GDK_BackSpace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Tab", GDK_Tab, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Linefeed", GDK_Linefeed, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Clear", GDK_Clear, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Return", GDK_Return, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pause", GDK_Pause, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Scroll_Lock", GDK_Scroll_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Sys_Req", GDK_Sys_Req, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Escape", GDK_Escape, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Delete", GDK_Delete, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Multi_key", GDK_Multi_key, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_SingleCandidate", GDK_SingleCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_MultipleCandidate", GDK_MultipleCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_PreviousCandidate", GDK_PreviousCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Kanji", GDK_Kanji, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Muhenkan", GDK_Muhenkan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Henkan_Mode", GDK_Henkan_Mode, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Henkan", GDK_Henkan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Romaji", GDK_Romaji, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hiragana", GDK_Hiragana, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Katakana", GDK_Katakana, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hiragana_Katakana", GDK_Hiragana_Katakana, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zenkaku", GDK_Zenkaku, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hankaku", GDK_Hankaku, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zenkaku_Hankaku", GDK_Zenkaku_Hankaku, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Touroku", GDK_Touroku, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Massyo", GDK_Massyo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Kana_Lock", GDK_Kana_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Kana_Shift", GDK_Kana_Shift, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Eisu_Shift", GDK_Eisu_Shift, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Eisu_toggle", GDK_Eisu_toggle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zen_Koho", GDK_Zen_Koho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Mae_Koho", GDK_Mae_Koho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Home", GDK_Home, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Left", GDK_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Up", GDK_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Right", GDK_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Down", GDK_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Prior", GDK_Prior, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Page_Up", GDK_Page_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Next", GDK_Next, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Page_Down", GDK_Page_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_End", GDK_End, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Begin", GDK_Begin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Select", GDK_Select, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Print", GDK_Print, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Execute", GDK_Execute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Insert", GDK_Insert, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Undo", GDK_Undo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Redo", GDK_Redo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Menu", GDK_Menu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Find", GDK_Find, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cancel", GDK_Cancel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Help", GDK_Help, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Break", GDK_Break, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Mode_switch", GDK_Mode_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_script_switch", GDK_script_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Num_Lock", GDK_Num_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Space", GDK_KP_Space, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Tab", GDK_KP_Tab, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Enter", GDK_KP_Enter, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_F1", GDK_KP_F1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_F2", GDK_KP_F2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_F3", GDK_KP_F3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_F4", GDK_KP_F4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Home", GDK_KP_Home, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Left", GDK_KP_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Up", GDK_KP_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Right", GDK_KP_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Down", GDK_KP_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Prior", GDK_KP_Prior, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Page_Up", GDK_KP_Page_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Next", GDK_KP_Next, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Page_Down", GDK_KP_Page_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_End", GDK_KP_End, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Begin", GDK_KP_Begin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Insert", GDK_KP_Insert, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Delete", GDK_KP_Delete, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Equal", GDK_KP_Equal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Multiply", GDK_KP_Multiply, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Add", GDK_KP_Add, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Separator", GDK_KP_Separator, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Subtract", GDK_KP_Subtract, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Decimal", GDK_KP_Decimal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_Divide", GDK_KP_Divide, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_0", GDK_KP_0, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_1", GDK_KP_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_2", GDK_KP_2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_3", GDK_KP_3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_4", GDK_KP_4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_5", GDK_KP_5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_6", GDK_KP_6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_7", GDK_KP_7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_8", GDK_KP_8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_KP_9", GDK_KP_9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F1", GDK_F1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F2", GDK_F2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F3", GDK_F3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F4", GDK_F4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F5", GDK_F5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F6", GDK_F6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F7", GDK_F7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F8", GDK_F8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F9", GDK_F9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F10", GDK_F10, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F11", GDK_F11, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L1", GDK_L1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F12", GDK_F12, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L2", GDK_L2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F13", GDK_F13, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L3", GDK_L3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F14", GDK_F14, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L4", GDK_L4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F15", GDK_F15, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L5", GDK_L5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F16", GDK_F16, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L6", GDK_L6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F17", GDK_F17, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L7", GDK_L7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F18", GDK_F18, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L8", GDK_L8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F19", GDK_F19, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L9", GDK_L9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F20", GDK_F20, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L10", GDK_L10, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F21", GDK_F21, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R1", GDK_R1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F22", GDK_F22, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R2", GDK_R2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F23", GDK_F23, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R3", GDK_R3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F24", GDK_F24, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R4", GDK_R4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F25", GDK_F25, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R5", GDK_R5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F26", GDK_F26, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R6", GDK_R6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F27", GDK_F27, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R7", GDK_R7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F28", GDK_F28, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R8", GDK_R8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F29", GDK_F29, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R9", GDK_R9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F30", GDK_F30, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R10", GDK_R10, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F31", GDK_F31, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R11", GDK_R11, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F32", GDK_F32, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R12", GDK_R12, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F33", GDK_F33, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R13", GDK_R13, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F34", GDK_F34, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R14", GDK_R14, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F35", GDK_F35, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R15", GDK_R15, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Shift_L", GDK_Shift_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Shift_R", GDK_Shift_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Control_L", GDK_Control_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Control_R", GDK_Control_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Caps_Lock", GDK_Caps_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Shift_Lock", GDK_Shift_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Meta_L", GDK_Meta_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Meta_R", GDK_Meta_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Alt_L", GDK_Alt_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Alt_R", GDK_Alt_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Super_L", GDK_Super_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Super_R", GDK_Super_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hyper_L", GDK_Hyper_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hyper_R", GDK_Hyper_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Lock", GDK_ISO_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Level2_Latch", GDK_ISO_Level2_Latch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Level3_Shift", GDK_ISO_Level3_Shift, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Level3_Latch", GDK_ISO_Level3_Latch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Level3_Lock", GDK_ISO_Level3_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Group_Shift", GDK_ISO_Group_Shift, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Group_Latch", GDK_ISO_Group_Latch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Group_Lock", GDK_ISO_Group_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Next_Group", GDK_ISO_Next_Group, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Next_Group_Lock", GDK_ISO_Next_Group_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Prev_Group", GDK_ISO_Prev_Group, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Prev_Group_Lock", GDK_ISO_Prev_Group_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_First_Group", GDK_ISO_First_Group, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_First_Group_Lock", GDK_ISO_First_Group_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Last_Group", GDK_ISO_Last_Group, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Last_Group_Lock", GDK_ISO_Last_Group_Lock, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Left_Tab", GDK_ISO_Left_Tab, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Move_Line_Up", GDK_ISO_Move_Line_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Move_Line_Down", GDK_ISO_Move_Line_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Partial_Line_Up", GDK_ISO_Partial_Line_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Partial_Line_Down", GDK_ISO_Partial_Line_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Partial_Space_Left", GDK_ISO_Partial_Space_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Partial_Space_Right", GDK_ISO_Partial_Space_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Set_Margin_Left", GDK_ISO_Set_Margin_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Set_Margin_Right", GDK_ISO_Set_Margin_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Release_Margin_Left", GDK_ISO_Release_Margin_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Release_Margin_Right", GDK_ISO_Release_Margin_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Release_Both_Margins", GDK_ISO_Release_Both_Margins, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Fast_Cursor_Left", GDK_ISO_Fast_Cursor_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Fast_Cursor_Right", GDK_ISO_Fast_Cursor_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Fast_Cursor_Up", GDK_ISO_Fast_Cursor_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Fast_Cursor_Down", GDK_ISO_Fast_Cursor_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Continuous_Underline", GDK_ISO_Continuous_Underline, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Discontinuous_Underline", GDK_ISO_Discontinuous_Underline, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Emphasize", GDK_ISO_Emphasize, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Center_Object", GDK_ISO_Center_Object, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ISO_Enter", GDK_ISO_Enter, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_grave", GDK_dead_grave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_acute", GDK_dead_acute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_circumflex", GDK_dead_circumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_tilde", GDK_dead_tilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_macron", GDK_dead_macron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_breve", GDK_dead_breve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_abovedot", GDK_dead_abovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_diaeresis", GDK_dead_diaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_abovering", GDK_dead_abovering, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_doubleacute", GDK_dead_doubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_caron", GDK_dead_caron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_cedilla", GDK_dead_cedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_ogonek", GDK_dead_ogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_iota", GDK_dead_iota, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_voiced_sound", GDK_dead_voiced_sound, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_semivoiced_sound", GDK_dead_semivoiced_sound, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dead_belowdot", GDK_dead_belowdot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_First_Virtual_Screen", GDK_First_Virtual_Screen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Prev_Virtual_Screen", GDK_Prev_Virtual_Screen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Next_Virtual_Screen", GDK_Next_Virtual_Screen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Last_Virtual_Screen", GDK_Last_Virtual_Screen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Terminate_Server", GDK_Terminate_Server, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_AccessX_Enable", GDK_AccessX_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_AccessX_Feedback_Enable", GDK_AccessX_Feedback_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_RepeatKeys_Enable", GDK_RepeatKeys_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_SlowKeys_Enable", GDK_SlowKeys_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_BounceKeys_Enable", GDK_BounceKeys_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_StickyKeys_Enable", GDK_StickyKeys_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_MouseKeys_Enable", GDK_MouseKeys_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_MouseKeys_Accel_Enable", GDK_MouseKeys_Accel_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Overlay1_Enable", GDK_Overlay1_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Overlay2_Enable", GDK_Overlay2_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_AudibleBell_Enable", GDK_AudibleBell_Enable, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Left", GDK_Pointer_Left, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Right", GDK_Pointer_Right, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Up", GDK_Pointer_Up, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Down", GDK_Pointer_Down, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_UpLeft", GDK_Pointer_UpLeft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_UpRight", GDK_Pointer_UpRight, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DownLeft", GDK_Pointer_DownLeft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DownRight", GDK_Pointer_DownRight, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button_Dflt", GDK_Pointer_Button_Dflt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button1", GDK_Pointer_Button1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button2", GDK_Pointer_Button2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button3", GDK_Pointer_Button3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button4", GDK_Pointer_Button4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Button5", GDK_Pointer_Button5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick_Dflt", GDK_Pointer_DblClick_Dflt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick1", GDK_Pointer_DblClick1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick2", GDK_Pointer_DblClick2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick3", GDK_Pointer_DblClick3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick4", GDK_Pointer_DblClick4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DblClick5", GDK_Pointer_DblClick5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag_Dflt", GDK_Pointer_Drag_Dflt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag1", GDK_Pointer_Drag1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag2", GDK_Pointer_Drag2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag3", GDK_Pointer_Drag3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag4", GDK_Pointer_Drag4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Drag5", GDK_Pointer_Drag5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_EnableKeys", GDK_Pointer_EnableKeys, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_Accelerate", GDK_Pointer_Accelerate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DfltBtnNext", GDK_Pointer_DfltBtnNext, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Pointer_DfltBtnPrev", GDK_Pointer_DfltBtnPrev, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Duplicate", GDK_3270_Duplicate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_FieldMark", GDK_3270_FieldMark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Right2", GDK_3270_Right2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Left2", GDK_3270_Left2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_BackTab", GDK_3270_BackTab, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_EraseEOF", GDK_3270_EraseEOF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_EraseInput", GDK_3270_EraseInput, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Reset", GDK_3270_Reset, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Quit", GDK_3270_Quit, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_PA1", GDK_3270_PA1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_PA2", GDK_3270_PA2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_PA3", GDK_3270_PA3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Test", GDK_3270_Test, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Attn", GDK_3270_Attn, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_CursorBlink", GDK_3270_CursorBlink, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_AltCursor", GDK_3270_AltCursor, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_KeyClick", GDK_3270_KeyClick, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Jump", GDK_3270_Jump, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Ident", GDK_3270_Ident, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Rule", GDK_3270_Rule, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Copy", GDK_3270_Copy, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Play", GDK_3270_Play, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Setup", GDK_3270_Setup, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Record", GDK_3270_Record, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_ChangeScreen", GDK_3270_ChangeScreen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_DeleteWord", GDK_3270_DeleteWord, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_ExSelect", GDK_3270_ExSelect, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_CursorSelect", GDK_3270_CursorSelect, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_PrintScreen", GDK_3270_PrintScreen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3270_Enter", GDK_3270_Enter, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_space", GDK_space, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_exclam", GDK_exclam, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_quotedbl", GDK_quotedbl, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_numbersign", GDK_numbersign, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dollar", GDK_dollar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_percent", GDK_percent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ampersand", GDK_ampersand, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_apostrophe", GDK_apostrophe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_quoteright", GDK_quoteright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_parenleft", GDK_parenleft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_parenright", GDK_parenright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_asterisk", GDK_asterisk, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_plus", GDK_plus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_comma", GDK_comma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_minus", GDK_minus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_period", GDK_period, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_slash", GDK_slash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_0", GDK_0, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_1", GDK_1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_2", GDK_2, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_3", GDK_3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_4", GDK_4, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_5", GDK_5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_6", GDK_6, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_7", GDK_7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_8", GDK_8, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_9", GDK_9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_colon", GDK_colon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_semicolon", GDK_semicolon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_less", GDK_less, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_equal", GDK_equal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_greater", GDK_greater, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_question", GDK_question, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_at", GDK_at, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_A", GDK_A, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_B", GDK_B, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_C", GDK_C, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_D", GDK_D, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_E", GDK_E, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_F", GDK_F, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_G", GDK_G, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_H", GDK_H, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_I", GDK_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_J", GDK_J, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_K", GDK_K, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_L", GDK_L, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_M", GDK_M, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_N", GDK_N, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_O", GDK_O, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_P", GDK_P, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Q", GDK_Q, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_R", GDK_R, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_S", GDK_S, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_T", GDK_T, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_U", GDK_U, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_V", GDK_V, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_W", GDK_W, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_X", GDK_X, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Y", GDK_Y, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Z", GDK_Z, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_bracketleft", GDK_bracketleft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_backslash", GDK_backslash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_bracketright", GDK_bracketright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_asciicircum", GDK_asciicircum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_underscore", GDK_underscore, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_grave", GDK_grave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_quoteleft", GDK_quoteleft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__a", GDK_a, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__b", GDK_b, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__c", GDK_c, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__d", GDK_d, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__e", GDK_e, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__f", GDK_f, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__g", GDK_g, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__h", GDK_h, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__i", GDK_i, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__j", GDK_j, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__k", GDK_k, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__l", GDK_l, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__m", GDK_m, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__n", GDK_n, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__o", GDK_o, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__p", GDK_p, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__q", GDK_q, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__r", GDK_r, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__s", GDK_s, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__t", GDK_t, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__u", GDK_u, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__v", GDK_v, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__w", GDK_w, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__x", GDK_x, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__y", GDK_y, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__z", GDK_z, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_braceleft", GDK_braceleft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_bar", GDK_bar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_braceright", GDK_braceright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_asciitilde", GDK_asciitilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_nobreakspace", GDK_nobreakspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_exclamdown", GDK_exclamdown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_cent", GDK_cent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_sterling", GDK_sterling, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_currency", GDK_currency, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_yen", GDK_yen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_brokenbar", GDK_brokenbar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_section", GDK_section, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_diaeresis", GDK_diaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_copyright", GDK_copyright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ordfeminine", GDK_ordfeminine, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_guillemotleft", GDK_guillemotleft, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_notsign", GDK_notsign, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hyphen", GDK_hyphen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_registered", GDK_registered, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_macron", GDK_macron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_degree", GDK_degree, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_plusminus", GDK_plusminus, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_twosuperior", GDK_twosuperior, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_threesuperior", GDK_threesuperior, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_acute", GDK_acute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_mu", GDK_mu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_paragraph", GDK_paragraph, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_periodcentered", GDK_periodcentered, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_cedilla", GDK_cedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onesuperior", GDK_onesuperior, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_masculine", GDK_masculine, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_guillemotright", GDK_guillemotright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onequarter", GDK_onequarter, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onehalf", GDK_onehalf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_threequarters", GDK_threequarters, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_questiondown", GDK_questiondown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Agrave", GDK_Agrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Aacute", GDK_Aacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Acircumflex", GDK_Acircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Atilde", GDK_Atilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Adiaeresis", GDK_Adiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Aring", GDK_Aring, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_AE", GDK_AE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ccedilla", GDK_Ccedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Egrave", GDK_Egrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Eacute", GDK_Eacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ecircumflex", GDK_Ecircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ediaeresis", GDK_Ediaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Igrave", GDK_Igrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Iacute", GDK_Iacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Icircumflex", GDK_Icircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Idiaeresis", GDK_Idiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ETH", GDK_ETH, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Eth", GDK_Eth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ntilde", GDK_Ntilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ograve", GDK_Ograve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Oacute", GDK_Oacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ocircumflex", GDK_Ocircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Otilde", GDK_Otilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Odiaeresis", GDK_Odiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_multiply", GDK_multiply, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ooblique", GDK_Ooblique, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ugrave", GDK_Ugrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Uacute", GDK_Uacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ucircumflex", GDK_Ucircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Udiaeresis", GDK_Udiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Yacute", GDK_Yacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_THORN", GDK_THORN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Thorn", GDK_Thorn, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ssharp", GDK_ssharp, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__agrave", GDK_agrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__aacute", GDK_aacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__acircumflex", GDK_acircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__atilde", GDK_atilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__adiaeresis", GDK_adiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__aring", GDK_aring, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ae", GDK_ae, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ccedilla", GDK_ccedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__egrave", GDK_egrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__eacute", GDK_eacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ecircumflex", GDK_ecircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ediaeresis", GDK_ediaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__igrave", GDK_igrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__iacute", GDK_iacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__icircumflex", GDK_icircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__idiaeresis", GDK_idiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY___eth", GDK_eth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ntilde", GDK_ntilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ograve", GDK_ograve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__oacute", GDK_oacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ocircumflex", GDK_ocircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__otilde", GDK_otilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__odiaeresis", GDK_odiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_division", GDK_division, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_oslash", GDK_oslash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ugrave", GDK_ugrave, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__uacute", GDK_uacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ucircumflex", GDK_ucircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__udiaeresis", GDK_udiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__yacute", GDK_yacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY___thorn", GDK_thorn, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ydiaeresis", GDK_ydiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Aogonek", GDK_Aogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_breve", GDK_breve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Lstroke", GDK_Lstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Lcaron", GDK_Lcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Sacute", GDK_Sacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Scaron", GDK_Scaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Scedilla", GDK_Scedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Tcaron", GDK_Tcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zacute", GDK_Zacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zcaron", GDK_Zcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Zabovedot", GDK_Zabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__aogonek", GDK_aogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ogonek", GDK_ogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__lstroke", GDK_lstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__lcaron", GDK_lcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__sacute", GDK_sacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_caron", GDK_caron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__scaron", GDK_scaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__scedilla", GDK_scedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__tcaron", GDK_tcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__zacute", GDK_zacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_doubleacute", GDK_doubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__zcaron", GDK_zcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__zabovedot", GDK_zabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Racute", GDK_Racute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Abreve", GDK_Abreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Lacute", GDK_Lacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cacute", GDK_Cacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ccaron", GDK_Ccaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Eogonek", GDK_Eogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ecaron", GDK_Ecaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Dcaron", GDK_Dcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Dstroke", GDK_Dstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Nacute", GDK_Nacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ncaron", GDK_Ncaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Odoubleacute", GDK_Odoubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Rcaron", GDK_Rcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Uring", GDK_Uring, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Udoubleacute", GDK_Udoubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Tcedilla", GDK_Tcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__racute", GDK_racute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__abreve", GDK_abreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__lacute", GDK_lacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__cacute", GDK_cacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ccaron", GDK_ccaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__eogonek", GDK_eogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ecaron", GDK_ecaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__dcaron", GDK_dcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__dstroke", GDK_dstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__nacute", GDK_nacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ncaron", GDK_ncaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__odoubleacute", GDK_odoubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__udoubleacute", GDK_udoubleacute, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__rcaron", GDK_rcaron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__uring", GDK_uring, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__tcedilla", GDK_tcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_abovedot", GDK_abovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hstroke", GDK_Hstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hcircumflex", GDK_Hcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Iabovedot", GDK_Iabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Gbreve", GDK_Gbreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Jcircumflex", GDK_Jcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__hstroke", GDK_hstroke, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__hcircumflex", GDK_hcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_idotless", GDK_idotless, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__gbreve", GDK_gbreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__jcircumflex", GDK_jcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cabovedot", GDK_Cabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ccircumflex", GDK_Ccircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Gabovedot", GDK_Gabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Gcircumflex", GDK_Gcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ubreve", GDK_Ubreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Scircumflex", GDK_Scircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__cabovedot", GDK_cabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ccircumflex", GDK_ccircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__gabovedot", GDK_gabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__gcircumflex", GDK_gcircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ubreve", GDK_ubreve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__scircumflex", GDK_scircumflex, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kra", GDK_kra, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kappa", GDK_kappa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Rcedilla", GDK_Rcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Itilde", GDK_Itilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Lcedilla", GDK_Lcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Emacron", GDK_Emacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Gcedilla", GDK_Gcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Tslash", GDK_Tslash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__rcedilla", GDK_rcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__itilde", GDK_itilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__lcedilla", GDK_lcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__emacron", GDK_emacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__gcedilla", GDK_gcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__tslash", GDK_tslash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ENG", GDK_ENG, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__eng", GDK_eng, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Amacron", GDK_Amacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Iogonek", GDK_Iogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Eabovedot", GDK_Eabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Imacron", GDK_Imacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ncedilla", GDK_Ncedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Omacron", GDK_Omacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Kcedilla", GDK_Kcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Uogonek", GDK_Uogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Utilde", GDK_Utilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Umacron", GDK_Umacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__amacron", GDK_amacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__iogonek", GDK_iogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__eabovedot", GDK_eabovedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__imacron", GDK_imacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__ncedilla", GDK_ncedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__omacron", GDK_omacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kcedilla", GDK_kcedilla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__uogonek", GDK_uogonek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__utilde", GDK_utilde, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__umacron", GDK_umacron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_overline", GDK_overline, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_fullstop", GDK_kana_fullstop, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_openingbracket", GDK_kana_openingbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_closingbracket", GDK_kana_closingbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_comma", GDK_kana_comma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_conjunctive", GDK_kana_conjunctive, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_middledot", GDK_kana_middledot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_WO", GDK_kana_WO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_a", GDK_kana_a, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_i", GDK_kana_i, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_u", GDK_kana_u, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_e", GDK_kana_e, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_o", GDK_kana_o, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_ya", GDK_kana_ya, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_yu", GDK_kana_yu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_yo", GDK_kana_yo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_tsu", GDK_kana_tsu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_tu", GDK_kana_tu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_prolongedsound", GDK_prolongedsound, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_A", GDK_kana_A, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_I", GDK_kana_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_U", GDK_kana_U, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_E", GDK_kana_E, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_O", GDK_kana_O, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_KA", GDK_kana_KA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_KI", GDK_kana_KI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_KU", GDK_kana_KU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_KE", GDK_kana_KE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_KO", GDK_kana_KO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_SA", GDK_kana_SA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_SHI", GDK_kana_SHI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_SU", GDK_kana_SU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_SE", GDK_kana_SE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_SO", GDK_kana_SO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_TA", GDK_kana_TA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_CHI", GDK_kana_CHI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_TI", GDK_kana_TI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_TSU", GDK_kana_TSU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_TU", GDK_kana_TU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_TE", GDK_kana_TE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_TO", GDK_kana_TO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_NA", GDK_kana_NA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_NI", GDK_kana_NI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_NU", GDK_kana_NU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_NE", GDK_kana_NE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_NO", GDK_kana_NO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_HA", GDK_kana_HA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_HI", GDK_kana_HI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_FU", GDK_kana_FU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_HU", GDK_kana_HU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_HE", GDK_kana_HE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_HO", GDK_kana_HO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_MA", GDK_kana_MA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_MI", GDK_kana_MI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_MU", GDK_kana_MU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_ME", GDK_kana_ME, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_MO", GDK_kana_MO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_YA", GDK_kana_YA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_YU", GDK_kana_YU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__kana_YO", GDK_kana_YO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_RA", GDK_kana_RA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_RI", GDK_kana_RI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_RU", GDK_kana_RU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_RE", GDK_kana_RE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_RO", GDK_kana_RO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_WA", GDK_kana_WA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_N", GDK_kana_N, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_voicedsound", GDK_voicedsound, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_semivoicedsound", GDK_semivoicedsound, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_kana_switch", GDK_kana_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_comma", GDK_Arabic_comma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_semicolon", GDK_Arabic_semicolon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_question_mark", GDK_Arabic_question_mark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hamza", GDK_Arabic_hamza, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_maddaonalef", GDK_Arabic_maddaonalef, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hamzaonalef", GDK_Arabic_hamzaonalef, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hamzaonwaw", GDK_Arabic_hamzaonwaw, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hamzaunderalef", GDK_Arabic_hamzaunderalef, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hamzaonyeh", GDK_Arabic_hamzaonyeh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_alef", GDK_Arabic_alef, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_beh", GDK_Arabic_beh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_tehmarbuta", GDK_Arabic_tehmarbuta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_teh", GDK_Arabic_teh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_theh", GDK_Arabic_theh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_jeem", GDK_Arabic_jeem, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_hah", GDK_Arabic_hah, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_khah", GDK_Arabic_khah, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_dal", GDK_Arabic_dal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_thal", GDK_Arabic_thal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_ra", GDK_Arabic_ra, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_zain", GDK_Arabic_zain, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_seen", GDK_Arabic_seen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_sheen", GDK_Arabic_sheen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_sad", GDK_Arabic_sad, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_dad", GDK_Arabic_dad, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_tah", GDK_Arabic_tah, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_zah", GDK_Arabic_zah, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_ain", GDK_Arabic_ain, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_ghain", GDK_Arabic_ghain, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_tatweel", GDK_Arabic_tatweel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_feh", GDK_Arabic_feh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_qaf", GDK_Arabic_qaf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_kaf", GDK_Arabic_kaf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_lam", GDK_Arabic_lam, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_meem", GDK_Arabic_meem, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_noon", GDK_Arabic_noon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_ha", GDK_Arabic_ha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_heh", GDK_Arabic_heh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_waw", GDK_Arabic_waw, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_alefmaksura", GDK_Arabic_alefmaksura, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_yeh", GDK_Arabic_yeh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_fathatan", GDK_Arabic_fathatan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_dammatan", GDK_Arabic_dammatan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_kasratan", GDK_Arabic_kasratan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_fatha", GDK_Arabic_fatha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_damma", GDK_Arabic_damma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_kasra", GDK_Arabic_kasra, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_shadda", GDK_Arabic_shadda, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_sukun", GDK_Arabic_sukun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Arabic_switch", GDK_Arabic_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_dje", GDK_Serbian_dje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Macedonia_gje", GDK_Macedonia_gje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_io", GDK_Cyrillic_io, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukrainian_ie", GDK_Ukrainian_ie, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukranian_je", GDK_Ukranian_je, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Macedonia_dse", GDK_Macedonia_dse, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukrainian_i", GDK_Ukrainian_i, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukranian_i", GDK_Ukranian_i, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukrainian_yi", GDK_Ukrainian_yi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Ukranian_yi", GDK_Ukranian_yi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_je", GDK_Cyrillic_je, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_je", GDK_Serbian_je, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_lje", GDK_Cyrillic_lje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_lje", GDK_Serbian_lje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_nje", GDK_Cyrillic_nje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_nje", GDK_Serbian_nje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_tshe", GDK_Serbian_tshe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Macedonia_kje", GDK_Macedonia_kje, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Byelorussian_shortu", GDK_Byelorussian_shortu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_dzhe", GDK_Cyrillic_dzhe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Serbian_dze", GDK_Serbian_dze, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_numerosign", GDK_numerosign, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_DJE", GDK_Serbian_DJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Macedonia_GJE", GDK_Macedonia_GJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_IO", GDK_Cyrillic_IO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukrainian_IE", GDK_Ukrainian_IE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukranian_JE", GDK_Ukranian_JE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Macedonia_DSE", GDK_Macedonia_DSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukrainian_I", GDK_Ukrainian_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukranian_I", GDK_Ukranian_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukrainian_YI", GDK_Ukrainian_YI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Ukranian_YI", GDK_Ukranian_YI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_JE", GDK_Cyrillic_JE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_JE", GDK_Serbian_JE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_LJE", GDK_Cyrillic_LJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_LJE", GDK_Serbian_LJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_NJE", GDK_Cyrillic_NJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_NJE", GDK_Serbian_NJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_TSHE", GDK_Serbian_TSHE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Macedonia_KJE", GDK_Macedonia_KJE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Byelorussian_SHORTU", GDK_Byelorussian_SHORTU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_DZHE", GDK_Cyrillic_DZHE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Serbian_DZE", GDK_Serbian_DZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_yu", GDK_Cyrillic_yu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_a", GDK_Cyrillic_a, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_be", GDK_Cyrillic_be, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_tse", GDK_Cyrillic_tse, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_de", GDK_Cyrillic_de, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ie", GDK_Cyrillic_ie, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ef", GDK_Cyrillic_ef, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ghe", GDK_Cyrillic_ghe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ha", GDK_Cyrillic_ha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_i", GDK_Cyrillic_i, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_shorti", GDK_Cyrillic_shorti, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ka", GDK_Cyrillic_ka, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_el", GDK_Cyrillic_el, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_em", GDK_Cyrillic_em, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_en", GDK_Cyrillic_en, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_o", GDK_Cyrillic_o, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_pe", GDK_Cyrillic_pe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ya", GDK_Cyrillic_ya, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_er", GDK_Cyrillic_er, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_es", GDK_Cyrillic_es, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_te", GDK_Cyrillic_te, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_u", GDK_Cyrillic_u, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_zhe", GDK_Cyrillic_zhe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ve", GDK_Cyrillic_ve, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_softsign", GDK_Cyrillic_softsign, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_yeru", GDK_Cyrillic_yeru, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_ze", GDK_Cyrillic_ze, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_sha", GDK_Cyrillic_sha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_e", GDK_Cyrillic_e, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_shcha", GDK_Cyrillic_shcha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_che", GDK_Cyrillic_che, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Cyrillic_hardsign", GDK_Cyrillic_hardsign, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_YU", GDK_Cyrillic_YU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_A", GDK_Cyrillic_A, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_BE", GDK_Cyrillic_BE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_TSE", GDK_Cyrillic_TSE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_DE", GDK_Cyrillic_DE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_IE", GDK_Cyrillic_IE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_EF", GDK_Cyrillic_EF, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_GHE", GDK_Cyrillic_GHE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_HA", GDK_Cyrillic_HA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_I", GDK_Cyrillic_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_SHORTI", GDK_Cyrillic_SHORTI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_KA", GDK_Cyrillic_KA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_EL", GDK_Cyrillic_EL, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_EM", GDK_Cyrillic_EM, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_EN", GDK_Cyrillic_EN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_O", GDK_Cyrillic_O, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_PE", GDK_Cyrillic_PE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_YA", GDK_Cyrillic_YA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_ER", GDK_Cyrillic_ER, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_ES", GDK_Cyrillic_ES, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_TE", GDK_Cyrillic_TE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_U", GDK_Cyrillic_U, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_ZHE", GDK_Cyrillic_ZHE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_VE", GDK_Cyrillic_VE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_SOFTSIGN", GDK_Cyrillic_SOFTSIGN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_YERU", GDK_Cyrillic_YERU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_ZE", GDK_Cyrillic_ZE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_SHA", GDK_Cyrillic_SHA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_E", GDK_Cyrillic_E, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_SHCHA", GDK_Cyrillic_SHCHA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_CHE", GDK_Cyrillic_CHE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Cyrillic_HARDSIGN", GDK_Cyrillic_HARDSIGN, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_ALPHAaccent", GDK_Greek_ALPHAaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_EPSILONaccent", GDK_Greek_EPSILONaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_ETAaccent", GDK_Greek_ETAaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_IOTAaccent", GDK_Greek_IOTAaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_IOTAdiaeresis", GDK_Greek_IOTAdiaeresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_OMICRONaccent", GDK_Greek_OMICRONaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_UPSILONaccent", GDK_Greek_UPSILONaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_UPSILONdieresis", GDK_Greek_UPSILONdieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_OMEGAaccent", GDK_Greek_OMEGAaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_accentdieresis", GDK_Greek_accentdieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_horizbar", GDK_Greek_horizbar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_alphaaccent", GDK_Greek_alphaaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_epsilonaccent", GDK_Greek_epsilonaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_etaaccent", GDK_Greek_etaaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_iotaaccent", GDK_Greek_iotaaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_iotadieresis", GDK_Greek_iotadieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_iotaaccentdieresis", GDK_Greek_iotaaccentdieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_omicronaccent", GDK_Greek_omicronaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_upsilonaccent", GDK_Greek_upsilonaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_upsilondieresis", GDK_Greek_upsilondieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_upsilonaccentdieresis", GDK_Greek_upsilonaccentdieresis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_omegaaccent", GDK_Greek_omegaaccent, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_ALPHA", GDK_Greek_ALPHA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_BETA", GDK_Greek_BETA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_GAMMA", GDK_Greek_GAMMA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_DELTA", GDK_Greek_DELTA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_EPSILON", GDK_Greek_EPSILON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_ZETA", GDK_Greek_ZETA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_ETA", GDK_Greek_ETA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_THETA", GDK_Greek_THETA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_IOTA", GDK_Greek_IOTA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_KAPPA", GDK_Greek_KAPPA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_LAMDA", GDK_Greek_LAMDA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_LAMBDA", GDK_Greek_LAMBDA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_MU", GDK_Greek_MU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_NU", GDK_Greek_NU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_XI", GDK_Greek_XI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_OMICRON", GDK_Greek_OMICRON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_PI", GDK_Greek_PI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_RHO", GDK_Greek_RHO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_SIGMA", GDK_Greek_SIGMA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_TAU", GDK_Greek_TAU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_UPSILON", GDK_Greek_UPSILON, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_PHI", GDK_Greek_PHI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_CHI", GDK_Greek_CHI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_PSI", GDK_Greek_PSI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_OMEGA", GDK_Greek_OMEGA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_alpha", GDK_Greek_alpha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_beta", GDK_Greek_beta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_gamma", GDK_Greek_gamma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_delta", GDK_Greek_delta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_epsilon", GDK_Greek_epsilon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_zeta", GDK_Greek_zeta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_eta", GDK_Greek_eta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_theta", GDK_Greek_theta, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_iota", GDK_Greek_iota, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_kappa", GDK_Greek_kappa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_lamda", GDK_Greek_lamda, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_lambda", GDK_Greek_lambda, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_mu", GDK_Greek_mu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_nu", GDK_Greek_nu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_xi", GDK_Greek_xi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_omicron", GDK_Greek_omicron, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_pi", GDK_Greek_pi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_rho", GDK_Greek_rho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_sigma", GDK_Greek_sigma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_finalsmallsigma", GDK_Greek_finalsmallsigma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_tau", GDK_Greek_tau, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_upsilon", GDK_Greek_upsilon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_phi", GDK_Greek_phi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_chi", GDK_Greek_chi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_psi", GDK_Greek_psi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY__Greek_omega", GDK_Greek_omega, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Greek_switch", GDK_Greek_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftradical", GDK_leftradical, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topleftradical", GDK_topleftradical, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizconnector", GDK_horizconnector, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topintegral", GDK_topintegral, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botintegral", GDK_botintegral, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_vertconnector", GDK_vertconnector, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topleftsqbracket", GDK_topleftsqbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botleftsqbracket", GDK_botleftsqbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_toprightsqbracket", GDK_toprightsqbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botrightsqbracket", GDK_botrightsqbracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topleftparens", GDK_topleftparens, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botleftparens", GDK_botleftparens, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_toprightparens", GDK_toprightparens, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botrightparens", GDK_botrightparens, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftmiddlecurlybrace", GDK_leftmiddlecurlybrace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightmiddlecurlybrace", GDK_rightmiddlecurlybrace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topleftsummation", GDK_topleftsummation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botleftsummation", GDK_botleftsummation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topvertsummationconnector", GDK_topvertsummationconnector, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botvertsummationconnector", GDK_botvertsummationconnector, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_toprightsummation", GDK_toprightsummation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_botrightsummation", GDK_botrightsummation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightmiddlesummation", GDK_rightmiddlesummation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_lessthanequal", GDK_lessthanequal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_notequal", GDK_notequal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_greaterthanequal", GDK_greaterthanequal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_integral", GDK_integral, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_therefore", GDK_therefore, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_variation", GDK_variation, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_infinity", GDK_infinity, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_nabla", GDK_nabla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_approximate", GDK_approximate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_similarequal", GDK_similarequal, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ifonlyif", GDK_ifonlyif, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_implies", GDK_implies, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_identical", GDK_identical, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_radical", GDK_radical, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_includedin", GDK_includedin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_includes", GDK_includes, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_intersection", GDK_intersection, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_union", GDK_union, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_logicaland", GDK_logicaland, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_logicalor", GDK_logicalor, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_partialderivative", GDK_partialderivative, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_function", GDK_function, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftarrow", GDK_leftarrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_uparrow", GDK_uparrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightarrow", GDK_rightarrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_downarrow", GDK_downarrow, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_blank", GDK_blank, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_soliddiamond", GDK_soliddiamond, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_checkerboard", GDK_checkerboard, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ht", GDK_ht, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ff", GDK_ff, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_cr", GDK_cr, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_lf", GDK_lf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_nl", GDK_nl, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_vt", GDK_vt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_lowrightcorner", GDK_lowrightcorner, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_uprightcorner", GDK_uprightcorner, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_upleftcorner", GDK_upleftcorner, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_lowleftcorner", GDK_lowleftcorner, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_crossinglines", GDK_crossinglines, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizlinescan1", GDK_horizlinescan1, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizlinescan3", GDK_horizlinescan3, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizlinescan5", GDK_horizlinescan5, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizlinescan7", GDK_horizlinescan7, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_horizlinescan9", GDK_horizlinescan9, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftt", GDK_leftt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightt", GDK_rightt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_bott", GDK_bott, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_topt", GDK_topt, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_vertbar", GDK_vertbar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emspace", GDK_emspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_enspace", GDK_enspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_em3space", GDK_em3space, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_em4space", GDK_em4space, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_digitspace", GDK_digitspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_punctspace", GDK_punctspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_thinspace", GDK_thinspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hairspace", GDK_hairspace, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emdash", GDK_emdash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_endash", GDK_endash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_signifblank", GDK_signifblank, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ellipsis", GDK_ellipsis, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_doubbaselinedot", GDK_doubbaselinedot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onethird", GDK_onethird, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_twothirds", GDK_twothirds, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onefifth", GDK_onefifth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_twofifths", GDK_twofifths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_threefifths", GDK_threefifths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_fourfifths", GDK_fourfifths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_onesixth", GDK_onesixth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_fivesixths", GDK_fivesixths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_careof", GDK_careof, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_figdash", GDK_figdash, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftanglebracket", GDK_leftanglebracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_decimalpoint", GDK_decimalpoint, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightanglebracket", GDK_rightanglebracket, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_marker", GDK_marker, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_oneeighth", GDK_oneeighth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_threeeighths", GDK_threeeighths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_fiveeighths", GDK_fiveeighths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_seveneighths", GDK_seveneighths, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_trademark", GDK_trademark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_signaturemark", GDK_signaturemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_trademarkincircle", GDK_trademarkincircle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftopentriangle", GDK_leftopentriangle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightopentriangle", GDK_rightopentriangle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emopencircle", GDK_emopencircle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emopenrectangle", GDK_emopenrectangle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftsinglequotemark", GDK_leftsinglequotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightsinglequotemark", GDK_rightsinglequotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftdoublequotemark", GDK_leftdoublequotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightdoublequotemark", GDK_rightdoublequotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_prescription", GDK_prescription, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_minutes", GDK_minutes, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_seconds", GDK_seconds, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_latincross", GDK_latincross, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hexagram", GDK_hexagram, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_filledrectbullet", GDK_filledrectbullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_filledlefttribullet", GDK_filledlefttribullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_filledrighttribullet", GDK_filledrighttribullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emfilledcircle", GDK_emfilledcircle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_emfilledrect", GDK_emfilledrect, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_enopencircbullet", GDK_enopencircbullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_enopensquarebullet", GDK_enopensquarebullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_openrectbullet", GDK_openrectbullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_opentribulletup", GDK_opentribulletup, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_opentribulletdown", GDK_opentribulletdown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_openstar", GDK_openstar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_enfilledcircbullet", GDK_enfilledcircbullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_enfilledsqbullet", GDK_enfilledsqbullet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_filledtribulletup", GDK_filledtribulletup, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_filledtribulletdown", GDK_filledtribulletdown, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftpointer", GDK_leftpointer, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightpointer", GDK_rightpointer, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_club", GDK_club, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_diamond", GDK_diamond, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_heart", GDK_heart, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_maltesecross", GDK_maltesecross, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_dagger", GDK_dagger, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_doubledagger", GDK_doubledagger, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_checkmark", GDK_checkmark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_ballotcross", GDK_ballotcross, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_musicalsharp", GDK_musicalsharp, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_musicalflat", GDK_musicalflat, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_malesymbol", GDK_malesymbol, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_femalesymbol", GDK_femalesymbol, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_telephone", GDK_telephone, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_telephonerecorder", GDK_telephonerecorder, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_phonographcopyright", GDK_phonographcopyright, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_caret", GDK_caret, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_singlelowquotemark", GDK_singlelowquotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_doublelowquotemark", GDK_doublelowquotemark, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_cursor", GDK_cursor, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftcaret", GDK_leftcaret, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightcaret", GDK_rightcaret, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_downcaret", GDK_downcaret, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_upcaret", GDK_upcaret, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_overbar", GDK_overbar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_downtack", GDK_downtack, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_upshoe", GDK_upshoe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_downstile", GDK_downstile, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_underbar", GDK_underbar, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_jot", GDK_jot, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_quad", GDK_quad, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_uptack", GDK_uptack, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_circle", GDK_circle, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_upstile", GDK_upstile, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_downshoe", GDK_downshoe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_rightshoe", GDK_rightshoe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_leftshoe", GDK_leftshoe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_lefttack", GDK_lefttack, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_righttack", GDK_righttack, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_doublelowline", GDK_hebrew_doublelowline, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_aleph", GDK_hebrew_aleph, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_bet", GDK_hebrew_bet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_beth", GDK_hebrew_beth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_gimel", GDK_hebrew_gimel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_gimmel", GDK_hebrew_gimmel, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_dalet", GDK_hebrew_dalet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_daleth", GDK_hebrew_daleth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_he", GDK_hebrew_he, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_waw", GDK_hebrew_waw, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_zain", GDK_hebrew_zain, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_zayin", GDK_hebrew_zayin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_chet", GDK_hebrew_chet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_het", GDK_hebrew_het, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_tet", GDK_hebrew_tet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_teth", GDK_hebrew_teth, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_yod", GDK_hebrew_yod, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalkaph", GDK_hebrew_finalkaph, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_kaph", GDK_hebrew_kaph, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_lamed", GDK_hebrew_lamed, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalmem", GDK_hebrew_finalmem, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_mem", GDK_hebrew_mem, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalnun", GDK_hebrew_finalnun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_nun", GDK_hebrew_nun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_samech", GDK_hebrew_samech, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_samekh", GDK_hebrew_samekh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_ayin", GDK_hebrew_ayin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalpe", GDK_hebrew_finalpe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_pe", GDK_hebrew_pe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalzade", GDK_hebrew_finalzade, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_finalzadi", GDK_hebrew_finalzadi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_zade", GDK_hebrew_zade, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_zadi", GDK_hebrew_zadi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_qoph", GDK_hebrew_qoph, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_kuf", GDK_hebrew_kuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_resh", GDK_hebrew_resh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_shin", GDK_hebrew_shin, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_taw", GDK_hebrew_taw, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_hebrew_taf", GDK_hebrew_taf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hebrew_switch", GDK_Hebrew_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_kokai", GDK_Thai_kokai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_khokhai", GDK_Thai_khokhai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_khokhuat", GDK_Thai_khokhuat, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_khokhwai", GDK_Thai_khokhwai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_khokhon", GDK_Thai_khokhon, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_khorakhang", GDK_Thai_khorakhang, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_ngongu", GDK_Thai_ngongu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_chochan", GDK_Thai_chochan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_choching", GDK_Thai_choching, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_chochang", GDK_Thai_chochang, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_soso", GDK_Thai_soso, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_chochoe", GDK_Thai_chochoe, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_yoying", GDK_Thai_yoying, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_dochada", GDK_Thai_dochada, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_topatak", GDK_Thai_topatak, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thothan", GDK_Thai_thothan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thonangmontho", GDK_Thai_thonangmontho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thophuthao", GDK_Thai_thophuthao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_nonen", GDK_Thai_nonen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_dodek", GDK_Thai_dodek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_totao", GDK_Thai_totao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thothung", GDK_Thai_thothung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thothahan", GDK_Thai_thothahan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thothong", GDK_Thai_thothong, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_nonu", GDK_Thai_nonu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_bobaimai", GDK_Thai_bobaimai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_popla", GDK_Thai_popla, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_phophung", GDK_Thai_phophung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_fofa", GDK_Thai_fofa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_phophan", GDK_Thai_phophan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_fofan", GDK_Thai_fofan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_phosamphao", GDK_Thai_phosamphao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_moma", GDK_Thai_moma, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_yoyak", GDK_Thai_yoyak, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_rorua", GDK_Thai_rorua, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_ru", GDK_Thai_ru, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_loling", GDK_Thai_loling, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lu", GDK_Thai_lu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_wowaen", GDK_Thai_wowaen, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sosala", GDK_Thai_sosala, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sorusi", GDK_Thai_sorusi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sosua", GDK_Thai_sosua, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_hohip", GDK_Thai_hohip, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lochula", GDK_Thai_lochula, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_oang", GDK_Thai_oang, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_honokhuk", GDK_Thai_honokhuk, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_paiyannoi", GDK_Thai_paiyannoi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraa", GDK_Thai_saraa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maihanakat", GDK_Thai_maihanakat, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraaa", GDK_Thai_saraaa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraam", GDK_Thai_saraam, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarai", GDK_Thai_sarai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraii", GDK_Thai_saraii, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraue", GDK_Thai_saraue, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarauee", GDK_Thai_sarauee, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarau", GDK_Thai_sarau, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarauu", GDK_Thai_sarauu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_phinthu", GDK_Thai_phinthu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maihanakat_maitho", GDK_Thai_maihanakat_maitho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_baht", GDK_Thai_baht, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarae", GDK_Thai_sarae, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraae", GDK_Thai_saraae, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_sarao", GDK_Thai_sarao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraaimaimuan", GDK_Thai_saraaimaimuan, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_saraaimaimalai", GDK_Thai_saraaimaimalai, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lakkhangyao", GDK_Thai_lakkhangyao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maiyamok", GDK_Thai_maiyamok, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maitaikhu", GDK_Thai_maitaikhu, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maiek", GDK_Thai_maiek, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maitho", GDK_Thai_maitho, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maitri", GDK_Thai_maitri, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_maichattawa", GDK_Thai_maichattawa, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_thanthakhat", GDK_Thai_thanthakhat, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_nikhahit", GDK_Thai_nikhahit, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_leksun", GDK_Thai_leksun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_leknung", GDK_Thai_leknung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_leksong", GDK_Thai_leksong, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_leksam", GDK_Thai_leksam, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_leksi", GDK_Thai_leksi, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lekha", GDK_Thai_lekha, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lekhok", GDK_Thai_lekhok, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lekchet", GDK_Thai_lekchet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lekpaet", GDK_Thai_lekpaet, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Thai_lekkao", GDK_Thai_lekkao, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul", GDK_Hangul, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Start", GDK_Hangul_Start, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_End", GDK_Hangul_End, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Hanja", GDK_Hangul_Hanja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Jamo", GDK_Hangul_Jamo, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Romaja", GDK_Hangul_Romaja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Codeinput", GDK_Hangul_Codeinput, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Jeonja", GDK_Hangul_Jeonja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Banja", GDK_Hangul_Banja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_PreHanja", GDK_Hangul_PreHanja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_PostHanja", GDK_Hangul_PostHanja, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SingleCandidate", GDK_Hangul_SingleCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_MultipleCandidate", GDK_Hangul_MultipleCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_PreviousCandidate", GDK_Hangul_PreviousCandidate, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Special", GDK_Hangul_Special, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_switch", GDK_Hangul_switch, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Kiyeog", GDK_Hangul_Kiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SsangKiyeog", GDK_Hangul_SsangKiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_KiyeogSios", GDK_Hangul_KiyeogSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Nieun", GDK_Hangul_Nieun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_NieunJieuj", GDK_Hangul_NieunJieuj, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_NieunHieuh", GDK_Hangul_NieunHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Dikeud", GDK_Hangul_Dikeud, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SsangDikeud", GDK_Hangul_SsangDikeud, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Rieul", GDK_Hangul_Rieul, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulKiyeog", GDK_Hangul_RieulKiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulMieum", GDK_Hangul_RieulMieum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulPieub", GDK_Hangul_RieulPieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulSios", GDK_Hangul_RieulSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulTieut", GDK_Hangul_RieulTieut, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulPhieuf", GDK_Hangul_RieulPhieuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulHieuh", GDK_Hangul_RieulHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Mieum", GDK_Hangul_Mieum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Pieub", GDK_Hangul_Pieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SsangPieub", GDK_Hangul_SsangPieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_PieubSios", GDK_Hangul_PieubSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Sios", GDK_Hangul_Sios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SsangSios", GDK_Hangul_SsangSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Ieung", GDK_Hangul_Ieung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Jieuj", GDK_Hangul_Jieuj, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SsangJieuj", GDK_Hangul_SsangJieuj, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Cieuc", GDK_Hangul_Cieuc, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Khieuq", GDK_Hangul_Khieuq, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Tieut", GDK_Hangul_Tieut, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Phieuf", GDK_Hangul_Phieuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_Hieuh", GDK_Hangul_Hieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_A", GDK_Hangul_A, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_AE", GDK_Hangul_AE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YA", GDK_Hangul_YA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YAE", GDK_Hangul_YAE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_EO", GDK_Hangul_EO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_E", GDK_Hangul_E, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YEO", GDK_Hangul_YEO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YE", GDK_Hangul_YE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_O", GDK_Hangul_O, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_WA", GDK_Hangul_WA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_WAE", GDK_Hangul_WAE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_OE", GDK_Hangul_OE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YO", GDK_Hangul_YO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_U", GDK_Hangul_U, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_WEO", GDK_Hangul_WEO, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_WE", GDK_Hangul_WE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_WI", GDK_Hangul_WI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YU", GDK_Hangul_YU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_EU", GDK_Hangul_EU, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YI", GDK_Hangul_YI, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_I", GDK_Hangul_I, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Kiyeog", GDK_Hangul_J_Kiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_SsangKiyeog", GDK_Hangul_J_SsangKiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_KiyeogSios", GDK_Hangul_J_KiyeogSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Nieun", GDK_Hangul_J_Nieun, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_NieunJieuj", GDK_Hangul_J_NieunJieuj, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_NieunHieuh", GDK_Hangul_J_NieunHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Dikeud", GDK_Hangul_J_Dikeud, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Rieul", GDK_Hangul_J_Rieul, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulKiyeog", GDK_Hangul_J_RieulKiyeog, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulMieum", GDK_Hangul_J_RieulMieum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulPieub", GDK_Hangul_J_RieulPieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulSios", GDK_Hangul_J_RieulSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulTieut", GDK_Hangul_J_RieulTieut, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulPhieuf", GDK_Hangul_J_RieulPhieuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_RieulHieuh", GDK_Hangul_J_RieulHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Mieum", GDK_Hangul_J_Mieum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Pieub", GDK_Hangul_J_Pieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_PieubSios", GDK_Hangul_J_PieubSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Sios", GDK_Hangul_J_Sios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_SsangSios", GDK_Hangul_J_SsangSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Ieung", GDK_Hangul_J_Ieung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Jieuj", GDK_Hangul_J_Jieuj, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Cieuc", GDK_Hangul_J_Cieuc, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Khieuq", GDK_Hangul_J_Khieuq, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Tieut", GDK_Hangul_J_Tieut, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Phieuf", GDK_Hangul_J_Phieuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_Hieuh", GDK_Hangul_J_Hieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_RieulYeorinHieuh", GDK_Hangul_RieulYeorinHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SunkyeongeumMieum", GDK_Hangul_SunkyeongeumMieum, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SunkyeongeumPieub", GDK_Hangul_SunkyeongeumPieub, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_PanSios", GDK_Hangul_PanSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_KkogjiDalrinIeung", GDK_Hangul_KkogjiDalrinIeung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_SunkyeongeumPhieuf", GDK_Hangul_SunkyeongeumPhieuf, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_YeorinHieuh", GDK_Hangul_YeorinHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_AraeA", GDK_Hangul_AraeA, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_AraeAE", GDK_Hangul_AraeAE, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_PanSios", GDK_Hangul_J_PanSios, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_KkogjiDalrinIeung", GDK_Hangul_J_KkogjiDalrinIeung, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Hangul_J_YeorinHieuh", GDK_Hangul_J_YeorinHieuh, CONST_CS | CONST_PERSISTENT);
	REGISTER_LONG_CONSTANT("GDK_KEY_Korean_Won", GDK_Korean_Won, CONST_CS | CONST_PERSISTENT);
}

#endif	/* HAVE_PHP_GTK */
