<?php

/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class AddressBookEntry {
		var $uid;
		var $fn;
		var $mi;
		var $ln;
		var $mail_addr;
		var $ph;

		function AddressBookEntry ($uid,$fn,$ln, $mi,$mail_addr, $ph) {
			$this->uid=$uid;
			$this->fn=$fn;
			$this->mi=$mi;
			$this->ln=$ln;
			$this->mail_addr=$mail_addr;
			$this->ph=$ph;
		}

		function get_first_name() {
			return $this->fn;
		}

		function get_middle_initial() {
			return $this->mi;
		}

		function get_last_name() {
			return $this->ln;
		}
	
		function get_mail() {
			return $this->mail_addr;
		}

		function get_phone() {
			return $this->ph;
		}

		function get_uid() {
			return $this->uid;
		}

		function save_new($adb) {
			switch ($adb->type) {
				// We should never get here with a value of ldap, but just incase.
				case ldap:
					$ed = &new error_dialog("Addition of entried to LDAP \ndirectories is not yet supported");
					$ed->show_all();
				break;
				
				case db:
					$query = "INSERT INTO $adb->name (fname,mname,lname,phone,email,insdate) VALUES ('$this->fn','$this->mi','$this->ln','$this->ph','$this->mail_addr',NOW())";
					$success = mysql_db_query($adb->db,"$query",$adb->conn);
					
					if (!$success)
						return mysql_error();
					else
						return $success;
				break;
				
				case tfile:
					case tfile:
					$file_name=$adb->get_location();
						
					// Check the file exists before opening it
					if (file_exists($file_name) == FALSE) {
						echo "File doesn't exist. Bailing out\n";
						return;
					}
					$fp = fopen ("$file_name","a-");
					$write_string="uid=$this->uid\nfn=$this->fn\nln=$this->ln\nmi=$this->mi\nmail=$this->mail_addr\nph=$this->ph\n\n";
					$success=fputs($fp,$write_string);
					fclose ($fp);
						
					return $success;
				break;
			}
		}
 /* ##################################################################################################################
	 Function to delete this object from the relevant contact list (Yes, I'm deleting myself!)
      #################################################################################################################*/
		function delete_entry ($adb) {
			switch ($adb->type) {
				case ldap:
					return;
				break;
				
				case db:
					$query = "DELETE FROM $adb->name WHERE indx=$this->uid";
					$success = mysql_db_query($adb->db,"$query",$adb->conn);
					if (!$success)
						return mysql_error();
					else
						return $success;					
				break;
				
				case tfile:
					$filename=$adb->location;
					if (file_exists($filename) == FALSE) {
						echo "File doesn't exist. Bailing out\n";
						return;
					}
					$file_copy = $filename.".bak";
					$copy_success = copy ($filename,$file_copy);
					if ($copy_success != TRUE) {
						echo "Couldn't make file copy \n";
						return;
					}
					$fp_old = fopen ($file_copy,"r");
					$fp_new = fopen ($filename,"w");
		
					while (!feof ($fp_old)) {
						$buffer = fgets($fp_old,4096);
						list ($var, $value) = split("=",$buffer);
						if (trim($value) == trim($this->uid)) {
							// We've found the entry so we need to just read until we find a '\n' by itself
							while ($buffer[0] != "\n") 
								$buffer = fgets($fp_old,4096);
						}	
						else
							fwrite ($fp_new,$buffer);
					}
		
					fclose($fp_old);
					fclose($fp_new);
					
					return 1;
			
				break;
			}
		return;
		}
	}
?>
