<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	Class AddAddressBookDialog extends GtkDialog {
		var $add_type;
		var $success;
		var $add_button;
		
		var $name_entry;
		var $loc_entry;
		var $user_entry;
		var $passwd_entry;
		var $db_entry;
		
		var $text_button;
		var $db_button;
		var $ldap_button;
		
		function AddAddressBookDialog($function,$adb_list) {
			$this->GtkDialog();
			
			$this->add_type="tfile";
			$this->success=FALSE;
			$this->realize();
			
			$name_label = &new GtkLabel("Name:");
			$loc_label = &new GtkLabel("Location:");
			$user_label = &new GtkLabel ("Username:");
			$user_label->set_sensitive(FALSE);
			$passwd_label = &new GtkLabel ("Password:");
			$passwd_label->set_sensitive(FALSE);
			$db_label = &new GtkLabel("Database:");
			$db_label->set_sensitive(FALSE);
			
			$name_entry = &new GtkEntry();
			$this->name_entry=$name_entry;
			$loc_entry = &new GtkEntry();
			$this->loc_entry=$loc_entry;
			$user_entry = &new GtkEntry();
			$this->user_entry=$user_entry;
			$user_entry->set_sensitive(FALSE);
			$passwd_entry = &new GtkEntry();
			$passwd_entry->set_sensitive(FALSE);
			$this->passwd_entry=$passwd_entry;
			$db_entry = &new GtkEntry();
			$db_entry->set_sensitive(FALSE);
			$this->db_entry=$db_entry;

			if ($function == "Add")  {
				$this->set_title("Add An Address Book");
				$add_button = &new PictureButton("Add Book","images/stock_add.xpm",$this,HORZ,"Add The New Contact List");
				$add_button->connect('clicked',array(&$this,add_adb_entry),$name_entry,$loc_entry,$passwd_entry,$user_entry,$db_entry);
			}
			elseif ($function == "Change") {
				$this->set_title("Address Book Properties");
				$add_button = &new PictureButton("Apply","images/stock_button_apply.xpm",$this,HORZ,"Apply The Current Changes");
				$add_button->connect('clicked',array(&$this,change_adb_entry),$name_entry,$loc_entry,$passwd_entry,$user_entry,$db_entry,&$adb_list);
			}
			
			$this->set_border_width(5);
			
			$label = &new GtkLabel("Address Book Type: ");
			
			$text_button = &new GtkRadioButton(NULL,"Text File");
			$ldap_button = &new GtkRadioButton($text_button,"LDAP");
			$db_button = &new GtkRadioButton($text_button,"DB");
			
			$this->add_button = $add_button;
			$close_button = &new PictureButton("Close","images/stock_close.xpm",$this,HORZ,"Close This Window Without Saving Changes");
			$help_button = &new PictureButton ("Help","images/stock_help.xpm",$this,HORZ,"Get Help");
			$close_button->connect('clicked',array($this, close_dialog));

			$top_box = $this->vbox;
			$bottom_box = $this->action_area;
			
			$button_box = &new GtkHBox();
			$button_box->pack_start($label);
			$button_box->pack_start($text_button);
			$button_box->pack_start($ldap_button);
			$button_box->pack_start($db_button);
			
			$browse_button = &new GtkButton("Browse");
			$browse_button->connect('clicked',array($this,show_file_dialog),$loc_entry);
			
			$text_button->connect('toggled',array(&$this,set_widgets_sensitive),$passwd_label,$user_label,$passwd_entry,$user_entry,$db_label,$db_entry,$browse_button);
			$this->text_button=$text_button;
			$ldap_button->connect('toggled',array(&$this,set_widgets_sensitive),$passwd_label,$user_label,$passwd_entry,$user_entry,$db_label,$db_entry,$browse_button);
			$this->ldap_button=$ldap_button;
			$db_button->connect('toggled',array(&$this,set_widgets_sensitive),$passwd_label,$user_label,$passwd_entry,$user_entry,$db_label,$db_entry,$browse_button);
			$this->db_button=$db_button;
			
			$field_table = &new GtkTable(5,2,FALSE);
			$field_table->set_row_spacings(8);
			$field_table->set_col_spacings(5);
			
			$field_table->attach($name_label,1,2,1,2);
			$field_table->attach($name_entry,2,3,1,2);	
			
			$field_table->attach($loc_label,1,2,2,3);
			$field_table->attach($loc_entry,2,3,2,3);
			$field_table->attach($browse_button,3,4,2,3);
			
			$field_table->attach($user_label,1,2,3,4);
			$field_table->attach($user_entry,2,3,3,4);
			
			$field_table->attach($passwd_label,1,2,4,5);
			$field_table->attach($passwd_entry,2,3,4,5); 
			
			$field_table->attach($db_label,1,2,5,6);
			$field_table->attach($db_entry,2,3,5,6);
			
			$top_box->pack_start($button_box);
			$top_box->pack_start($field_table);
						
			$bottom_box->pack_start($add_button);
			$bottom_box->pack_start($close_button);
			$bottom_box->pack_end($help_button);

		}
		// End Constructor
/* ###################################################################################################################
	show the file dialog
################################################################################################################### */ 
	function show_file_dialog ($widget, $loc_entry) {
		$fd = &new GtkFileSelection("Choose Address Book File Name");
		$fd_ok = $fd->ok_button;
		$fd_ok->connect('clicked',array($this,fd_ok_pressed),$fd,&$loc_entry);
		$fd_cancel = $fd->cancel_button;
		$fd_cancel->connect('clicked',array($this, destroy_fd),$fd);
		$fd->show();
	
	}
	
	function fd_ok_pressed ($widget, $fd, $loc_entry) {
		$loc_entry->set_text($fd->get_filename());
		$fd->destroy();
	}
		
	function destroy_fd ($widget, $fd) {
		$fd->destroy();
	}
/* ###################################################################################################################
	Load the current values of a contact list into the text boxes
################################################################################################################### */ 
	function load_current_values ($address_book) {
	
		switch ($address_book->type) {
			case tfile:
				$button=$this->text_button;
				$db_btn=$this->db_button;
				$db_btn->set_sensitive(FALSE);
				$ldap_btn=$this->ldap_button;
				$ldap_btn->set_sensitive(FALSE);
			break;
			
			case db:
				$button=$this->db_button;
				$txt_btn=$this->text_button;
				$txt_btn->set_sensitive(FALSE);
				$ldap_btn=$this->ldap_button;
				$ldap_btn->set_sensitive(FALSE);
			break;
			
			case ldap:
				$button=$this->ldap_button;
				$db_btn=$this->db_button;
				$db_btn->set_sensitive(FALSE);
				$txt_btn=$this->text_button;
				$txt_btn->set_sensitive(FALSE);
			break;
		}
		$button->set_active(TRUE);
	
		$name_entry=$this->name_entry;
		$name_entry->set_text($address_book->name);
		
		$loc_entry=$this->loc_entry;
		$loc_entry->set_text($address_book->location);
		
		if ($address_book->username != "null") {
			$user_entry=$this->user_entry;
			$user_entry->set_text($address_book->username);
		}
		
		if ($address_book->password != "null") {
			$passwd_entry=$this->passwd_entry;
			$passwd_entry->set_text($address_book->password);
		}
		
		if ($address_book->db != "null") {
			$db_entry=$this->db_entry;
			$db_entry->set_text($address_book->db);
		}
	}	
/* ###################################################################################################################
	change  an AdbConfigEntry object and save it
################################################################################################################### */ 
	function change_adb_entry ($widget, $name_entry, $loc_entry, $passwd_entry, $user_entry, $db_entry,$adb_list) {
		global $config;
		
		$selection=$adb_list->selection[0];
		$uid = $adb_list->get_text($selection,1);
		
		$user = $user_entry->get_chars(0,-1);
		if ($user == NULL)
			$user="null";
		$passwd = $passwd_entry->get_chars(0,-1);
		if ($passwd == NULL)
			$passwd="null";
		$db_name = $db_entry->get_chars(0,-1);
		if ($db_name === NULL)
			$db_name="null";
			
		$adb_change_object = &new AddressBookConfig($uid,$this->add_type,$name_entry->get_chars(0,-1),$loc_entry->get_chars(0,-1),$user,$passwd,$db);
		$success=$adb_change_object->change_address_book($config[preferences][address_book_config]);	
		
		if ($success != TRUE) {
			$ed = &new error_dialog("$success");
			$ed->show_all();
		}
		else
			$this->clear_entry_fields($name_entry,$loc_entry,$user_entry,$passwd_entry,$db_entry);
		
		
	}
/* ###################################################################################################################
	create an AdbConfigEntry object and save it
################################################################################################################### */ 
	function  add_adb_entry($widget, $name_entry, $loc_entry, $passwd_entry, $user_entry, $db_entry) { 
		global $config;
		
		$name = $name_entry->get_chars(0,-1);
		$loc = $loc_entry->get_chars(0,-1);
		
		if (($name == NULL) || ($loc == NULL)) {
			$ed = &new error_dialog("You need to enter at least\n a name and a location.");
			$ed->show();
			return;
		}
		
		$user = $user_entry->get_chars(0,-1);
		if (($user == NULL) && ($this->add_type == db)) {
			$ed = &new error_dialog("Database entries require a username!.");
			$ed->show();
			return;
		}
		elseif ($user == NULL)
			$user="null";
		
		$passwd = $passwd_entry->get_chars(0,-1);
		if ($passwd == NULL)
			$passwd="null";
		$db_name = $db_entry->get_chars(0,-1);
		if ($db_name === NULL)
			$db_name="null";
			
		$uid = date(YmdGis);
		
		$new_entry = &new AddressBookConfig($uid,$this->add_type, $name, $loc, $user, $passwd, $db_name);
			
		$return=$new_entry->save_new($config[preferences][address_book_config]);
		
		if ($return !== TRUE) {
			$ed = &new error_dialog($return);
			$ed->show();
		}
		else
			$this->success=TRUE;
	}
	
/* ###################################################################################################################
	Clear out the user entry fields
################################################################################################################### */ 	
	function clear_entry_fields ($name,$loc,$user,$passwd,$db) {
		$name->set_text("");
		$loc->set_text("");
		$user->set_text("");
		$passwd->set_text("");
		$db->set_text("");
	}
		
/* ###################################################################################################################
	handle whether or not the username and password widgets are sensitive or not and set the entry type
################################################################################################################### */ 
	function set_widgets_sensitive ($widget, $p_label, $u_label, $p_entry, $u_entry, $db_label, $db_entry, $b_button ) { 
		$button_label=$widget->child;
		
		switch ($button_label->get()) {
			case "Text File":
				$p_label->set_sensitive(FALSE);
				$u_label->set_sensitive(FALSE);
				$p_entry->set_sensitive(FALSE);
				$u_entry->set_sensitive(FALSE);
				$db_label->set_sensitive(FALSE);
				$db_entry->set_sensitive(FALSE);
				$b_button->set_sensitive(TRUE);
				$this->add_type="tfile";
				break;
			case LDAP:
				$p_label->set_sensitive(TRUE);
				$u_label->set_sensitive(TRUE);
				$p_entry->set_sensitive(TRUE);
				$u_entry->set_sensitive(TRUE);
				$db_label->set_sensitive(FALSE);
				$db_entry->set_sensitive(FALSE);
				$b_button->set_sensitive(FALSE);
				$this->add_type="ldap";
				break;
			case DB:
				$p_label->set_sensitive(TRUE);
				$u_label->set_sensitive(TRUE);
				$p_entry->set_sensitive(TRUE);
				$u_entry->set_sensitive(TRUE);
				$db_label->set_sensitive(TRUE);
				$db_entry->set_sensitive(TRUE);
				$b_button->set_sensitive(FALSE);
				$this->add_type="db";
				break;
			}
	}
		
	/* ###################################################################################################################
		close the dialog
	################################################################################################################### */ 
	function  close_dialog( ) { 
		$this->destroy();		
	}
	
	/* ###################################################################################################################
		
	################################################################################################################### */ 
	function  get_add_button ( ) { 
		return $this->add_button;		
	}
	
	function get_success() {
		return $this->success;
	}
}

