<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	Class AddAddressBookEntryDialog extends GtkDialog {
		var $address_book;
		var $fname_entry;
		var $mi_entry;
		var $lname_entry;
		var $email_entry;
		var $phone_entry;
		var $entry_uid;
		var $add_button;
		
		function AddAddressBookEntryDialog($function,$address_book) {
		
			$this->GtkDialog();
			
			$this->address_book=$address_book;
			
			$this->realize();
			
			if ($function == "Add")  {
				$this->set_title("Add A New Contact");
				$add_button = &new PictureButton("Add","images/stock_add.xpm",$this,HORZ,"Add The New Contact");
				$add_button->set_name("Add");
			}
			elseif ($function == "Change") {
				$this->set_title("Contact Properties");
				$add_button = &new PictureButton("Apply","images/stock_button_apply.xpm",$this,HORZ,"Apply The Current Changes");
				$add_button->set_name("Change");
			}
			$this->add_button=$add_button;
			
			$this->set_border_width(5);
			
			$this->add_button = $add_button;
			
			$close_button = &new PictureButton("Cancel","images/stock_button_cancel.xpm",$this,HORZ,"Close The Window");
			$help_button = &new PictureButton("Help","images/stock_help.xpm",$this,HORZ,"Get Help");
			$close_button->connect('clicked',array($this, close_dialog));

			$top_box = $this->vbox;
			$bottom_box = $this->action_area;
			
			$button_box = &new GtkHBox();
						
			$fname_label = &new GtkLabel("First Name:");
			$mi_label = &new GtkLabel("Middle Name:");
			$lname_label = &new GtkLabel ("Last Name");
			$email_label = &new GtkLabel ("Email Address:");
			$phone_label = &new GtkLabel("Phone Number:");
	
			
			$fname_entry = &new GtkEntry();
			$this->fname_entry=$fname_entry;
			$mi_entry = &new GtkEntry();
			$this->mi_entry=$mi_entry;
			$lname_entry = &new GtkEntry();
			$this->lname_entry=$lname_entry;
			$email_entry = &new GtkEntry();
			$this->email_entry=$email_entry;
			$phone_entry = &new GtkEntry();
			$this->phone_entry=$phone_entry;
					
			
			$field_table = &new GtkTable(5,2,FALSE);
			$field_table->set_row_spacings(8);
			$field_table->set_col_spacings(5);
			
			$field_table->attach($fname_label,1,2,1,2);
			$field_table->attach($fname_entry,2,3,1,2);	
			
			$field_table->attach($mi_label,1,2,2,3);
			$field_table->attach($mi_entry,2,3,2,3);
			
			
			$field_table->attach($lname_label,1,2,3,4);
			$field_table->attach($lname_entry,2,3,3,4);
			
			$field_table->attach($email_label,1,2,4,5);
			$field_table->attach($email_entry,2,3,4,5); 
			
			$field_table->attach($phone_label,1,2,5,6);
			$field_table->attach($phone_entry,2,3,5,6);
			
			$top_box->pack_start($button_box);
			$top_box->pack_start($field_table);
						
			$bottom_box->pack_start($add_button);
			$bottom_box->pack_start($close_button);
			$bottom_box->pack_end($help_button);
			
			$add_button->connect('clicked',array(&$this,add_contact),$fname_entry,$mi_entry,$lname_entry,$email_entry,$phone_entry);

		}
		// End Constructor
	
	/* ###################################################################################################################
		create an AdbConfigEntry object and save it
	################################################################################################################### */ 
	function  load_current_values ($entry_uid) {
		$address_book = $this->address_book;
		$this->entry_uid = $entry_uid;
		
		$fname_entry = $this->fname_entry;
		$mi_entry = $this->mi_entry;
		$lname_entry = $this->lname_entry;
		$email_entry = $this->email_entry;
		$phone_entry =  $this->phone_entry;
		
		switch ($address_book->type) {
			case ldap:
				return;
			break;
			
			case db:
				$query = "SELECT * FROM $address_book->name WHERE indx=$entry_uid";
				$res = mysql_db_query($address_book->db,"$query",$address_book->conn);
				$res_obj = mysql_fetch_object($res);
				$fname_entry->set_text($res_obj->fname);
				$mi_entry->set_text($res_obj->mname);
				$lname_entry->set_text($res_obj->lname);
				$email_entry->set_text($res_obj->email);
				$phone_entry->set_text($res_obj->phone);
			
			break;
			
			case tfile:
				$filename=$address_book->location;
				
				// If the file doesn't exist, in which case all hell has pobably broken loose, just leave now
				if (!file_exists($filename)) {
					echo "File doesn't exist. Bailing out\n";
					return;
				}
				
				// Open the file, find the uid, load it's info into the text boxes
				$fp = fopen ($filename,"r");
				while (!feof ($fp)) { 
					$buffer = fgets($fp, 1000);
					list ($var, $value) = split("=",$buffer);
					if (trim($value) == trim($entry_uid)) {
						while ((($buffer2=fgets($fp,1000)) != "\n") && !feof($fp)) {
								    list ($var, $value) = split("=",$buffer2);
								    $$var=trim($value);
						}
					}
					//else
							// FIXME Jump  ahead x lines ??
				}			
				$fname_entry->set_text($fn);
				$mi_entry->set_text($mi);
				$lname_entry->set_text($ln);
				$email_entry->set_text($mail);
				$phone_entry->set_text($ph);
				
				fclose($fp);
				
			break;
		}
	}
	
	/* ###################################################################################################################
		create an AdbConfigEntry object and save it, or change an existing object
	################################################################################################################### */ 
	function  add_contact($widget, $fname, $mi, $lname, $email, $phone) { 
		
		$action = $widget->get_name();

		if ($action == "Add") {
			// We might use this, if it's a db entry then it will generate it's own, if it's a file entry we need it
			$uid = date(YmdGis);
			$new_entry = &new AddressBookEntry($uid,$fname->get_chars(0,-1), $lname->get_chars(0,-1), $mi->get_chars(0,-1),$email->get_chars(0,-1), $phone->get_chars(0,-1));
			$success=$new_entry->save_new($this->address_book);	
		}
		
		else if ($action == "Change") {
			$uid = $this->entry_uid;
			$new_entry = &new AddressBookEntry($uid,$fname->get_chars(0,-1), $lname->get_chars(0,-1), $mi->get_chars(0,-1),$email->get_chars(0,-1), $phone->get_chars(0,-1));
			$success=$new_entry->delete_entry($this->address_book);
			if ($success == 1) 
				$success=$new_entry->save_new($this->address_book);	
		}
		
		if (!$success) {
			$text = "Something went wrong in saving this entry\n".$success;
			$ed = &new error_dialog($text);
			$ed->show();
		}
	}
	
	/* ###################################################################################################################
		
	################################################################################################################### */ 
	function set_text_field_values ($fname, $mi, $lname, $phone, $email) {
		$fname_entry=$this->fname_entry;
		$fname_entry->set_text($fname);
		$mi_entry=$this->mi_entry;
		$mi_entry->set_text($mi);
		$lname_entry=$this->lname_entry;
		$lname_entry->set_text($lname);
		$phone_entry=$this->phone_entry;
		$phone_entry->set_text($phone);
		$email_entry=$this->email_entry;
		$email_entry->set_text($email);
	}	
		
	/* ###################################################################################################################
		close the dialog
	################################################################################################################### */ 
	function  close_dialog( ) { 
		$this->destroy();		
	}
	
	function get_add_button () {
		return $this->add_button;
	}

}

