#!/usr/local/bin/php -q
<?php
/*

	Copyright (C) 2001,2002 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	/* First lets take care of anything we were passed on the command line */

if ($HTTP_SERVER_VARS[argc] > 1) {
	echo "We've been passed something....\n";
	$argv_array=$HTTP_SERVER_VARS[argv];
	for ($i=0;$i<$HTTP_SERVER_VARS[argc];$i++) 
		echo $argv_array[$i]."\n";
}
		

	if (!class_exists('gtk')) {
		if (strtoupper(substr(PHP_OS, 0, 3)) == 'WIN') {
			dl('php_gtk.dll');
			$OS=WIN;
		}
		else {
			dl('php_gtk.so');
			$OS=UNIX;
		}
	}

	
	include ('error_dialog.php');
	include ('password_dialog.php');
	
	include ('AddressBook/TeakAddressBookClass.php');
	include ('AddressBook/AdbConfigClass.php');
	include ('AddressBook/AdbEntryClass.php');
	include ('AddressBook/TeakAddressClist.php');
	include ('AddressBook/AddAddressBookDialog.php');
	include ('AddressBook/AddAddressBookEntryDialog.php');
	include ('compose_class.php');

	include ('widgets/PictureButton.php');
	include ('widgets/HeaderBlock.php');

	include ('lib/mime.php');

/*
 * Called when delete-event happens. Returns false to indicate that the event
 * should proceed.
 */
function delete_event()
{
	return false;
}

/*
 * Called when the window is being destroyed. Simply quit the main loop.
 */
function destroy()
{
	Gtk::main_quit();
}



/*
 * Create a new top-level window and connect the signals to the appropriate
 * functions. Note that all constructors must be assigned by reference.
 */

//Setup a few constants, this is where teak itself is installed.
define ("TEAKDIR",dirname(__FILE__)."/");
define ("TEAKETCDIR",TEAKDIR."etc/");
	
// FIXME Does this work in windows ??
$user = getenv(USER);

if ($OS == "WIN")
	$user_config_path = "c:\users\\".$user."\\.teak\\";
else
	$user_config_path = "/home/".$user."/.teak/";
		
		
// New user config code
$config = load_config_file($user_config_path);
$config[preferences][mime_file] = $user_config_path."mime.types";
$config[preferences][address_book_config] = $user_config_path."adb.config";
$config[preferences][temp_dir] = $user_config_path."temp/";

$servers = load_servers($user_config_path);
	
$adb_window = &new TeakAddressBook(NULL);
$adb_window->connect('destroy','destroy');
$adb_exit_button = $adb_window->get_exit_button();
$adb_exit_button->connect('clicked','destroy');
$adb_window->show_all();

/* Run the main loop. */
Gtk::main();

/* ####################################################################################################################
	Load the configuration file(s) for us, if they don't exist, setup the defaults and reload
####################################################################################################################*/
function load_config_file($user_config_path) {
	global $OS;
	
	$config_file = $user_config_path."config.ini";
	
	// If the user's config file doesn't exist, then we copy in the defaults and call this again to load the default config
	if (!file_exists($config_file)) {
		echo "Sorry, Teak has not yet been configured\n";
		echo "Please run teak itself in order for the configuration files to get setup";
	}
	else {
		$config = parse_ini_file("$config_file",TRUE);
		return $config;
	}
}

/* ####################################################################################################################
	Load the list of servers
####################################################################################################################*/
function load_servers($user_config_path) {
		$servers_file = $user_config_path."servers.ini";
		$servers = parse_ini_file($servers_file,TRUE);
		return $servers;
	}

?>
