<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class ldap_search_dialog extends GtkWindow {
		function ldap_search_dialog($text_box) {
			$this->GtkWindow();
			global $ldap_server;

			$this->set_title("Address Book Search");

			//Get the LDAP connection
			$ldap_conn=$this->get_ldap_connection($ldap_server);
			
			$label = &new GtkLabel("Name: ");
			$entry = &new GtkEntry();
			$search_button = &new GtkButton("Search");
			
			$list_scroller = &new GtkScrolledWindow();
			$list_scroller->set_usize(300,100);
			$titles = array ("Name","Email");
			$result_list = &new GtkCList(2,$titles);
			$result_list->set_column_width(0,150);
			$result_list->set_selection_mode(GTK_SELECTION_SINGLE);
			$list_scroller->add_with_viewport($result_list);
			$search_button->connect('clicked',array($this, search),$entry,$ldap_conn,$result_list);

			$master_box=&new GtkTable(3,1,FALSE);
			$master_box->set_row_spacings(8);
			$master_box->set_col_spacings(8);

			$top_box=&new GtkTable(3,1,FALSE);
			$top_box->set_row_spacings(8);
			$top_box->set_col_spacings(8);
			$top_box->attach($label,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$top_box->attach($entry,2,3,1,2,GTK_SHRINK,GTK_SHRINK);
			$top_box->attach($search_button,3,4,1,2,GTK_SHRINK,GTK_SHRINK);

			$bottom_box = &new GtkHBox();
			$add_address_button = &new GtkButton("Add Address");
			$add_address_button->connect('clicked',array($this,add_email),$text_box,$result_list);
			$close_button = &new GtkButton("Close");
			$close_button->connect('clicked',array($this,close_button_pressed),$ldap_conn);

			$bottom_box->pack_start($add_address_button,false,false,10);
			$bottom_box->pack_start($close_button,false,false,100);
	
			$master_box->set_border_width(5);
			$master_box->attach($top_box,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$master_box->attach($list_scroller,1,2,2,3);
			$master_box->attach($bottom_box,1,2,3,4,GTK_EXPAND,GTK_SHRINK);
			$this->add($master_box);

			$this->connect('delete-event',array($this,close_conn),$ldap_conn);
			$this->show_all();

	}
	// End of constructor

/* ##########################################################################################
	Add the email address to the appropriate text box
*/ ##########################################################################################
	function add_email($widget, $text_box, $clist) {
		$row=$clist->selection[0];
		$email_address=$clist->get_text($row,1);
	
		$current_text = $text_box->get_text();
		if ($current_text == NULL)
			$text_box->set_text($email_address);
		else 
			$text_box->set_text($current_text.";".$email_address);
	} 	

/* ##########################################################################################
	Close ye olde LDAP connection before exiting
*/ ##########################################################################################
	function close_conn($widget,$event,$conn) {
		ldap_close($conn);
	}

/* ##########################################################################################
	Time to check out....
*/ ##########################################################################################
	function close_button_pressed ($widget,$conn) {
		$this->close_conn(null,null,$conn);
		$this->destroy();
	}

/* ##########################################################################################
	Function that actually does the ldap searching for us
*/ ##########################################################################################
	function search ($widget, $text_entry, $conn, $name_list) {

		$name_list->clear();

		$search_text=$text_entry->get_text();
		$search_string="(|(sn=*$search_text*)(givenname=*$search_text*))";
		$sr=ldap_search($conn,"c=US", $search_string);  

		$info = ldap_get_entries($conn, $sr);
	
		for ($i=0; $i<$info["count"]; $i++) {
			$items=array($info[$i]["cn"][0],$info[$i]["mail"][0]);
			$name_list->append($items);
	    	}
	}
/* ##########################################################################################
	Function to get an ldap connection
*/ ##########################################################################################
	function get_ldap_connection ($server) {
		$conn=ldap_connect($server);
		$binding=ldap_bind($conn);
		return $conn;
	}


}
