<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	dl('php_gtk.so');

/* ########################################################################################
	This is a dialog to handle both the colour selections and the font selections
	for the three main widget in the mail reader (and eventually composer).
	$clist 		- list of mail messages (headers)
	$ctree 		- tree of mailbox folders
	$msg_text	- the actually text box that displays the message contents

*/ #########################################################################################
Class colour_selection extends GtkWindow {
	function colour_selection ($clist, $ctree, $msg_text) {

	//First we need to store a copy of the current styles of the three widgets
		$temp_style=$clist->get_style();
		$orig_style=$temp_style->copy();
	
		$this->GtkWindow();
		$this->set_usize(220,180);
		$this->set_title("Choose Application Colours/Fonts");

		$note_book = &new GtkNotebook();
		$note_book->set_border_width(5);

		$dialog_box = &new GtkVBox();
		$dialog_box->set_border_width(5);
		$button_box = &new GtkHBox();
		$button_box->set_border_width(5);
		$button_box->set_spacing(5);

		$ok_button = &new GtkButton("OK");
	//FIXME, needs to save the current style first!
		$ok_button->connect('clicked',array($this,destroy_dialog),$this);
		$cancel_button = &new GtkButton("Cancel");
		$apply_button = &new GtkButton("Apply");
		$cancel_button->connect('clicked',array($this,cancel_changes),$clist,$ctree,$msg_text,$orig_style);
		$cancel_button->connect('clicked',array($this,destroy_dialog),$this);
		$button_box->pack_start($ok_button);
		$button_box->pack_start($apply_button);
		$button_box->pack_start($cancel_button);

		$clist_table = &new GtkTable(4,2,FALSE);
		$clist_table->set_row_spacings(5);
		$clist_table->set_col_spacings(5);
		$clist_table->set_border_width(5);
		$bg_label = &new GtkLabel("Background Colour: ");
		$bg_button = &new GtkButton();
		$bg_button->connect('clicked',array($this,show_colour_dialog),"base",GTK_STATE_NORMAL);
		$this->set_button_style($bg_button, $clist,"base",GTK_STATE_NORMAL);
	
		$fg_label = &new GtkLabel("Foreground Colour: ");
		$fg_button = &new GtkButton();
		$fg_button->connect('clicked',array($this,show_colour_dialog),"fg",GTK_STATE_NORMAL);
		$this->set_button_style($fg_button, $clist,"fg",GTK_STATE_NORMAL);

		$hf_label = &new GtkLabel("Highlight Foreground: ");
		$hf_button = &new GtkButton();
		$hf_button->connect('clicked',array($this,show_colour_dialog),"bg",GTK_STATE_SELECTED);
		$this->set_button_style($hf_button, $clist,"bg",GTK_STATE_SELECTED);
		
		$hb_label = &new GtkLabel("Highlight Background: ");
		$hb_button = &new GtkButton();
		$hb_button->connect('clicked',array($this,show_colour_dialog),"fg",GTK_STATE_SELECTED);
		$this->set_button_style($hb_button, $clist,"fg",GTK_STATE_SELECTED);

		$clist_table->attach($bg_label,1,2,1,2);
		$clist_table->attach($bg_button,2,3,1,2);
		$clist_table->attach($fg_label,1,2,2,3);
		$clist_table->attach($fg_button,2,3,2,3);
		$clist_table->attach($hf_label,1,2,3,4);
		$clist_table->attach($hf_button,2,3,3,4);
		$clist_table->attach($hb_label,1,2,4,5);
		$clist_table->attach($hb_button,2,3,4,5);
		$clist_page_title = &new GtkLabel("Colours");

		$apply_button->connect('clicked',array($this,apply_changes),$clist,$ctree,$msg_text,$bg_button,$fg_button,$hf_button,$hb_button);

//Font pane
		$font_table = &new GtkTable(3,2,FALSE);
		$font_table->set_row_spacings(5);
		$font_table->set_col_spacings(5);
		$font_table->set_border_width(5);
		$font_table_title = &new GtkLabel("Fonts");
	
		$clist_font_label = &new GtkLabel("Message List: ");
		$ctree_font_label = &new GtkLabel("Folder List: ");
		$msg_text_font_label = &new GtkLabel("Message Text: ");

		$clist_font_button = &new GtkButton("font");
		$this->set_button_style($clist_font_button,$clist,"font",null);
		$ctree_font_button = &new GtkButton("font");
	  	$this->set_button_style($ctree_font_button,$ctree,"font",null);
		$msg_text_font_button = &new GtkButton("font");
		$this->set_button_style($msg_text_font_button,$msg_text,"font",null);


		$font_table->attach($clist_font_label,1,2,1,2);
		$font_table->attach($ctree_font_label,1,2,2,3);
		$font_table->attach($msg_text_font_label,1,2,3,4);
		$font_table->attach($clist_font_button,2,3,1,2);
		$font_table->attach($ctree_font_button,2,3,2,3);
		$font_table->attach($msg_text_font_button,2,3,3,4);
//End font pane

		$note_book->append_page($clist_table,$clist_page_title);
		$note_book->append_page($font_table,$font_table_title);
	

		$dialog_box->pack_start($note_book);
		$dialog_box->pack_start($button_box);
		$this->add($dialog_box);
		$this->show_all();
	}

/* #########################################################################################
	Apply the changes the user has selected to the main window's widget's
*/ #########################################################################################
	function apply_changes ($widget,$clist,$ctree,$msg_text,$bg,$fg,$hb,$hf) {
		$current_style=$clist->get_style();
		$new_style = $current_style->copy();
		
		$bg_style=$bg->get_style();
		$bg_color=$bg_style->bg[GTK_STATE_NORMAL];
		
		$fg_style=$fg->get_style();
		$fg_color=$fg_style->bg[GTK_STATE_NORMAL];

		$hb_style=$hb->get_style();
		$hb_color=$hb_style->bg[GTK_STATE_NORMAL];
		
		$hf_style=$hf->get_style();
		$hf_color=$hf_style->bg[GTK_STATE_NORMAL];

		$new_style->base[GTK_STATE_NORMAL]=$bg_color;
		$new_style->fg[GTK_STATE_NORMAL]=$fg_color;
		$new_style->bg[GTK_STATE_SELECTED]=$hb_color;
		$new_style->fg[GTK_STATE_SELECTED]=$hf_color;

		$clist->set_style($new_style);
		$ctree->set_style($new_style);
		$msg_text->set_style($new_style);


	}

/* #########################################################################################
	Cancel any colour changes and go back to how we started
*/ #########################################################################################
	function cancel_changes ($widget, $clist, $ctree, $msg_text, $orig_style) {
		$clist->set_style($orig_style);
		$ctree->set_style($orig_style);
		$msg_text->set_style($orig_style);
	}
	
/* #########################################################################################
	set the current button colour to fit the current widget set of colours	
*/ #########################################################################################
	function set_button_style($button,$widget,$which,$state) {
		$ts=$widget->get_style();
		$style = &new GtkStyle();
		switch ($which) {
			case base:
				$current_bg=$ts->base[$state];
				$style->bg[GTK_STATE_NORMAL]=$current_bg;
				break;
			case fg:
				$current_bg=$ts->fg[$state];
				$style->bg[GTK_STATE_NORMAL]=$current_bg;
				break;
			case bg:
				$current_bg=$ts->bg[$state];
				$style->bg[GTK_STATE_NORMAL]=$current_bg;
				break;
			case font:
				$current_bg=$ts->font;
				$style->font=$current_bg;
		}
		$button->set_style($style);	
	}

/* #########################################################################################
	set the $which properly of the $state for the given $widget
*/ #########################################################################################
	function set_widget_style ($widget,$which,$state,$colour) {

		$current_widget_style=$widget->get_style();
		$new_widget_style=$current_widget_style->copy();
		switch ($which) {
			case base:
				$new_widget_style->base[$state]=$colour;
				break;
			case fg:
			
				$new_widget_style->fg[$state]=$colour;
				break;case base:
			case bg:
				$new_widget_style->bg[$state]=$colour;
				break;
		}
		$widget->set_style($new_widget_style);	
	}	

/* #########################################################################################
	show the user the colour picker
*/ #########################################################################################
	function show_colour_dialog($widget,$which,$state) {
		$ccd = &new GtkColorSelectionDialog("Choose Colour");
		$ccd->show();
		$ccd_cancel=$ccd->cancel_button;
		$ccd_cancel->connect('clicked',array($this,destroy_dialog),$ccd);
		$ccd_ok=$ccd->ok_button;
		$ccd_ok->connect('clicked',array($this,update_color),$which,$state,$widget,$ccd);
		$ccd_ok->connect('clicked',array($this,destroy_dialog),$ccd);
	}

/* #########################################################################################
	change the colour of the button and the element of the $widget
*/ #########################################################################################
	function update_color ($widget,$which,$state,$button,$ccd) {
		$colour_changer=$ccd->colorsel;
		$new_colour=$colour_changer->get_color();
		$red=(int)round(($new_colour[0] * 65535));
		$green=(int)round(($new_colour[1] * 65535));
		$blue=(int)round(($new_colour[2] * 65535));
		$new_rgb = &new GdkColor($red,$green,$blue);

		// First set the style of the button
		$curr_style=$button->get_style();
		$new_style=$curr_style->copy();
		$new_style->bg[GTK_STATE_NORMAL]=$new_rgb;
		$button->set_style($new_style);

	} 

/* #########################################################################################
	generic 'destroy' function	
*/ #########################################################################################
	function destroy_dialog ($widget, $dialog) {
		$dialog->destroy();
	}

}

?>
