<?php
/*

	Copyright (C) 2001,2002 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class Compose_Window extends GtkWindow {
		var $send_button;
		var $cancel_button;
		var $message_parts;
		var $itemf;
		var $current_server;
		var $mimes;
		
		function Compose_Window($to_string,$cc_array,$subject,$body,$current_server,$mimes,$msg_id) {
			global $servers;
			global $config;
			
			$this->GtkWindow();

			// This is for Drag and Drop
			$targets = array(array('text/plain', 0, -1));
			
			if ($mimes == NULL) {
				$mimes = &new Mime();
				$this->mimes=$mimes;
			}
			
			$this->set_title("Teak - Compose Message");
			$this->set_usize(640,480);

			$master_box = &new GtkVBox(false,5);
			$master_box->set_border_width(5);
			$top_box = &new GtkVBox(false,5);
			$bottom_box = &new GtkVBox(false,5);
			
			$attachment_box = &new GtkHBox(false,5);
			$attachment_box->set_spacing(5);
			$attachment_box->set_border_width(5);

			$this->realize();
			
			$send_button = &new PictureButton("Send","images/envelope.xpm",$this,HORZ,"Send This Email");
	// It seems Zend can't handle $this->send_button->function(), so we have to do this
			$this->send_button=$send_button;
			
			$attach_button =  &new PictureButton("Attach","images/attachment.xpm",$this,HORZ,"Add An Attachment");
			$cancel_button = &new PictureButton("Close","images/cancel.xpm",$this,HORZ,"Close This Window Without Sending This Message");
			$cancel_button->connect('clicked',array($this,destroy_window)); 
			$this->cancel_button = $cancel_button;

			$button_table = &new GtkTable(3,1,FALSE);
			$button_table->attach($this->send_button,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$button_table->attach($attach_button,2,3,1,2,GTK_SHRINK,GTK_SHRINK);
			$button_table->attach($this->cancel_button,3,4,1,2,GTK_SHRINK,GTK_FILL);
			
			$address_box = &new GtkTable(3,2,false);
			$address_box->set_row_spacings(5);
			$address_box->set_col_spacings(5);
			
			//If we were NOT passed a valid $current_server index we choose the default (from the config file)
			//  as the sending address. FIXME - we should be able to choose!
			if (!isset($current_server)) {
				for ($i=0;$i<count($servers);$i++)
					if ($servers[$i][default_server] == TRUE) {
						$this->current_server = $i;
						break;
					}
			}
			else 
				$this->current_server = $current_server;
								
			$from_button = &new GtkButton ("From");
			$from_button->set_usize(60,25);
			$to_button = &new GtkButton ("To");
			$to_button->set_usize(60,25);
			$cc_button = &new GtkButton ("Cc");
			$cc_button->set_usize(60,25);
			$bcc_button = &new GtkButton ("Bcc");
			$bcc_button->set_usize(60,25);
			
			$from_entry = &new GtkEntry();
			$from_entry->set_text($servers[$this->current_server][return_address]);
			$from_entry->set_editable(FALSE);

			$to_entry = &new GtkEntry();
			if ($to_string != NULL)
				$to_entry->set_text($to_string);
			$to_entry->set_name("ToEntry");
			$to_entry->connect('drag_data_received',array(&$this,dnd_entry_drop_received));
			$to_entry->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
				
			$cc_entry = &new GtkEntry();
			if (count($cc_array) != 0) {
				$cc_string=$cc_array[0]->mailbox."@".$cc_array[0]->host;
				if (count($cc_array > 1)) {
					for ($i=1;$i<count($cc_array);$i++) {
						$cc_string=$cc_string.";".$cc_array[$i]->mailbox."@".$cc_array[$i]->host;
					}
				}
				$cc_entry->set_text($cc_string);
			}
			
			$cc_entry->connect('drag_data_received',array(&$this,dnd_entry_drop_received));
			$cc_entry->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
			
			$bcc_entry = &new GtkEntry();
			$bcc_entry->connect('drag_data_received',array(&$this,dnd_entry_drop_received));
			$bcc_entry->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
				
				
			//Attach the signal handlers for the to/cc/bcc buttons
			$to_button->connect('clicked',array($this,show_address_book),$to_entry);
			$cc_button->connect('clicked',array($this,show_address_book),$cc_entry);
			$bcc_button->connect('clicked',array($this,show_address_book),$bcc_entry);
			$address_box->attach($from_button,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$address_box->attach($from_entry,2,3,1,2);
			$address_box->attach($to_button,1,2,2,3,GTK_SHRINK,GTK_SHRINK);
			$address_box->attach($to_entry,2,3,2,3);
			$address_box->attach($cc_button,1,2,3,4,GTK_SHRINK,GTK_SHRINK);
			$address_box->attach($cc_entry,2,3,3,4);
			$address_box->attach($bcc_button,1,2,4,5,GTK_SHRINK,GTK_SHRINK);
			$address_box->attach($bcc_entry,2,3,4,5);

			$text_scroll = &new GtkScrolledWindow();
			$text_box = &new GtkText();
			if ($body != NULL) {
				// If the user has set a reply indent char append it to each line of the text.
				if ($config[preferences][reply_indent] != NULL) {
					$pos = strpos ($body,"\n");
					$start = 0;
					while ($pos !== FALSE) {
						$text = $config[preferences][reply_indent].substr($body,$start,($pos-$start)+1);
						$text_box->insert(null,null,null,$text);
						$start = $pos+1;
						$pos = strpos($body,"\n",$start);
					}
				}
				else
					$text_box->insert(null,null,null,$body);
			}
			$text_box->set_editable(TRUE);
			$text_scroll->add($text_box);
			
			//Setup our basic signiatures
			// If we don't have a server selected just use the sig from the default server
			if ($this->current_server == NULL) {
				for ($i=0;$i<count($servers);$i++) {
					if ($servers[$i][default_server] == TRUE) {
						$sig = $servers[$i][signature];
						break;
					}
				}
			}
			else
				$sig = $servers[$this->current_server][signature];
			
			// Load the sig file(if there is one) into the text widget, append it with a couple of new lines and --
			if ($sig !== "") {
				if ($fp = fopen($sig,"r")) {
					$contents = fread ($fp, filesize ($sig));
					$text_box->insert(null,null,null,"\n\n--\n");
					$text_box->insert(null,null,null,$contents);
				}
			}

			$subject_label = &new GtkLabel("Subject: ");
			$subject_entry = &new GtkEntry();
			if ($subject != NULL)
				$subject_entry->set_text($subject);
			$subject_box = &new GtkTable(1,2,false);
			$subject_box->attach($subject_label,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$subject_box->attach($subject_entry,2,3,1,2);
			
			$bottom_box->pack_start($subject_box,false,false,10);
			$bottom_box->pack_start($text_scroll,true,true);
			$bottom_box->pack_start($attachment_box,false,false);
			
			$master_box->pack_start($top_box,false,false);
			$master_box->pack_start($bottom_box,true,true);

			$message_parts=$this->message_parts;

			// Create the menus, we need this down here because of the parameter for callback
			$ag = &new GtkAccelGroup();
			$itemf = &new GtkItemFactory(GtkMenuBar::get_type(), '<main>', $ag);
			$this->add_accel_group($ag);
			$itemf->create_items(array(
				array('/_Message','',null,0,'<Branch>'),
				array('/_Message/Se_nd',  '<alt>N', array($this,send_mail), 1, '',array($to_entry,$cc_entry, $bcc_entry, $subject_entry,$text_box,&$message_parts,$msg_id)), 
				array('/_Message/_Save', '<alt>S',array(&$this,save_message),2, '',array($to_entry,$cc_entry, $bcc_entry, $subject_entry,$text_box,$servers[$this->current_server][drafts],&$message_parts)),
				array('/_Message/sep1','',null,3,'<Separator>'),
				array('/_Message/Exit','<alt>Q',null,4,''),
			//Text menu	
				array('/_Text','',null,5,'<Branch>'),
				array('/_Text/Cut','<alt>X',array($this,cut_text),6,'',array($text_box)),
				array('/_Text/_Copy','<alt>C',array($this,copy_text),7,'',array($text_box)),
				array('/_Text/_Paste','<alt>P',array($this,paste_text),8,'',array($text_box)),
				array('/_Text/sep2','',null,9,'<Separator>'),
				array('/_Text/Select A_ll','<alt>L',array($this,select_all_text),7,'',array($text_box))
			));
			//Set the class variable to be the local
			$this->itemf=$itemf;	

			$button_menu_box = &new GtkVBox();
			$button_menu_box->pack_start($itemf->get_widget('<main>'),false,false,5);
			$button_menu_box->pack_start($button_table,false,false);

			$top_box->pack_start($button_menu_box,false,false);
			$top_box->pack_start($address_box);


			//Setup the event handlers
			$send_button->connect('clicked',array($this,send_mail),null,$to_entry,$cc_entry, $bcc_entry, $subject_entry,$text_box,&$message_parts,$msg_id);
			$attach_button->connect('clicked',array($this,get_file_name),&$message_parts,&$attachment_box);
			$this->add($master_box);
			$this->show_all();
			$to_entry->grab_focus();
		}
		// End constructor
/* #################################################################################
	Function to append an email address to the text field on the compose window
*/ #################################################################################
	function dnd_entry_drop_received ($widget, $context, $x, $y, $data, $info, $time) {
		// This means we've had an address dropped on us
		if ($data->data == "AddressList") {
			// This gets us the source of the DND operation
			$source_widget=Gtk::drag_get_source_widget($context);
			
			$row=$source_widget->selection[0];
			$address=$source_widget->get_text($row,1);
			$current_text = $widget->get_chars(0,-1);
			if ($current_text == NULL)
				$widget->set_text($address);
			else {
				$new_text = $current_text.",".$address;
				$widget->set_text($new_text);
			}
		}
	}
/* #################################################################################
	Function close out this window
*/ #################################################################################
	function destroy_window($widget) {
		$this->destroy();
	}



/* #################################################################################
	Function to check the spelling in $text
*/ #################################################################################
	function check_spelling ($text_box) {

		return TRUE;

		/* More important things to do for now than this......
		$text=$text_box->get_chars(0,-1);
		//FIXME, the language should really not be hard coded!

		$pspell_link = pspell_new("en","american","lrg","ISO8859-1",PSPELL_NORMAL);
		if ($pspell_link == NULL) {
			echo "Unable to make a connection to the spell checker\n";
			return;
		}

		if (!pspell_check ($pspell_link, $text)) {
                                $suggestions = pspell_suggest ($pspell_link, $text);

                                for ($i=0; $i < count ($suggestions); $i++) 
                                    echo "Possible spelling: " . $suggestions[$i] . "\n"; 
                }
		*/

	}

/* #################################################################################
	save the message to $folder
	We need an imap connection here to save the message
*/ #################################################################################
	function save_message($widget, $id, $to, $cc, $bcc, $subj, $text,$folder,$parts) {
		
		$env["to"]=$to->get_text();
		$env["from"]=$return_address;
		$env["cc"]=$cc->get_text();
		$env["bcc"]=$bcc->get_text();
		$env["subject"]=$subj->get_text();

		$num_parts=(count($parts)+1);
		$msg_text["type"]=TYPETEXT;
                $msg_text["subtype"]="plain";
                $msg_text["contents.data"]=$text->get_chars(0,-1);
		
		/* If we only have one element in the array then the user hasn't attached
			any files, so we're not generating a multi-part message */
		if ($num_parts == 1 ) 
			$body[0]=$msg_text;
		else {
			$header["type"]=TYPEMULTIPART;
		        $header["subtype"]="mixed";
			$body[0]=$header;
			$body[1]=$msg_text;
			for ($i=2;$i<($num_parts+1);$i++) {
				$part_count=($i - 1);
				$body[$i]=$parts[$part_count];
			}
				}	
		
		$message=imap_mail_compose($env,$body);
		
		$success=$this->save_message_to_folder($message, $folder,"\\Draft");
		
		if ($success == TRUE) {
			$this->destroy_window(null);
		}
		else { 
			$message = "Something went wrong saving this message.\n Please make sure the folder $folder exists.";
			$ed = &new error_dialog($message);
			$ed->show_all();
		}
	}
/* #################################################################################
	Used for saving the given message to the given folder
*/ #################################################################################
	function save_message_to_folder ($message,$folder,$flags) {
		global $servers;
		
		if ($servers[$this->current_server][conn] == NULL) {
			$this->show_passwd_dialog();
		}

		// Construct the right mbox for the  folder
		if ($folder != NULL)
			$folder_mbox = "{".$servers[$this->current_server][host].":".$servers[$this->current_server][port]."}".$folder;
		else 
			return;
		
		$success=imap_append($servers[$this->current_server][conn],$folder_mbox,$message,$flags);
		
		// FIXME, need to update the message count in any folder we might have changed
		//if ($success)
			// Update folder count info
			
		return $success;
		
	
	}
/* #################################################################################
	Create a password dialog for the user to put in their password
*/ #################################################################################
	function show_passwd_dialog() {
		global $config;
		global $servers;

		$pwd_dialog = &new password_dialog($servers[$this->current_server]);
		$pwd_ok_button = $pwd_dialog->get_ok_button();
		$pwd_cancel_button = $pwd_dialog->get_cancel_button();
		$pwd_ok_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);
		$pwd_cancel_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);

		//"Start" the dialog's main, it will exit when the user presses OK or Cancel
		$pwd_dialog->start_main();
		$pwd_entry = $pwd_dialog->get_passwd_entry();
		$passwd=$pwd_entry->get_chars(0,-1);
		$server_string = "{".$servers[$this->current_server][host].":".$servers[$this->current_server][port]."}";
		$return = $this->connect_to_imap_server($server_string,$servers[$this->current_server][user],$passwd);
		$servers[$this->current_server][conn] = $return;
	}	

	function destroy_dialog($widget, $dialog) {
			$dialog->destroy();
		}
		
/* #################################################################################################
        Function to get a connection to the IMAP server
*/ #################################################################################################
        function connect_to_imap_server($host, $user, $passwd) {
                $success=imap_open("$host","$user", "$passwd");
                if ($success == NULL) {
                        $message="The connection to the IMAP server has failed\n".imap_last_error();
                        $error_dialog = &new error_dialog($message);
                }
                else
                        return $success;
        }

	
/* #################################################################################
	Actually sends the mail and calls the spell checker, if desiired (or not at the moment)
*/ #################################################################################
	function send_mail($widget, $id, $to, $cc, $bcc, $subj, $text,$parts,$orig_msg_id)  {
		global $config;
		global $servers;
		
		$env["to"]=$to->get_chars(0,-1);

		if ($env["to"] == NULL) {
			$ed = &new Error_Dialog("You Did Not Enter Any Recipients!");
			$ed->show_all();
			return;
		}

		$env["from"]=$servers[$this->current_server][return_address];
		$env["cc"]=$cc->get_chars(0,-1);
		$env["bcc"]=$bcc->get_chars(0,-1);
		$env["subject"]=$subj->get_chars(0,-1);
		$env["date"]=date("r");

		$num_parts=(count($parts)+1);
		$msg_text["type"]=TYPETEXT;
                $msg_text["subtype"]="plain";
                $msg_text["contents.data"]=$text->get_chars(0,-1);		

		/* If we only have one element in the array then the user hasn't attached
			any files, so we're not generating a multi-part message */
		if ($num_parts == 1 ) 
			$body[0]=$msg_text;
		else {
			$header["type"]=TYPEMULTIPART;
		        $header["subtype"]="mixed";
			$body[0]=$header;
			$body[1]=$msg_text;
			for ($i=2;$i<($num_parts+1);$i++) {
				$part_count=($i - 1);
				$body[$i]=$parts[$part_count];
			}
				}	

		$result=imap_mail_compose($env,$body);
		
		// If the user's has given us a folder to save this in, then save a copy there
		if (isset($servers[$this->current_server][sent])) 
			$success=$this->save_message_to_folder($result,$servers[$this->current_server][sent],"\\Seen");
			
		if (!$success) {
			$message = "Something went wrong saving a copy to ".$servers[$this->current_server][sent]."\n ".imap_last_error()."\n Attempting to send your message anyway.";
			$ed = &new error_dialog($message);
			$ed->show_all();
		}
		
		// use $orig_msg_id above to mark original message as answered
		if ($orig_msg_id !== NULL) 
			$update_status = imap_setflag_full($servers[$this->current_server][conn],$orig_msg_id,"\\Answered",ST_UID);
		
		$mail_pipe=popen($config[preferences][smtp_path],"w");
		fwrite($mail_pipe,$result);
		pclose($mail_pipe);
		$this->destroy();	
	}

/* ##############################################################################################
	Create the file dialog for attachments
*/ ##############################################################################################
	function get_file_name ($widget,$parts,$attachment_box) {
			$fs = &new GtkFileSelection('File Selection Example');
			$ok_button = $fs->ok_button;
			$ok_button->connect('clicked', array($this,attach_file),$fs,&$parts,&$attachment_box);
			$ok_button->connect_object('clicked', array($fs, 'destroy'));
			$cancel_button = $fs->cancel_button;
			$cancel_button->connect_object('clicked', array($fs, 'destroy'));
			$fs->show();
	}
	
	
/* ##############################################################################################
	This is where we actually attach the file to the message
	10-25-2001
		- Improved the mime handling based on the mime.php class
*/ ##############################################################################################
	function attach_file ($widget,$fs,$parts,$attachment_box) {
		$mimes=$this->mimes;
	
	
			$file=$fs->get_filename();
                        $fp=fopen($file,"r");
			
                        $contents=fread($fp,filesize($file));
                        fclose($fp);

			//Get just the name of the file, without the path
			$pos=strrpos($file,'/');
			$filename=substr($file,$pos+1,strlen($file));
			
			// Get the filename extension and lookup its mime type
			$ext = substr($file, strrpos($file,".")+1);
			$mime_type=$mimes->get_mime_type($ext);
			
			$type=substr($mime_type,0,(strpos($mime_type,"/")));
			$subtype=substr($mime_type,strpos($mime_type,"/")+1);
			
			switch ($type) {
				case "application":
					$send_type=TYPEAPPLICATION;
				break;
				case "text":
					$send_type=TYPETEXT;
				break;
				case "image":
					$send_type=TYPEIMAGE;
				break;
				case "video":
					$send_type=TYPEVIDEO;
				break;
				case "audio":
					$send_type=TYPEAUDIO;
				break;
				default:
					$send_type=TYPEOTHER;
				break;
				
			}  
			
			$parts_size=(count($parts)+1);
			$parts[$parts_size]["type"] = $send_type;
                        $parts[$parts_size]["encoding"]=ENCBINARY;
                        $parts[$parts_size]["subtype"]=$subtype;
                        $parts[$parts_size]["description"]=basename($filename);
                        $parts[$parts_size]["contents.data"]=$contents;
			$parts[$parts_size]["disposition.type"] = "attachment";
			$parts[$parts_size]["disposition"]["filename"] = $filename;
			$parts[$parts_size]["disposition"]["FILENAME"] = $filename;
			 
			//Add a button to the attachment box
			$attachment_btn = &new PictureButton($filename,"images/attachment.xpm",$this,VERT,$file);
			$attachment_box->pack_start($attachment_btn,FALSE,TRUE);
			$attachment_box->show_all();
		
	}

/* ###############################################################################################
	Function to popup a search dialog to search for addresses in the ldap directory
*/ ###############################################################################################
	function show_address_book($widget,$txt_box) {
		$adb = &new TeakAddressBook(&$txt_box);
		$adb->show_all();

	}
/* ###############################################################################################
	Some general purpose functions for getting/returning components
*/ ###############################################################################################
	
	function get_send_button() {
		return $this->send_button;
	}

	function cut_text ($widget, $id, $text_area) {
		$text_area->cut_clipboard();
	}

	function copy_text ($widget, $id, $text_area) {
		$text_area->copy_clipboard();
	}

	function paste_text ($widget, $id, $text_area) {
		$text_area->paste_clipboard();
	}

	function select_all_text ($widget, $id, $text_area) {
		$text_area->select_region(0,-1);
	}
	

	function get_exit_menu_item () {
		$itemfact=$this->itemf;
		return ($itemfact->get_widget_by_action(4));
	}

	function get_cancel_button() {
		return $this->cancel_button;
	}

	function get_send_menu_item () {
		$itemfact=$this->itemf;
		return ($itemfact->get_widget_by_action(1));
	}
}

// End Class

?>
