<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* Mime is a class to load our mime types, and then answer questions based upon
	those mime type. It's a pretty simple implementation and relies on
	a plain text mime file in the right format.
*/

Class Mime {
	var $mime_array;
	
	function mime() {
		global $config;
		global $mime_array;
		
		if (!file_exists($config[preferences][mime_file])) {
			$ed = &new error_dialog("Unable to open mime file!\n This isn't good!");
			$ed->show();
			return FALSE;
		}
		
		else {
			$fp = fopen($config[preferences][mime_file],"r");
			while (!feof($fp)) {
				$type=trim(fgets($fp,1024));
				if (($type[0] != "#") && ($type !== "")) {
					$extensions=trim(fgets($fp,1024));
					$app=trim(fgets($fp,1024));
				
					$extension_list = substr($extensions,strpos($extensions,":")+2);
					$application=substr($app,strpos($app,":")+2);
					$mime_array[]= array($type,$extension_list,$application);
				}
			}
			
		}
		fclose($fp);
	}

/* #########################################################################################
	Return the mime type for a given extension, the extensions are stored in the array as a string.
*/#########################################################################################
	function get_mime_type ($extension) {
		global $mime_array;
		
		for ($i=0;$i<count($mime_array);$i++) 
			if (stristr($mime_array[$i][1],$extension))
				return $mime_array[$i][0];
				
	}
	
/* #########################################################################################
	Return the possible extensions for a given mime type.
*/#########################################################################################
	function get_extensions ($mime_type) {
		global $mime_array;
		
		for ($i=0;$i<count($mime_array);$i++)
			if (strtoupper($mime_array[$i][0]) == strtoupper($mime_type))
				return $mime_array[$i][1];
	
	}
	
/* #########################################################################################
	Return the associated application for a given mime type
*/#########################################################################################	
	function get_application_from_mime ($mime_type) {
		global $mime_array;
				
		for ($i=0;$i<count($mime_array);$i++) 
			if (stristr($mime_array[$i][0],$mime_type))
				return $mime_array[$i][2];

		// We didn't find anything, let the caller know we failed
		return NULL;
	}
	
/* #########################################################################################
	Return the athe associated application for a given extension
*/#########################################################################################	
	function get_application_from_extension ($extension) {
		global $mime_array;
		
		for ($i=0;$i<count($mime_array);$i++) 
			if (stristr($mime_array[$i][1],$extension))
				return $mime_array[$i][2];
				
		// We didn't find anything, let the caller know we failed
		return NULL;
	}

}
	
	


?>
