<?php
/*

	Copyright (C) 2001,2002 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	class Main_Window extends GtkWindow {
		//Declare sone variables up front, ones that other classes might need
		var $exit_button;
		var $compose_button;
		var $itemf;
		var $status_bar;
		var $message_array;
		var $bold_style;
		var $wait_cursor;
		var $norm_cursor;
		var $current_server;
	
		function Main_Window() {
	
			// This stays! This is the config object we loaded in main.php
			global $config;
			global $servers;
			
			
			/* Since we now support multiple servers we need a way to keep track of which server is 'current', in other
			words which server currently has focus. This is actually on integer, that allows us to look up the config in
			the $server array above*/
			$this->current_server = NULL;
			
			//First we need to call the parents constructor, php doesn't do this 
			$this->GtkWindow();

			// This is for Drag and Drop
			$targets = array(array('text/plain', 0, -1));

			$this->set_title("Teak - PHP Mail");	
			
			// Create a Mime object, this loads in our mime types 
			$mimes = &new Mime();
			$this->mimes=$mimes;
			
			// Build the cursors
			$c_val = 150 & 0xfe;
			$wait_cursor = gdk::cursor_new($c_val);
			$this->wait_cursor=$wait_cursor;
			$c_val = 68 & 0xfe;
			$norm_cursor = gdk::cursor_new($c_val);
			$this->norm_cursor=$norm_cursor;

			//Top level table
			$master_table = &new GtkVBox(false,10);
			$master_table->set_border_width(5);
			//contains the view table and folder tree
			$view_table = &new GtkHPaned();
			//contains the message box and message list
			$message_table = &new GtkVPaned();
			//We pack the above message_table and the attachment_box into this Box
			$right_hand_box = &new GtkVPaned();
	
			$view_table->add2($right_hand_box);

			//Create the HBox container where we'll put icons for attachments
			$attachment_box = &new GtkHBox(false,5);
			$attachment_box->set_spacing(5);
			$attachment_box->set_border_width(5);

			$button_table = &new GtkTable(10,1,false);
			$button_table->set_col_spacings(1);

			// Setup the tree for folders
			$folder_tree = &new FolderTree(4,0,array("Name","Total","Unread","Uid"));
			$folder_tree->connect('click_column',array(&$this,ctree_click_column));
			
			$scrl_tree = &new GtkScrolledWindow();
			$scrl_tree->add_with_viewport($folder_tree);
			$view_table->add1($scrl_tree);
			$view_table->set_position(300);

			// Setup the clist for the message, needs to be cleaned up!!
			$scrl_win = &new GtkScrolledWindow();
			$scrl_win->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_ALWAYS);
			//$scrl_win->set_usize(350,100);
			$titles = array("Subject","Sender","Date","Size","ID","unixtime","seen");
			$clist = &new MessageList(count($titles), $titles);
			
			$clist->connect('click_column', array(&$this,clist_click_column));
			$clist->connect('drag_data_get', array(&$this,dnd_drag_data_get));
			$clist->drag_source_set(GDK_BUTTON1_MASK|GDK_BUTTON3_MASK, $targets,
								 GDK_ACTION_COPY);

			$scrl_win->add($clist);
			$message_table->add1($scrl_win);
			
			//Creates the actual message view window
			$view_box = &new GtkVBox();
			$header_block = &new HeaderBlock();
			$view_box->pack_start($header_block,FALSE,FALSE,2);			
			
			$scrl_message = &new GtkScrolledWindow();

			$message_text = &new TeakText();
			$message_text->set_word_wrap(TRUE);

			$scrl_message->set_usize(350,360);
			$scrl_message->add($message_text);
			$view_box->pack_start($scrl_message,TRUE,TRUE,2);
			$message_table->add2($view_box);
                        
			$right_hand_box->pack1($message_table,TRUE,TRUE);
			$right_hand_box->pack2($attachment_box,FALSE,FALSE);

			$folder_tree->connect('tree_select_row',array(&$this,folder_selected),$clist,$message_text,&$header_block);
			$folder_tree->connect('drag_data_received',array(&$this,dnd_ctree_received),&$folder_tree,$clist);
			$folder_tree->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);

		/* Register for the select-row event, pass 'this' as &$this, that is pass
		a reference to this exact object, not a copy */
			$clist->connect('select-row',array(&$this,message_selected),$message_text,$attachment_box,&$mimes,&$header_block);

		// We need to realize the GtkWindow so that the GdkWindow is created so we can use it below in the pixmap calls
			$this->realize();

		//Create the exit button
			$exit_button = &new PictureButton("Exit","images/stock_exit.xpm",$this,VERT,"Exit Teak");
			$this->exit_button=$exit_button;
			$button_table->attach($this->exit_button,8,9,1,2,GTK_SHRINK,GTK_FILL);
			//$exit_button->connect('clicked',array(&$this, close_imap_connection));
					
		/* Create the button sending-receiving mail */
			$check_button = &new PictureButton("Check-Mail","images/send-receive.xpm",$this,VERT,"Check For New Mail");
			$button_table->attach($check_button,1,2,1,2,GTK_SHRINK,GTK_SHRINK);
			$check_button->connect('clicked',array(&$this,get_new_mail),$host,$folder_tree,$clist,$msg_text,&$header_block);
		
		/* Create the button for composing a new message */

			$compose_button = &new PictureButton("Compose","images/new-message.xpm",$this,VERT,"Compose A New Message");
			$button_table->attach($compose_button,2,3,1,2,GTK_SHRINK,GTK_SHRINK);
			$compose_button->connect('drag_data_received',array(&$this,dnd_reply_to_compose_received),"composeto",$clist,$message_text);
			$compose_button->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
			$compose_button->connect('clicked',array(&$this,reply_to_message),null,"compose",$clist,$message_text);

			$reply_button = &new PictureButton("Reply","images/reply.xpm",$this,VERT,"Reply To Author");
			$button_table->attach($reply_button,3,4,1,2,GTK_SHRINK,GTK_SHRINK);
			$reply_button->connect('clicked',array(&$this,reply_to_message),null,"reply",$clist,$message_text);
			$reply_button->connect('drag_data_received',array(&$this,dnd_reply_to_compose_received),"reply",$clist,$message_text);
			$reply_button->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
					
			$reply_to_all_button = &new PictureButton("Reply To All","images/reply_to_all.xpm",$this,VERT,"Reply To All");
			$button_table->attach($reply_to_all_button,4,5,1,2,GTK_SHRINK,GTK_SHRINK);
			$reply_to_all_button->connect('clicked',array(&$this,reply_to_message),null,"all",$clist,$message_text);
			$reply_to_all_button->connect('drag_data_received',array(&$this,dnd_reply_to_compose_received),"all",$clist,$message_text);
			$reply_to_all_button->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
			

			// Forward button
			$forward_button = &new PictureButton("Forward","images/forward.xpm",$this,VERT,"Forward This Message");
			$button_table->attach($forward_button,5,6,1,2,GTK_SHRINK,GTK_SHRINK);
			$forward_button->connect('clicked',array(&$this,reply_to_message),null,"forward",$clist,$message_text);
			$forward_button->connect('drag_data_received',array(&$this,dnd_reply_to_compose_received),"forward",$clist,$message_text);
			$forward_button->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);

			$delete_button = &new PictureButton("Delete","images/delete_message.xpm",$this,VERT,"Delete Selected Message");
			$button_table->attach($delete_button,6,7,1,2,GTK_SHRINK,GTK_SHRINK);
			$delete_button->connect('drag_data_received',array(&$this,dnd_delete_received),$folder_tree,$clist,$message_text,$delete_items);
			$delete_button->drag_dest_set(GTK_DEST_DEFAULT_ALL, $targets, GDK_ACTION_COPY);
			$delete_button->connect('clicked',array(&$this,delete_message),null,$folder_tree,$clist,$message_text);

			$print_button = &new PictureButton("Print","images/stock_print.xpm",$this,VERT,"Print The Selected Message");
			$button_table->attach($print_button,7,8,1,2,GTK_SHRINK,GTK_SHRINK);
			$print_button->connect('clicked',array(&$this,print_message),null,$clist);

			// Create the menus, do this almost last so everything exists already
			$ag = &new GtkAccelGroup();
			$itemf = &new GtkItemFactory(GtkMenuBar::get_type(), '<main>', $ag);
			$this->add_accel_group($ag);
			$itemf->create_items(array(
				array ('/_Program','', null, 0, '<Branch>'),
				array('/_Program/E_xit', '<ctrl>X', null, 4, ''),
			
			// Folder menu
				array('/_Folder', '', null, 0, '<Branch>'), 
				array('/_Folder/S_ubscribe', '<ctrl>U',array(&$this,file_subscribe),2, '',array($folder_tree,$host)),
				array('/_Folder/Ne_w','<ctrl>W',array(&$this,new_folder),3,'',array($folder_tree,$host)),
				array('/_Folder/_Expunge','<ctrl>E',array(&$this,expunge_mailbox),17,''),
				
			//Message menu
				array ('/_Message','',null,6,'<Branch>'),
				array ('/_Message/_Delete','<ctrl>D',array(&$this,delete_message),9,'',array($folder_tree,$clist,$message_text)),
				array ('/_Message/sep1','',null,5,'<Separator>'),
				// The callback is null here as it's handled in main.php
				array ('/_Message/_Compose','<ctrl>C',array(&$this,reply_to_message),10,'',array("compose",$clist,$message_text)),
				array ('/_Message/_Reply','<ctrl>R',array(&$this,reply_to_message),11,'',array("reply",$clist,$message_text)),
				array ('/_Message/Reply To All','<ctrl>A',array(&$this,reply_to_message),12,'',array("all",$clist,$message_text)),
				array ('/_Message/_Forward','<ctrl>F',array(&$this,reply_to_message),13,'',array("forward",$clist,$message_text)),
				array ('/_Message/sep2','',null,5,'<Separator>'),
				array ('/_Message/_Print','<ctrl>P',array(&$this,print_message),14,'',array($clist)),
				array ('/_Message/_Save To File','<ctrl>S',array(&$this,save_message_to_file),18,'',array($clist)),
				
			/* //Preferences menu	
				array('/_Preferences','',null,5,'<Branch>'),
			
			removed 10-03-2001 I don't like the way this whole thing works and it needs to be re-written
				array('/_Preferences/_Colours and Fonts','<alt>C',array($this,colour_selection),6,'',array($clist,$folder_tree,$message_text)),
			*/
				array('/_Applications','',null,14,'<Branch>'),
				array('/_Applications/Cale_ndar','<ctrl>N',array($this,show_cal),15,''),
				array('/_Applications/Contact _Lists','<ctrl>L',array($this,show_address_book),16,''),
			));
			$this->itemf=$itemf;

			$master_table->pack_start($itemf->get_widget('<main>'),false);
			$master_table->pack_start($button_table,false);
			$master_table->pack_start($view_table);

		// Create the status are and add that to the window
			$status_bar = &new GtkStatusBar();
			$current_id = $status_bar->get_context_id("First Message");
			$status_bar->push($current_id,"Awaiting Your Command");
			$this->status_bar=$status_bar;
			$master_table->pack_start($status_bar,FALSE,FALSE,0);

			$this->add($master_table);
			$this->show_all();
			
			$current_style=$folder_tree->get_style();
			$this->bold_style=$current_style->copy();
			$bold_font_object = Gdk::font_load($config[preferences][bold_font]);
			$this->bold_style->font=$bold_font_object;
			
			$this->load_parents($folder_tree);
			
			// For each server config that has a password, make an imap connection to the host and save the connection in the array
			for ($i=0;$i<count($servers);$i++) {
				if ($servers[$i][passwd] != NULL) {
					$this->current_server=$i;
					$server_string = "{".$servers[$i][host].":".$servers[$i][port]."}";
					$servers[$i][conn]=$this->connect_to_imap_server($server_string,$servers[$i][user],$servers[$i][passwd]);
					$this->load_folders(null,$folder_tree,$servers[$i]);
				}
			}
			
			/* Create the popup menu of items to display, IF the user right clicks in the
				message list area */	
			$message_popup=$this->construct_popup_menu($folder_tree,$clist,$host,$message_text);
			$clist->connect('button_press_event',array(&$this,message_list_mouse_click),&$message_popup);
			$folder_popup=$this->construct_folder_popup_menu(&$folder_tree);
			$folder_tree->connect('button_press_event',array(&$this,message_list_mouse_click),&$folder_popup);
			
			// Create the timer to run the mailcheck routine, 0 means disabled
			if ($config[preferences][mail_check] != 0) {
				$timer=$config[preferences][mail_check]*60000;
			gtk::timeout_add($timer, array(&$this,get_new_mail),null,$host,$folder_tree,$clist,$message_text,&$header_block);
			}
			
	}
/* ###################################################################################################################
	Show the user a simple calendar widget, this should evetually be it's own class with some added stuff.....later
################################################################################################################### */ 
	function expunge_mailbox ($widget) {
	global $servers;
	
	//FIXME  Do we have a valid IMAP connection, if not we just return, basically ignoring the users request.
		if (isset($servers[$this->current_server][conn]))
			imap_expunge($servers[$this->current_server][conn]);
	}
	
/* ###################################################################################################################
	Show the user a simple calendar widget, this should evetually be it's own class with some added stuff.....later
################################################################################################################### */ 
	function show_cal ($widget) {
		$cal_window = &new GtkWindow();
		$cal_window->set_title("Teak - Calendar");
		
		$cal_box = &new GtkVBox();
		
		list ($pixmap, $mask) = Gdk::pixmap_create_from_xpm($this->window,null,"images/stock_close.xpm");
		$close_image = &new GtkPixmap($pixmap, $mask);
		$close_button = &new GtkButton();
		$close_label = &new GtkLabel("Close");
		$close_box = &new GtkHBox();
		$close_box->pack_start($close_image);
		$close_box->pack_start($close_label);
		$close_button->add($close_box);
		$close_button->connect('clicked',array($this, destroy_dialog), $cal_window);
		
		$cal = &new GtkCalendar();
		
		$cal_box->pack_start($cal,TRUE,TRUE,3);
		$cal_box->pack_start($close_button,FALSE,TRUE,3);
		
		$cal_window->add($cal_box);
		$cal_window->show_all();
	}
	
	
/* ###################################################################################################################
	Show the user a simple calendar widget, this should evetually be it's own class with some added stuff.....later
################################################################################################################### */ 
	function show_address_book ($widget) {
		$address_book = &new TeakAddressBook(null);
		$address_book->show_all();
	}

/* ################################################################################################# 
	We set part of the selection data to be the name on the button, this way we can
	decode it later and do the appropraite thing
*/ #################################################################################################
	function dnd_drag_data_get($widget, $context, $selection_data, $info, $time) {
			$dnd_sender = $widget->get_name();
			$selection_data->set($selection_data->target, 8, $dnd_sender);

	}

/* ################################################################################################# 
	Gets called when something is dropped on the delete button
*/ #################################################################################################
	function dnd_delete_received ($widget, $context, $x, $y, $data, $info, $time, $ctree,$clist,$msg_text,$deleted_items) {

		// If the dnd sender is the clist then we have a mail message
		if (($data->data) == "MessageList") {
			$this->delete_message(null,null,$ctree,$clist,$msg_text);
		}
	}

/* ################################################################################################# 
	Gets called when some is dropped on the reply/reply_to/compose/forward buttons
*/ #################################################################################################
	function dnd_reply_to_compose_received ($widget, $context, $x, $y, $data, $info, $time,$func,$msg_list,$msg_text ) {
		if (($data->data) == "MessageList") {
			$this->reply_to_message(null,null,$func,$msg_list,$msg_text);
		}
	}

/* ################################################################################################# 
	Gets called when the user drops something on the folder tree
*/ #################################################################################################
	function dnd_ctree_received ($widget, $context, $x, $y, $data, $info, $time, $ctree, $clist) {
		global $servers;
		global $config;
	
		if ($data->data == "MessageList") {
			$position=$ctree->get_selection_info($x,$y);
		
			// get_selection_info will return FALSE if the drop location isn't valid
			if ($position == FALSE)
				return;
			
			// Get the target node in the folder tree
			$target=$ctree->node_nth($position[0]);
		
			// This is the message that's selected in the clist
			$selection = $clist->selection[0];
		
			// If the selection object is null, no message was selected, bail out now
			if ($selection === NULL)
				return;
				
			// The unique ID of the message
			$uid = trim($clist->get_text($selection,4));
			
			// Next we need to look at the uids of the source and destination folder incase they're on differnet machines!
			$target_folder_uid = $ctree->node_get_text($target,3);
			$source_folder_uid = $ctree->node_get_text($ctree->selection[0],3);
			
			// Get the full folder name, we need to strip the {host:} off after 
			$temp_folder_name=$this->construct_mailbox_name($ctree,$target,null);
			$pos=strpos($temp_folder_name,'}');
			$dest_folder_name=substr($temp_folder_name,($pos+1));
			
			if ($target_folder_uid == $source_folder_uid) {
				// Copy the message, show an error if it fails
				$success=imap_mail_copy($servers[$this->current_server][conn], $uid, $dest_folder_name, CP_UID);
				list($dest_short_name,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($target,0);
				$this->update_message_count_from_folder_name($ctree,$dest_short_name);
			}
			else {
				// Append the message to the folder on the other host, if we have a valid imap connection
				//Build the message
				$msg_header=imap_fetchheader($servers[$this->current_server][conn], $uid, FT_UID);
				$msg_body=imap_body($servers[$this->current_server][conn], $uid, FT_UID);
				$message=$msg_header.$msg_body;
					
				// Find the entry in the servers array that corresponds to the server we've dropped onto
				for ($i=0;$i<count($servers);$i++) {
					if ($servers[$i][uid] == $target_folder_uid) {
						$remote_folder_name="{".$servers[$i][host].":".$servers[$i][port]."}".$dest_folder_name;
						$success=imap_append($servers[$i][conn],$remote_folder_name,$message,"\\Seen");
					
						if ($config[preferences][buggy_imap] == true) {
							echo "Using imap_status work around code \n";
							$reopen = imap_reopen($servers[$i][conn],$remote_folder_name);
							$status = imap_mailboxmsginfo($servers[$i][conn]);

							$ctree->node_set_text($target,1,"$status->Nmsgs");	
							$ctree->node_set_text($target,2,"$status->Unread");
							if (($status->Unread == 0) && ($ctree->node_get_row_style($target) != $ctree->get_style()))
								$ctree->node_set_row_style($target,$ctree->get_style());  
							break; 
						}
						
						else {
							$status=imap_status($servers[$i][conn],$remote_folder_name,SA_ALL);
							if ($status == false) 
								$this->buggy_imap_found();
							$ctree->node_set_text($target,1,"$status->messages");	
							$ctree->node_set_text($target,2,"$status->unseen");
							if (($status->unseen == 0) && ($ctree->node_get_row_style($target) != $ctree->get_style()))
								$ctree->node_set_row_style($target,$ctree->get_style());
							break;
						}
					}
					
				}
			}
			
			if (!$success) {
				$message = "An error occured copying this message.\n The error was:  \n".imap_last_error();
				$ed = &new error_dialog($message);
			}
		}
	}


/* ################################################################################################# 
	Builds us the popup menu for the folder tree
*/ #################################################################################################
	function construct_folder_popup_menu($ctree) {
		$ft_popup_menu = &new GtkMenu();
		$ft_popup_delete = &new GtkMenuItem("Delete Folder");
		$ft_popup_delete->connect('activate',array(&$this, delete_folder),&$ctree);
		$ft_popup_menu->add($ft_popup_delete);
		$ft_popup_menu->show_all();
		return $ft_popup_menu;	
	}
/* ################################################################################################# 
	Do the actual work of deleting the folder, if it's empty
*/ #################################################################################################
	function delete_folder ($widget,$ctree) {
	global $servers;
	
	//First we need to see if the folder has any messages, if yes then we give an error
	$selection=$ctree->selection[0];
	$folder_name = $this->construct_mailbox_name($ctree, $selection,null);
	$msgs_in_folder = imap_status($servers[$this->current_server][conn],$folder_name,SA_MESSAGES);
	if (($msgs_in_folder->messages) > 0) {
		$message="The folder \n $folder_name \n still contains messages.\n Please remove all the\n messages in the folder, \n then delete it";
		$ed = &new error_dialog($message);
		return;
		}
	else {
		// unselect the current node
 		$ctree->unselect($selection);

		//It seems VERY important we unsubscribe before deleting 
		imap_unsubscribe($servers[$this->current_server][conn],$folder_name);
		$success=imap_deletemailbox($servers[$this->current_server][conn],$folder_name);
		if ($success != TRUE) {
			$message="There was an error deleting the folder \n $folder_name.\n".imap_last_error();
			$ed = &new error_dialog($message);
			imap_subscribe($servers[$this->current_server][conn],$folder_name);
			return;
		}
		else 
			$ctree->remove_node($selection);
		}
	}
	
/* ################################################################################################# 
	Basic print function, not very fancy at the moment
*/ #################################################################################################
	function print_message($widget, $widget_item, $clist) {
		global $servers; 
		
		if ($servers[$this->current_server][conn] != NULL) {
			$row=$clist->selection[0];
			if ($row === NULL)
				return;
			$message_uid=$clist->get_text($row,4);
			$print_dialog = &new printer_dialog($servers[$this->current_server][conn],$message_uid);
		}
	}

/* ################################################################################################# 
 	Function reply/reply_to_all/forward/compose_to
*/ #################################################################################################
	function reply_to_message ($widget,$widget_item,$func,$msg_list,$msg_text) {
		global $servers;	
		
		$row=$msg_list->selection[0];
		
		// If there is no row selected, just return if we're not starting a new message
		if (($row === NULL) && ($func != "compose"))
			return;
		
		// If we're composing a new message we don't care about any of this
		if ($func != "compose") {
			$msg_uid=$msg_list->get_text($row,4);	
			$msg_numb=imap_msgno($servers[$this->current_server][conn],$msg_uid);
			$header_obj=imap_headerinfo($servers[$this->current_server][conn],$msg_numb);
		}
	
		if (($func == "reply") || ($func == "all")) {	
			$from_obj=$header_obj->reply_to[0];
			$reply_address=str_replace("\r","",($from_obj->mailbox."@".$from_obj->host));
			$text=$msg_text->get_chars(0,-1);
			$subject="Re: ".$header_obj->subject;
				if ($func == "all") {
				//We need to construct the cc array
				$ccs=$header_obj->cc;
				if ($ccs == NULL)
					$ccs=$header_obj->to;
				else
					$ccs=array_merge($ccs, $header_obj->to);
			}
			else
				$ccs=NULL;
		}
		elseif ($func == "forward") {
			$subject="Fwd: ".$header_obj->subject;
			$text=$msg_text->get_chars(0,-1);
			}
		elseif ($func == "composeto") {
			$from_obj=$header_obj->reply_to[0];
			$reply_address=str_replace("\r","",$from_obj->mailbox."@".$from_obj->host."\n");
		}
			$compose_window = &new Compose_Window($reply_address,$ccs,$subject,$text,$this->current_server,$this->mimes,$msg_uid);
	}
/* ################################################################################################# 
	The user has clicked the mouse in $widget, if it's the right mouse button show the popup menu
*/ #################################################################################################
	function message_list_mouse_click ($widget, $event,$menu) {
		if ($event->button == 3) 
			$menu->popup(null,null,null,$event->button,$event->time);
	}

/* ################################################################################################# 
	Build the popup menu that's shown in the message list
*/ #################################################################################################
	function construct_popup_menu($ctree,$clist,$host,$msg_text) {
	
		$m = &new GtkMenu();

		$mi_delete = &new GtkMenuItem( 'Delete');
		$mi_delete->connect('activate',array(&$this,delete_message),null,$ctree,$clist,$msg_text);
		$m->add($mi_delete);

		$mi_sep = &new GtkMenuItem();
		$m->add($mi_sep);

		$mi_compose = &new GtkMenuItem ('Compose To');
		$mi_compose->connect('activate',array(&$this,reply_to_message),null,"composeto",$clist,$msg_text);
		$m->add($mi_compose);

		$mi_reply = &new GtkMenuItem ('Reply');
		$mi_reply->connect('activate',array(&$this,reply_to_message),null,"reply",$clist,$msg_text);
		$m->add($mi_reply);

		$mi_reply_to_all = &new GtkMenuItem ('Reply To All');
		$m->add($mi_reply_to_all);
		$mi_reply_to_all->connect('activate',array(&$this,reply_to_message),null,"all",$clist,$msg_text);

		$mi_forward = &new GtkMenuItem ('Forward');
		$m->add($mi_forward);
		$mi_forward->connect('activate',array(&$this,reply_to_message),null,"forward",$clist,$msg_text);
		
		$mi_sep2 = &new GtkMenuItem();
		$m->add($mi_sep2);

		$mi_mark_read = &new GtkMenuItem ('Mark As Read');
		$m->add($mi_mark_read);
		$mi_mark_read->connect('activate',array(&$this,change_message_status),"mark_as_read",$clist);
		
		$mi_mark_unread = &new GtkMenuItem ('Mark As UnRead');
		$m->add($mi_mark_unread);
		$mi_mark_unread->connect('activate',array(&$this,change_message_status),"mark_as_unread",$clist);
	
		$m->show_all(); 
		return $m;
	}
	
/* ################################################################################################# 
 	Change the status of a message, read/unread etc...
*/ #################################################################################################
	function change_message_status ($widget, $status_to_change, $clist) {
		global $servers;
	
		$selection=$clist->selection[0];
		if (!isset($selection))
			return;
			
		$uid=trim($clist->get_text($selection,4));
	
		switch ($status_to_change) {
			case mark_as_read:
				imap_setflag_full($servers[$this->current_server][conn], $uid, "\\Seen", ST_UID);
			break;
			
			case mark_as_unread:
				imap_clearflag_full($servers[$this->current_server][conn], $uid, "\\Seen", ST_UID);
			break;
		}
	
	}

/* ################################################################################################# 
 	Function to get any new mail for the current folder
*/ #################################################################################################
	function get_new_mail ($widget, $host, $ctree,$clist,$msg_text,$header_block) {
		global $servers;
		
		// We're going to make sure that we have the correct folder set first
		$selected_node=$ctree->selection[0];
		if ($selected_node === NULL)
			return;
		
		// Save the current
		$current_server = $this->current_server;
	
		// Run through each server updating its INBOX message count
		for ($i=0;$i<count($servers);$i++) {
			// Skip it if we don't yet have a valid imap connection to the server
			if ($servers[$i][conn] !== NULL) {
				// We have to do this as the function call below relies on current_server being set - poor design
				$this->current_server = $i;
				$selected_folder=$this->construct_mailbox_name($ctree,$servers[$i][inbox],null);
				$success=imap_reopen($servers[$this->current_server][conn],$selected_folder);
				
				$num_msgs=imap_check($servers[$this->current_server][conn]);
				$current_msgs=$ctree->node_get_text($servers[$this->current_server][inbox],1);
							
				if (($num_msgs->Nmsgs != $current_msgs) || ($num_msgs->Recent != 0)){
					$this->update_message_count($ctree,$servers[$this->current_server][inbox]);
					if ($servers[$this->current_server][inbox] === $selected_node)
						$this->folder_selected($ctree,$selected_node,0,$clist,$msg_text,&$header_block);
					
				}
			}
		} 
		
		// Reset the global pointer to the server that is active
		$this->current_server = $current_server;
		
		// Now check to see if the folder the user is in is an 'INBOX', if not do a check for it as well
		list($folder_name,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($selected_node,0);
		if ($folder_name != "INBOX") {
			$this->update_message_count($ctree,$selected_node);
			$this->folder_selected($ctree,$selected_node,0,$clist,$msg_text,&$header_block);
		}
				
		//We return true so that if a timer is setup, it will keep running
		return TRUE;
	}

/* ################################################################################################# 
 	Function to get a connection to the IMAP server
*/ #################################################################################################
	function connect_to_imap_server($host, $user, $passwd) {
	
		$success=@imap_open("$host","$user", "$passwd");
		if ($success == NULL) {
			return FALSE;
		}
		else
			return $success;
	}

/* #################################################################################################
	Function to add the parents (aka: servers) into the ctree
*/ #################################################################################################
	function load_parents ($ctree) {
		global $servers;
				
		list($pixmap_open, $mask_open) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_open.xpm");
		list($pixmap_closed, $mask_closed) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_closed.xpm");
		
		$ctree->freeze();
		$ctree->clear();
		for ($i=0;$i<count($servers);$i++) 
			$parent=$ctree->insert_node(null,null,array($servers[$i][name],"","",$servers[$i][uid]),5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,false,true);
		$ctree->thaw();
	}

/* #################################################################################################
	Function to load all of the subscribed folders
*/ #################################################################################################
	function load_folders($widget,$ctree,$current_host_data) {
		global $servers;
			
		$status_bar=$this->status_bar;
		$load_folders_context = $status_bar->get_context_id("Loading Folders");
		$status_bar->push($load_folders_context,"Loading Mail Folders From Server $current_host_data[host]");
		
		$gdk_window = $this->window;
		$gdk_window->set_cursor($this->wait_cursor);
		while (gtk::events_pending())
			 gtk::main_iteration();

		$ctree->freeze();

		$server_string = "{".$current_host_data[host].":".$current_host_data[port]."}";
		$folders = imap_getsubscribed ($current_host_data[conn], "$server_string", "*");
	        
		if ($folders == false) {
			$message = "Unable to load subscribed folders.\n".imap_last_error();
			$ed = &new error_dialog($message);
              	        echo $message."\n";
		} 
		else {
			
			$parent = $this->find_node($ctree,$current_host_data[name]);
			list($folder_name,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($parent,0);
							  
			while (list ($key, $val) = each ($folders)) {
					// The is so if there's anything pending we paus this action, take care of the event, then go back
					//  a sudo multi-threading if you like!
					while (gtk::events_pending())
						 gtk::main_iteration();
					$status=imap_status($current_host_data[conn],$val->name,SA_ALL);
					$temp_name=imap_utf7_decode($val->name);
					$node=$this->add_node_to_folder_ctree($ctree,$parent,$temp_name,$val->delimiter,$status->messages,$status->unseen,&$server_menu_tree);
				}
		}
	$ctree->select($servers[$this->current_server][inbox]);
	$ctree->thaw();
	$status_bar->pop($load_folders_context);
	$gdk_window->set_cursor($this->norm_cursor);

	}

/* #################################################################################################
	Function that actually adds the nodes to the tree
*/ #################################################################################################
	function add_node_to_folder_ctree ($ctree,$parent,$folder_to_add,$delimiter,$msgs,$unread,$server_menu) {
		global $servers;
			
		// First we need to load a couple of pixmps that we'll use later in the tree
		list($pixmap_open, $mask_open) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_open.xpm");
		list($pixmap_closed, $mask_closed) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_closed.xpm");
		
		//Works with wu-imapd and MS exchange, but a little clumsy
		// This determines if we have a delimiter in the name, if so we have a subfolder
		if ($delimiter != NULL) { 
			$subfolder=strstr($folder_to_add,$delimiter);
			if ($subfolder != NULL)  {
				// If we find a '}' character in the text, strip it out
				$pos=(strrpos($folder_to_add,'}')+1);
				if ($pos != 1) {
					$temp=substr($folder_to_add,0,strpos($folder_to_add,$delimiter));
					$folder_name=substr($temp,$pos,strlen($temp));
				}
				// if there's no } in it, we need to find from the beginning to the delim
				else  
					$folder_name=substr($folder_to_add,0,(strpos($folder_to_add,$delimiter)));

				$text=array($folder_name,$msgs,$unread,$servers[$this->current_server][uid]);
	
				// Scroll through the nodes looking for a match, if we find one, call again
				for ($i=1;$i<$ctree->rows;$i++) {
					$temp_node=$ctree->node_nth($i);
					list($current,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($temp_node,0);
					if ((strtoupper($folder_name)) == (strtoupper($current))) {
						$found=TRUE;
						$subfolder=substr($subfolder,1,strlen($subfolder));
						$this->add_node_to_folder_ctree($ctree,$temp_node,$subfolder,$delimiter,$msgs,$unread,&$server_menu);
						break;
					}
				}
				if ($found != TRUE) {
					$new_parent=$ctree->insert_node($parent,$new_parent,$text,5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,FALSE,TRUE);			
					$subfolder=substr($subfolder,1,strlen($subfolder));
					$this->add_node_to_folder_ctree($ctree,$new_parent,$subfolder,$delimiter,$msgs,$unread,&$server_menu);
				}
			
			
			}
			
			else {
		
			$pos=(strrpos($folder_to_add,'}')+1);
			if ($pos != 1)  
				$folder_name=substr($folder_to_add,$pos,strlen($folder_to_add));
			else 
				$folder_name=$folder_to_add;
			
			$text=array($folder_name,$msgs,$unread,$servers[$this->current_server][uid]);
			$sibling=$ctree->insert_node($parent,$sibling,$text,5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,FALSE,TRUE);
			if (strtoupper($text[0]) == "INBOX")
				$servers[$this->current_server][inbox]=$sibling;
			if ($text[2] > 0)
				$ctree->node_set_row_style($sibling,$this->bold_style);
			}
			
			
		}
		else {
		$pos=(strrpos($folder_to_add,'}')+1);
		if ($pos != 1) 
			$folder_name=substr($folder_to_add,$pos,strlen($folder_to_add));
		else 
			$folder_name=$folder_to_add;
		
		$text=array($folder_name,$msgs,$unread,$servers[$this->current_server][uid]);
		$sibling=$ctree->insert_node($parent,$sibling,$text,5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,FALSE,TRUE);
		if (strtoupper($text[0]) == "INBOX")
			$servers[$this->current_server][inbox]=$sibling;
		if ($text[2] > 0)
			$ctree->node_set_row_style($sibling,$this->bold_style);	
		}

	}

/* ################################################################################################
	When the user selects a folder, we need to work our way up the tree to find the 
	top node, that's the server name, on the way there we generate the folder tree
*/ ################################################################################################
	function construct_mailbox_name ($ctree, $node,$return) {
		global $servers;
		// This is the node that's selected, we then need to work our way up the tree until
		// we find the parent node, with no parent

		$parent_node=$node->parent;

		// We've found the top level node
		if ($parent_node == NULL) {
			$mailbox_name="{".$servers[$this->current_server][host].":".$servers[$this->current_server][port]."}".$return;		
			//Strip of the tailing '/', wu-imapd doesn't like this
			$mailbox_name=substr($mailbox_name,0,strlen($mailbox_name)-1);
			return $mailbox_name;
		}
		else {
			list ($folder_name, $spacing, $pixmap,$mask)=$ctree->node_get_pixtext($node,0);
			$return=$folder_name."/".$return;
			$mailbox_name=$this->construct_mailbox_name($ctree,$parent_node,$return);
		}
		return $mailbox_name;
		
	}

/* ################################################################################################
	Find a node in the tree
*/ ################################################################################################
	function find_node ($ctree,$parent_name) {
		for ($i=0;$i<$ctree->rows;$i++) {
			$temp_node=$ctree->node_nth($i);
			list($folder_name,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($temp_node,0);
			if ($folder_name == $parent_name)
				return $temp_node;
		}
		return FALSE;
	
	}
	
/* ################################################################################################
	Find the parent of a given node in the tree
*/ ################################################################################################
	function find_parent_node ($ctree, $node) {
		$parent_node=$node->parent;
		
		if ($parent_node == NULL) {
			return $node;
			}
		else
			$parent_node=$this->find_parent_node($ctree, $parent_node);
			
	return $parent_node;
	}
/* ################################################################################################
	 Function to load the message from a given folder
*/ ################################################################################################
	function folder_selected ($ctree, $node,$col,$clist,$msg_text, $header_block) {
		global $servers;
					
		// First we need the parent of the folder that's been selected to check if the imap connection has been setup or not
		$parent = $this->find_parent_node($ctree, $node);
		$uid=$ctree->node_get_text($parent,3);
		
		// Next we find this server in the array
		for ($i =0; $i<count($servers);$i++) {
			if ($servers[$i][uid] == $uid)
				$current = $i;
		}
		
		//This assigns it back to the global var, this can only change when a different folder is selected
		$this->current_server=$current;
		
		if ($servers[$current][conn] == NULL) {
			$status_bar=$this->status_bar;
			$passwd_context = $status_bar->get_context_id("Password Dialog");
			$status_bar->push($passwd_context,"Waiting For Passwd");
			$this->show_passwd_dialog($current,$ctree,$node);
			
			// If we didn't get a connection to the IMAP server just return now, otherwise we'll throw some errors below
			if ($servers[$current][conn] == NULL)
				return;			
		}
			
		// Else, if the selected node has no kids, and it matches the hostname of the server, load the folders 
		else {
			list($current_mailbox_name, $spacing, $pixmap, $mask) = $ctree->node_get_pixtext($node, 0);
			if ((count($node->children) == 0) && ($current_mailbox_name == $servers[$current][name])) 
				$this->load_folders(null,$ctree,$servers[$current]);	
		}
		//Construct the proper hostname and mailbox name
		$mailbox=imap_utf7_encode($this->construct_mailbox_name($ctree,$node,null));
		
		//Change to the mailbox the user has selected
		$result=imap_reopen($servers[$current][conn],$mailbox);
		
		//Get the number of message in the box
		$header_count=imap_num_msg($servers[$current][conn]);
		
		// Check to see our count of the number of messages in this folder is correct
		$current_message_count = $ctree->node_get_text($node,1);
		if ($current_message_count != $head_count)
			$this->update_message_count($ctree,$node);

		if ($header_count > 0) {			
			$status_bar=$this->status_bar;
			$folder_selected_context = $status_bar->get_context_id("Folder Selected");
			$status_bar->push($folder_selected_context,"Loading Folder $current_mailbox_name from server ".$servers[$current][host]);
	
			// This might take a while, set the cursor to tell the user to wait
			$gdk_window = $this->window;
			$gdk_window->set_cursor($this->wait_cursor);
			while (gtk::events_pending())
				gtk::main_iteration();
					 
			$message_array = array();
			$msgs="1:".$header_count;
			$msg_header=imap_fetch_overview($servers[$current][conn],"$msgs");
			for ($i=0;$i<count($msg_header);$i++) {
														
			/* Take care of any pending events, though the big wait comes from the above imap call not the message
			processing */
				while (gtk::events_pending())
					 gtk::main_iteration();

				// Get the date of the message, only go as far as the seconds, which we hope os 3 chars out from the last :
				$raw_date=substr($msg_header[$i]->date,0,(strrpos($msg_header[$i]->date,":")+3));
				
				// We sort on the unix data as that's much easier than sorting via a text date
				$unix_date = strtotime($raw_date);	
				
				//This should hopeful;ly get us the persons name, if it's there
				$sender=substr ($msg_header[$i]->from, 0, strpos($msg_header[$i]->from, "<"));
				//If there's not a name just show the email address
				if ($sender == "")
					$sender=$msg_header[$i]->from;
					//Add the row to the message list array
				$message_array[$i] = array($msg_header[$i]->subject,$sender, $raw_date,$msg_header[$i]->size, $msg_header[$i]->uid, "$unix_date",$msg_header[$i]->seen);	
				
				//Reset the cursor to normal and pop the status box
				$gdk_window->set_cursor($this->norm_cursor);
				$status_bar->pop($folder_selected_context);
			}
		}
		else {
			// Clear the message list and text area
			$clist->clear();
			$msg_text->set_point(0);
			$old_length=$msg_text->get_length();
			$msg_text->forward_delete($old_length);
			$header_block->clear();
		}
		
		$clist->set_sort_type(GTK_SORT_DESCENDING);
		$this->sort_clist(&$clist,'5',&$message_array);	
	}	
/* ################################################################################################
 	Function to handle loading the message text into the message pane
*/ ################################################################################################
	function message_selected ($clist,$row,$col,$event,$mesg_text,$attach_box,$mimes,$header_block) {
		global $servers;
		global $message_array;
		
		$mesg_text->freeze();
		$row=$clist->selection[0];
		$value=$clist->get_text($row,4);

		// If there's any kids in the attachment box, remove them all
		$kids=$attach_box->children();
		if (count($kids) != 0) {
			for ($i=0;$i<count($kids);$i++)
				$attach_box->remove($kids[$i]);
		}
		
		//First we need to clear out the text box
		$old_length=$mesg_text->get_length();
		$mesg_text->set_point(0);
		$mesg_text->forward_delete($old_length);
		
		$message_struct=imap_fetchstructure($servers[$this->current_server][conn],$value,FT_UID);
		
		//var_dump($message_struct);
		
		$this->parse_message_part($message_struct, "", $mesg_text, $value, $attach_box,&$mimes,&$header_block);
				
		// Reset the style of the row if it's been bold-ed
		if (($clist->get_row_style($row)) != ($clist->get_style())) 
			$clist->set_row_style($row,$clist->get_style());
			
		$mesg_text->thaw();
		$attach_box->show_all();
	}
	
/* ##################################################################################################
	Function to set the header block to the appropriate values (To, Cc, subject etc...)
*/ ##################################################################################################
 	function set_message_header ($uid,$header_block) {
		global $servers;
		
		// Clear the contents of the header block
		$header_block->clear();
	
		$msg_no = imap_msgno($servers[$this->current_server][conn],$uid);
		$header=imap_headerinfo($servers[$this->current_server][conn],$msg_no);
			
		//Construct each header value
		$types = array("to","from","cc");
		foreach ($types as $type) {
			for ($i = 0; $i<count($header->$type);$i++) {
				$temp=$header->$type;
				if ($temp[$i]->personal === NULL) 
					$$type.=$temp[$i]->mailbox."@".$temp[$i]->host;
				else
					$$type.=$temp[$i]->personal;
					
				$$type.=" ";
				
			}
		}
	
		if ($header->subject === NULL)
			$subject = $header->Subject;
		else
			$subject = $header->subject;
			
			
		$header_block->set_values($to,$from,$subject,$cc);
	}

/* ##################################################################################################
	Function to parse the contents of a messgae 
*/ ##################################################################################################
 	function parse_message_part ($msg_struct, $part_no, $mesg_text,$msg_uid,$at_box,$mimes,$header_block) {
		global $servers;
						
		switch ($msg_struct->type) {
			// Text only messgae
			case TYPETEXT:
			// Look up front to see if it's an attachment. VCards come in this way, as text but as an attachment
			if (strtoupper($msg_struct->disposition) == "ATTACHMENT") {
				$this->add_attachment_button($at_box,$msg_struct,$msg_uid,"$part_no",&$mimes);
			}
			if (strtoupper($msg_struct->subtype) == "PLAIN") {
				// If the part_no is nothing, make it one. This way we just get the message part not the headers as well
				if ($part_no == "")
					$part_no=1;
			
				$this->set_message_header($msg_uid,&$header_block);
				$text=$this->decode_body($msg_struct,imap_fetchbody($servers[$this->current_server][conn],$msg_uid,"$part_no",FT_UID));
				$current_text = $mesg_text->get_chars(0,-1);
				if ($current_text == NULL) 
					$mesg_text->teak_text_set_text(str_replace("\r","","$text"));
					
				else {
					$text = $current_text."\n\n".$text;
                                        $mesg_text->teak_text_set_text(str_replace("\r","",$text));
				}
			
			}
			elseif (strtoupper($msg_struct->subtype) == "HTML") {
				$this->add_attachment_button($at_box,$msg_struct,$msg_uid,"$part_no",&$mimes);
			}
			break;
	
			//Multipart Message
			case TYPEMULTIPART:
			//case TYPEMESSAGE:
			for ($i=0;$i<count($msg_struct->parts);$i++) {
				if ($part_no != "") 
					$part_no = $part_no.".";
				for ($i=0;$i<count($msg_struct->parts);$i++) 
					$this->parse_message_part($msg_struct->parts[$i],$part_no.($i+1),$mesg_text, $msg_uid, $at_box, $mimes,&$header_block);
			}
			break;

			// A Message
			case TYPEMESSAGE:
			// This is where things get a little weird. If we have a message, and the first part of the parts array tells us it's a 
			//  multipart then we reference the other objects by .2 (.3 .4 etc...), no .1.2, .1.3, .1.4 etc...
			if ($msg_struct->parts[0]->type == TYPEMULTIPART) {
				for ($i=1;$i<count($msg_struct->parts[0]->parts)+1;$i++) {
					$new_part = $part_no.".".$i;
					$this->parse_message_part($msg_struct->parts[0]->parts[$i-1],$new_part,$mesg_text, $msg_uid, $at_box, $mimes,&$header_block);
				}
			}
			else {
				for ($i=0;$i<count($msg_struct->parts);$i++) {
					if ($part_no != "") 
						$part_no = $part_no.".";
					for ($i=0;$i<count($msg_struct->parts);$i++) 
						$this->parse_message_part($msg_struct->parts[$i],$part_no.($i+1),$mesg_text, $msg_uid, $at_box, $mimes,&$header_block);
				}
			}
				
			break; 
			
			// Application, basically a message with no text but an app attached
			case TYPEAPPLICATION:
			case TYPEAUDIO:
			case TYPEVIDEO:
			case TYPEIMAGE:
			case TYPEOTHER:
			$this->add_attachment_button($at_box,$msg_struct,$msg_uid,$part_no,&$mimes);
			break;

			default:
			echo "Error: Message type: ".$msg_struct->type." not currently handled\n";
			break;
			
		}
	}

/* ##################################################################################################
	Function to add an attachment button
*/ ##################################################################################################
	function add_attachment_button ($at_box, $this_part,$value,$i,$mimes) {
		global $config;
		
		switch ($this_part->type) {
			case 0:
				$type="text";
				break;
			
			case 1:
				$type="multipart";
				break;	
			
			case 2:
				$type="message";
				break;
				
			case 3:
				$type="application";
				break;
				
			case 4:
				$type="audio";
				break;
				
			case 5:
				$type="image";
				break;
				
			case 6:
				$type="video";
				break;
				
			case 7:
				$type="other";
				break;
				
			default:
				$type="unknown";
		}

		$name=$this->get_name_value($this_part);
				
		$tt_text=$name."\n".$type."/".$this_part->subtype."\n".$this_part->bytes." bytes";
		$att_button_tt = &new GtkToolTips();
	
		$att_button = &new PictureButton (substr($name,0,15),"images/attachment.xpm",$this,VERT,$tt_text);
		
	// Based on the user's preferences, do we default to viewing or saving attachments
	if ($config[preferences][attachment_behavior] == "VIEW")
		$att_button->connect('clicked',array($this,view_file),&$mimes,$value,$i,$this_part,$name);
	else
		$att_button->connect('clicked',array($this,download_file),$value,$i,$this_part,$name);

	$att_button->connect_object('button_press_event',array($this,show_popup_menu),&$mimes,$value,$i,$this_part,$name);
	$at_box->pack_start($att_button,false,true);
	$at_box->show_all();

	}


/* ##################################################################################################
	Function to decode the message body
*/ ##################################################################################################
	function decode_body ($message_part, $text) {
		switch ($message_part->encoding) {
			case ENCBASE64:
				$decoded_contents=base64_decode($text);
			break;
	
			case ENCQUOTEDPRINTABLE:
				$decoded_contents=imap_qprint($text);
			break;

			case ENC8BIT:
			case ENC7BIT:
			case ENCBINARY:
				$decoded_contents=$text;
			break;
				
			default:
				echo "Encoding not known: ".$message_part->encoding."\n";
				$decoded_contents=$text;
			break;
		}
		
		return($decoded_contents);
	}

/* ##################################################################################################
	Function to return $this_part->[d]parameters->value of [FILE]NAME
*/ ##################################################################################################
	function get_name_value ($current_part) {
		if (strtoupper($current_part->subtype) == "HTML") {
			//We have an HTML version of the message
			return "message.html";
		}
		elseif (strtoupper($current_part->subtype) == "PGP-SIGNATURE") {
			//We have a PHP sig
			return "PGP-SIGNATURE";
		}
		elseif ((strtoupper($current_part->subtype) == "DELIVERY-STATUS") ||(strtoupper($current_part->subtype) == "RFC822-HEADERS")) {
			//We have a delivery status attachment ??
			if ($current_part->description != NULL)
				return "$current_part->description";
			else
				return "Delivery-Status";
		}
	
		if ($current_part->ifparameters != 0) {
			for ($j=0;$j<count($current_part->parameters);$j++) {
				$param = $current_part->parameters[$j];
				if (strtoupper($param->attribute) == "NAME") 
 					return($param->value);
			
				else {
					for ($j=0;$j<count($current_part->dparameters);$j++) {
						$param = $current_part->dparameters[$j];
						if (strtoupper($param->attribute) == "FILENAME")  
							return($param->value);
					}
				}
			}

		}
		elseif ($current_part->ifdparameters != 0) {
			for ($j=0;$j<count($current_part->dparameters);$j++) {
				$param = $current_part->dparameters[$j];
				if (strtoupper($param->attribute) == "FILENAME")  
					return($param->value);
			}
		}		
		// This is a last, desperate attempt to find a file name
		elseif (isset($current_part->description)) 
			return ($current_part->description);
		
		// Giving up, can't find a real named
		else {
			echo "Couldn't find any file name, returning unknown\n";
			return "unknown";
		}

	}

/* ##################################################################################################
	 Function to Delete a message from the IMAP server
*/ ##################################################################################################
	function delete_message($widget,$widget_item,$ctree,$clist,$msg_text) {
		global $servers;
		global $config;
				
		// If there's no message selected just leave now, selection is an array of selected item(s)
		if (count($clist->selection) < 1) {
			// Maybe the user wants to delete the folder?	
			$result=FALSE;
			$selection=$ctree->selection[0];
			
			// Bail if there's no folder selected
			if ($selection === NULL)
				return;
				
			$folder_name = $this->construct_mailbox_name($ctree,$selection,null);
			$text = "Do you really want to delete folder:\n $folder_name \n";
			$qd = &new yes_no_dialog($text);

			$ok_button = $qd->get_ok_button();
			$ok_button->connect('clicked',array(&$this,destroy_dialog_with_result),&$qd,&$result);
			$cancel_button = $qd->get_cancel_button();
			$cancel_button->connect('clicked',array(&$this,destroy_dialog_with_result),&$qd,&$result);

			/* We start another GtkMain in the dialog, and here we wait until the user presses one of the
			dialog buttons, the result code from the dialog is returned via the result variable used above in
			the widget connection*/
			$qd->start_main();
			
			// When we get here the the dialog has ended
			
			if ($result) {
				$this->delete_folder(null,$ctree);
			}
			return;
				
		} 
	
		/* We need to get the name of the current folder that's selected, this is so we can 
		look though the list later and select it AFTER the delete */
		$tree_node=$ctree->selection[0];
		list($current_mailbox_name, $spacing, $pixmap, $mask) = $ctree->node_get_pixtext($tree_node, 0);
		
		// The currently selected message, column 4 is the UID, not shown to the user
		$list_row=$clist->selection[0];
		$value=trim($clist->get_text($list_row,4));
		
		//Get the current Mailbox we're attached to, if it's the $delete_items mailbox we want
		// to really delete the message, not move it
		$current_mbox=imap_mailboxmsginfo($servers[$this->current_server][conn]);
		$pos=(strrpos($current_mbox->Mailbox,'}')+1);
		$current_mbox_name=substr($current_mbox->Mailbox,$pos,strlen($current_mbox->Mailbox));	

		/*If the user has set no deleted item mailbox, or if we're in the deleted_items 
		folder already... */
		if (($servers[$this->current_server][deleted_items] == NULL) || (strtoupper($current_mbox_name) == strtoupper($servers[$this->current_server][deleted_items]))) {
			// If the user had set no delete folder, we nuke the message :)
			$success=imap_delete($servers[$this->current_server][conn],$value,FT_UID);
			imap_expunge($servers[$this->current_server][conn]); 
			
		}
		else {
			
			$success=imap_mail_move($servers[$this->current_server][conn],$value,$servers[$this->current_server][deleted_items],CP_UID);
			if ($success == 1) {					
				 imap_expunge($servers[$this->current_server][conn]);
				// Update the message count for the $deleted_items folder
				$this->update_message_count_from_folder_name($ctree,$servers[$this->current_server][deleted_items]);	
			}
		}
		
	
	//Update the messsage count for this current folder
	$this->update_message_count_from_folder_name($ctree,$current_mailbox_name);	

	//Now update the message list
	$clist_row=$clist->selection[0];
	$clist->remove($clist_row);
	//Clear the message box as this might be the only message in the folder
	if ($clist_row == 0) {
		$msg_text->set_point(0);
		$old_length=$msg_text->get_length();
		$msg_text->forward_delete($old_length);
	}
	$clist->select_row($clist_row,0);

	}

/* ##################################################################################################
	Update the message count(s) for the given row (aka: mailbox)
	Here we just find the node, and leave the updating to the actual update_message_count function, which is also used from
		get_new_mail
*/ ##################################################################################################
	function update_message_count_from_folder_name ($ctree, $mailbox_name) {
		global $servers;
		
		// We assume that the folder we are updating resides on the same server as the currently selected node
		$current_node = $ctree->selection[0];
		$parent = $this->find_parent_node($ctree,$current_node);
		$all_kids = $parent->children;
		
		for ($i=0;$i<count($all_kids);$i++) {
		$temp_node=$all_kids[$i];
		list($current,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($temp_node,0);
			if ((strtoupper($current)) == (strtoupper($mailbox_name)))  
				$this->update_message_count($ctree,$temp_node);
		}	
	}
/* ##################################################################################################
	Update the message for a node in the tree
*/ ##################################################################################################
	function update_message_count ($ctree, $node) {
		global $config;
		global $servers;
		
		$full_mailbox_name=$this->construct_mailbox_name($ctree,$node,null);
		//Now we have worry about the user having a buggy imap installed
		if ($config[preferences][buggy_imap] == true) {
			// Certain versions of the imap libs seem to fail imap_status calls is multiple servers are open
			// this is a work around.
			echo "Using imap_status work around code \n";
			$reopen = imap_reopen($servers[$this->current_server][conn],$full_mailbox_name);
			$status = imap_mailboxmsginfo($servers[$this->current_server][conn]);
			
			$ctree->node_set_text($node,1,"$status->Nmsgs");	
			$ctree->node_set_text($node,2,"$status->Unread");
			if (($status->Unread == 0) && ($ctree->node_get_row_style($node) != $ctree->get_style()))
				$ctree->node_set_row_style($node,$ctree->get_style());  
				
			}
			
		else {
			//We've found the right folder, so get it's info and update the node
			$status=imap_status($servers[$this->current_server][conn],$full_mailbox_name,SA_ALL);
			if ($status == false) 
				$this->buggy_imap_found();
			$ctree->node_set_text($node,1,"$status->messages");	
			$ctree->node_set_text($node,2,"$status->unseen");
			if (($status->unseen == 0) && ($ctree->node_get_row_style($node) != $ctree->get_style()))
				$ctree->node_set_row_style($node,$ctree->get_style());
			elseif (($status->unseen != 0) && ($ctree->node_get_row_style($node) != $this->bold_style))
				$ctree->node_set_row_style($node,$this->bold_style);
			
		}
		return;
	}

/* ##################################################################################################
    Given the ctree (mailbox folder list) and the text of the selected box, selected the correct row
*/ ##################################################################################################
	function select_folder ($widget,$ctree, $current_mailbox_name) {
		for ($counter=0;$counter < $ctree->rows;$counter++){
			$current_row=$ctree->node_nth($counter);
			list($mailbox, $spacing, $pixmap, $mask) = $ctree->node_get_pixtext($current_row, 0);
			if ($mailbox == $current_mailbox_name) {
				$ctree->select($current_row);
				return;
			}
		}
	}
		
/* ################################################################################################
	Function to sort the ctree 
*/ ################################################################################################ 
	function ctree_click_column($ctree,$column) {                        
		if ($column == $ctree->sort_column) {
        	        if ($ctree->sort_type == GTK_SORT_ASCENDING)
                	        $ctree->set_sort_type(GTK_SORT_DESCENDING);
                        else
                                $ctree->set_sort_type(GTK_SORT_ASCENDING);
                } else
                        $ctree->set_sort_column($column);
                        $ctree->sort_recursive();        }
/* ################################################################################################
	 Called when the user clicks on one of the column headings, here we set things up for a sort.
*/ ################################################################################################ 
	function clist_click_column($clist, $column) {
		global $message_array;
		
		if ($column == $clist->sort_column) {
                        if ($clist->sort_type == GTK_SORT_DESCENDING)
                                $clist->set_sort_type(GTK_SORT_ASCENDING);
                         else
                                $clist->set_sort_type(GTK_SORT_DESCENDING);  
		} 
		else
                        $clist->set_sort_column($column);
			
		$this->sort_clist ($clist, $column,null);
	}
		
/* ################################################################################################
	 This is where we actually sort the clist, we may want to call this w/o changing the sort type (after adding a row)
*/ ################################################################################################ 
	function sort_clist ($clist, $column,$message_array)	{
		
		if (!isset($message_array)) {
			$message_array = array();
			for ($i=0;$i<$clist->rows;$i++)  	
				$message_array[$i] = array ($clist->get_text($i,0),$clist->get_text($i,1),$clist->get_text($i,2),$clist->get_text($i,3),$clist->get_text($i,4),$clist->get_text($i,5),);
		
		}
		// If the user wants to sort by date, sort via the unix time stamp, not the text date
		// We have to do this oursleves as it seems clist->sort can't handle large number values
		if ((($column == 2)  || ($column == 5) || ($column == 3)) && (count($message_array) > 0)) {
			$clist->freeze();
			$clist->clear();
		
			switch ($column) {
				case 5:
				case 2:
					if ($clist->sort_type == GTK_SORT_ASCENDING) 
						usort($message_array,array(&$this,cmp_date_func));
					else 
						usort($message_array,array(&$this,rev_cmp_date_func));
				break;
				
				case 3:
					if ($clist->sort_type == GTK_SORT_ASCENDING) 
						usort($message_array,array(&$this,cmp_size_func));
					else 
						usort($message_array,array(&$this,rev_cmp_size_func));				
				break;
			}
			
			reset ($message_array);
			foreach ($message_array as $temp) {
				$row=$clist->append(array($temp[0],$temp[1],$temp[2],$temp[3],$temp[4],$temp[5],$temp[6]));
				if ($temp[6] === 0)
					$clist->set_row_style($row,$this->bold_style);
					
				}
			$clist->thaw();
		}
		else				
			$clist->sort();
		
		$clist->select_row(0,0);
	}
/* ################################################################################################
 	These are our compare functions for usort-ing, the second(s) just sorts in reverse order.
	There's got to be a better way than this!
*/ ################################################################################################		
	function cmp_date_func ($a, $b) {
		if ($a[5] == $b[5])
			return 0;
		else
			return  ($a[5] < $b[5]) ? -1 : 1;
		
	}
	
	function rev_cmp_date_func ($a, $b) {
		if ($a[5] == $b[5])
			return 0;
		else
			return  ($a[5] < $b[5]) ? 1 : -1;
		
	}	
	
	function cmp_size_func ($a, $b) {
		if ($a[3] == $b[3])
			return 0;
		else
			return  ($a[3] < $b[3]) ? -1 : 1;
		
	}
	
	function rev_cmp_size_func ($a, $b) {
		if ($a[3] == $b[3])
			return 0;
		else
			return  ($a[3] < $b[3]) ? 1 : -1;
		
	}
/* ################################################################################################
 	Handle folder subscriptions
*/ ################################################################################################
	function file_subscribe($id,$widget,$ctree,$host) {
		global $servers;
		
		//FIXME  Do we have a valid IMAP connection, if not we just return, basically ignoring the users request.
		if (!isset($servers[$this->current_server][conn]))
			return;

		// Get the name of the currently selected mailbox
		$tree_node=$ctree->selection[0];

		//Check to see that there is a mailbox selected, or we throw a warning
		if ($tree_node != NULL) 
			list($current_mailbox_name, $spacing, $pixmap, $mask) = $ctree->node_get_pixtext($tree_node, 0);

		$sub_window = &new subscribe_window($this->current_server,$ctree);
		/*$sub_ok_button = $sub_window->get_ok_button();
		$sub_ok_button->connect('clicked',array(&$this,load_folders), $mailhost,$ctree);
		$sub_ok_button->connect('clicked',array(&$this,select_folder),$ctree, $current_mailbox_name); */
		$sub_window->show();
		
	}
/* ################################################################################################
	 Function to create a new mailbox, then subscribe to it
*/ ################################################################################################
	function new_folder ($id,$widget,$ctree,$host) {
		global $servers;
		
		// this should really be a seperate widget, post 0.20.
	
		//FIXME  Do we have a valid IMAP connection, if not we just return, basically ignoring the users request.
		if (!isset($servers[$this->current_server][conn]))
			return;
	
		$new_folder = &new GtkDialog();	
		$new_folder->set_border_width(5);
		$new_folder->set_title("Add New Folder");
		$top_box = $new_folder->vbox;
		$bottom_box = $new_folder->action_area;

		$label = &new GtkLabel("Folder Name: ");
		$entry = &new GtkEntry();
		$add_button = &new PictureButton("Add","images/stock_add.xpm",$this,HORZ,"Create The New Folder");
		$add_button->connect('clicked',array(&$this,add_imap_folder),$entry,$ctree);
		$close_button = &new PictureButton("Close","images/stock_close.xpm",$this,HORZ,"Close The Window Without Creating A Folder");
		$close_button->connect('clicked',array(&$this,destroy_new_add_dialog),$new_folder);
		$top_box->set_spacing(2);
		$top_box->pack_start($label);
		$top_box->pack_start($entry);

		$bottom_box->set_spacing(2);
		$bottom_box->pack_start($add_button);
		$bottom_box->pack_start($close_button);

		$new_folder->show_all();
		$entry->grab_focus();
	}

/* ###############################################################################################
	Function to add an imap folder on the host
*/ ###############################################################################################
	function add_imap_folder($widget,$entry_field,$ctree) {
		global $servers;
				
		$coded_entry=imap_utf7_encode($entry_field->get_text());
		$server_string = "{".$servers[$this->current_server][host].":".$servers[$this->current_server][port]."}";
		$entry_to_add=$server_string.$coded_entry;
		
		if ($coded_entry != "") {
			if ($servers[$this->current_server][conn] != NULL) {
				$create=imap_createmailbox($servers[$this->current_server][conn],$entry_to_add);
			}
			else
				{
				$pwd_dialog = &new password_dialog();
				$pwd_ok_button = $pwd_dialog->get_ok_button();
				$pwd_cancel_button = $pwd_dialog->get_cancel_button();
				$pwd_ok_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);
				$pwd_cancel_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);

				//"Start" the dialog's main, it will exit when the user presses OK or Cancel
				$pwd_dialog->start_main();

				// Now get the text entry, get the text from it and use that as the password
				$pwd_entry = $pwd_dialog->get_passwd_entry();
				$passwd=$pwd_entry->get_chars(0,-1);
				$server_string = 
				$success = $this->connect_to_imap_server($server_string,$user,$passwd);
				if ($success == TRUE) 
					$create=imap_createmailbox($servers[$this->current_server][conn],$entry_to_add);
					
			}
			if ($create == TRUE) {
				// First we need to load a couple of pixmps that we'll use later in the tree
				list($pixmap_open, $mask_open) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_open.xpm");
				list($pixmap_closed, $mask_closed) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_closed.xpm");
		
				imap_subscribe($servers[$this->current_server][conn],$entry_to_add);
				$parent=$this->find_parent_node($ctree, $ctree->selection[0]);
				$sibling=$ctree->insert_node($parent,$sibling,array($coded_entry,"0","0",null),5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,FALSE,TRUE);
			}
			else 
				$ed = &new error_dialog("An error occured while adding folder $entry_to_add \n".imap_last_error());
		}
		$entry_field->set_text("");
	}


/* ###############################################################################################
	Shows the popup menu that allows users to view the file with the known MIME type or
	pick a different app to view it.
*/ ###############################################################################################
	function show_popup_menu ($event, $mimes,$msg_numb,$msg_part,$msg_section,$name)  {
		//If right mouse button pressed
		if ($event->button == 3) {

			$popup_menu = &new GtkMenu();
			$view_item = &new GtkMenuItem("View");

			// If we don't have a matching MIME type and we can't find an extension that matches, don't allow this menu item
			if (!($mimes->get_application_from_mime($msg_section->subtype))) {
				$file_extension = $file_extension=substr($name,strrpos($name,".")+1);
				if (!($mimes->get_application_from_extension($file_extension)))
					$view_item->set_sensitive(false);
					
			}
			$view_item->connect('activate',array($this, view_file),&$mimes,$msg_numb,$msg_part,$msg_section,$name);
			$popup_menu->add($view_item);

			$view_with_item = &new GtkMenuItem("View With...");
			$view_with_item->connect('activate',array($this,view_with_file),$msg_numb,$msg_part,$msg_section,$name);
			$popup_menu->add($view_with_item);

			$save_item = &new GtkMenuItem("Save");
			$save_item->connect('activate',array($this,download_file),$msg_numb,$msg_part,$msg_section, $name); 
			$popup_menu->add($save_item);
			$popup_menu->show_all();
			$popup_menu->popup(null,null,null, $event->button, $event->time);
		}
	}
/* ###############################################################################################
	Function to prompt the user for the app they would like to open the attachment, then
	we'll lauch that program against the saved attachment.
*/ ###############################################################################################
	function view_with_file ($widget,$number, $part, $section, $name) {
		global $config;
		
		$temp_file = $config[preferences][temp_dir].$name;
		$this->write_file(NULL, NULL, $number, $part, $section, $temp_file);	

		$fs = &new GtkFileSelection('Choose Application');
		$ok_button = $fs->ok_button;
		$ok_button->connect('clicked',array($this,open_with_application),$fs,$temp_file);
		$ok_button->connect_object('clicked', array($fs, 'destroy'));
		$cancel_button = $fs->cancel_button;
		$cancel_button->connect_object('clicked', array($fs, 'destroy'));
		$fs->show();
	}

/* ###############################################################################################
	Function to lauch the program the user just selected with the temp file as it's 1st
	argument.
*/ ###############################################################################################
	function open_with_application ($widget, $fs, $file_to_open) {
		$app=$fs->get_filename();
		if (($fs != NULL) && ($file_to_open != NULL))
			exec ("$app \"$file_to_open\" >/dev/null 2>&1 &");
	}
	

/* ###############################################################################################
	Function to save the attachment to a temp directory then launch an app based on it's
	MIME type
*/ ###############################################################################################
	function view_file ($widget,$mimes, $number,$part,$msg_section,$name) {
		global $config;
	
		$temp_file = $config[preferences][temp_dir].$name;
		$this->write_file(NULL, NULL, $number, $part, $msg_section, $temp_file);
		$app_name=$mimes->get_application_from_mime($msg_section->subtype);
	
		if ($app_name == NULL) {
			// We've been passed a mime type that doesn't help us, for example Application/OCTET STREAM
			// so we try to find an extension on the file and then look for an app associated with that.
			$file_extension=substr($name,strrpos($name,".")+1);
			$app_name=$mimes->get_application_from_extension($file_extension);
		} 
		
		exec ("$app_name \"$temp_file\" >/dev/null 2>&1 &",$temp);

		
	}
/* ###############################################################################################
	Function to save a MIME attachment to a file, can get called in one of two ways:
	1) With a reference to a file save dialog box
	2) With a filename to save as
*/ ###############################################################################################

	function download_file ($widget, $message_number, $message_part,$msg_section,$filename) {
		$fs = &new GtkFileSelection('Save File');
		$ok_button = $fs->ok_button;
		$ok_button->connect('clicked',array($this,write_file),$fs, $message_number,$message_part,$msg_section,NULL);
		$ok_button->connect_object('clicked', array($fs, 'destroy'));
		$cancel_button = $fs->cancel_button;
		$cancel_button->connect_object('clicked', array($fs, 'destroy'));
		$fs->set_filename($filename);
		$fs->show();

	}
/* ###############################################################################################
	This can be called two ways, with and without a filename, without gets the name from the
	file selection dialog 
*/ ###############################################################################################
	function write_file ($widget, $fs, $message_number, $message_part, $msg_section, $filename) {
		global $servers;
		
		if ($filename == NULL) 
			$filename=$fs->get_filename();
		
		$fp=fopen($filename,"w");
        	$contents=imap_fetchbody($servers[$this->current_server][conn], $message_number, $message_part,FT_UID);
		
		//Decode the attachment
		switch ($msg_section->encoding) {
		case ENCBASE64:
			$decoded_contents=base64_decode($contents);
			break;
	
		case ENCQUOTEDPRINTABLE:
			$decoded_contents=quoted_printable_decode($contents);
			break;
		default:
			$decoded_contents=$contents;
		}
		fwrite($fp,$decoded_contents);
	        fclose($fp);
	}

/* ###############################################################################################
	show the password dialog box and get a password from the user for the $user on $server
*/ ###############################################################################################
	function show_passwd_dialog($current,$ctree,$node) {
		global $servers;

		$pwd_dialog = &new password_dialog($servers[$current]);
		$pwd_ok_button = $pwd_dialog->get_ok_button();
		$pwd_cancel_button = $pwd_dialog->get_cancel_button();
		$pwd_ok_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);
		$pwd_cancel_button->connect('clicked', array($this,destroy_dialog),$pwd_dialog);

		//"Start" the dialog's main, it will exit when the user presses OK or Cancel
		$pwd_dialog->start_main();

		// Now get the text entry, get the text from it and use that as the password
		$pwd_entry = $pwd_dialog->get_passwd_entry();
		$passwd=$pwd_entry->get_chars(0,-1);
		$server_string = "{".$servers[$current][host].":".$servers[$current][port]."}";
		$success = $this->connect_to_imap_server($server_string,$servers[$current][user],$passwd);

		if ($success != FALSE) {
			$servers[$current][conn] = $success;
			$ctree->unselect($node);
			$ctree->select($node);
			$status_bar=$this->status_bar;
			$passwd_done_id = $status_bar->get_context_id("Password Dialog");
			$status_bar->pop($passwd_done_id);
		}
		
		else {
			$message="The connection to the IMAP server has failed.\n".imap_last_error();
			$error_dialog = &new error_dialog($message);
		}
		
	}
	
/* ###############################################################################################
	Build the file as a string, then launch a file selection box to let the user choose the filename
*/ ###############################################################################################
	function save_message_to_file ($widget, $menuitem, $clist) {
		global $servers;
		
		if ($servers[$this->current_server][conn] != NULL) {
			$row=$clist->selection[0];
			if ($row === NULL)
				return;
			$msg_uid=$clist->get_text($row,4);
			
			$msg_header=imap_fetchheader($servers[$this->current_server][conn],$msg_uid,FT_UID);
			$msg_body=imap_body($servers[$this->current_server][conn],$msg_uid,FT_UID);
			$file_contents=$msg_header."\n".$msg_body;
			
			$fs = &new GtkFileSelection('Save File'); 
			$ok_button = $fs->ok_button;
			$ok_button->connect('clicked',array($this,write_save_file),$fs,$file_contents);
			$cancel_button = $fs->cancel_button;
			$cancel_button->connect('clicked', array($this, 'destroy_dialog'),$fs);
			$fs->show();
		}
	}
/* ###############################################################################################
	Save the string contents to the file selected, destroy the dialog
*/ ###############################################################################################
	function write_save_file ($widget,$fs, $contents) {
		$filename = $fs->get_filename();
		
		// If the file already exists in the filesystem then make sure the user knows they are going to over write it!
		if (file_exists($filename)) {
			$confirm_dialog = &new yes_no_dialog("WARNING! This file already exists.\n Are you sure you want to overwrite the contents?");
			$ok_button = $confirm_dialog->get_ok_button();
			$ok_button->connect('clicked',array(&$this,destroy_dialog_with_result),&$confirm_dialog,&$result);
                        $cancel_button = $confirm_dialog->get_cancel_button();
                        $cancel_button->connect('clicked',array(&$this,destroy_dialog_with_result),&$confirm_dialog,&$result);
			$confirm_dialog->start_main();
			
			// If result is not true then don't write anything, though we don't destroy the dialog as the user may with to save using a different name
			if (!$result)
				return;			
		}
		
		$fp = fopen ($filename, "w");
		$result = fwrite($fp, $contents);
		if ($result == -1) {
			$ed = &new error_dialog("An error occured while \n trying to save this file.");
			$ed->show();
		}
		
		$fs->destroy();
		
	}
/* ###############################################################################################
	If the imap connection exists, close it
*/ ###############################################################################################
	function close_imap_connection ($widget) {
		if ($servers[$this->current_server][conn] != NULL) {
			imap_close($servers[$this->current_server][conn],CL_EXPUNGE);
		}
	}

	function destroy_dialog($widget,$dialog) {
		$dialog->destroy();
	}

	function destroy_dialog_with_result($widget, $dialog, $result) {
		$result=$dialog->get_result();
		$dialog->end_main();
		$dialog->destroy();
	}

/* ###############################################################################################
	Close the add_folder dialog and call load_folders to reload all the folders from the IMAP 
	host
*/ ###############################################################################################
	function destroy_new_add_dialog($widget,$dialog) {
		$dialog->destroy();
		
	}
/* ###############################################################################################
	Call if an imap_status calls returns false. There's a bug in some versions of the imap libs that can't seem to keep
	multiple connection info straight.
*/ ###############################################################################################
	function buggy_imap_found () {
		global $config;
		
		$message = "An imap_status call has failed.\n This could be due to an imap connection\n not being open, but is more likely\n due to a bug in the imap libs.\n I'm enabling a workaround for this session.\n You should edit your config.ini file\n and add the line buggy_imap = true.";
		$ed = &new error_dialog($message);
		$ed->show_all();
		$config[buggy_imap] = true;
	}

// Function to return the exit button so we can register for events from it
	function get_exit_button() {
		return $this->exit_button;
	}

	function get_compose_button() {
		return $this->compose_button;
	}

	function get_exit_menu_item() {
		$itemfact=$this->itemf;
		return($itemfact->get_widget_by_action(4));
	}
	function get_new_menu_item() {
		$itemfact=$this->itemf;
		return($itemfact->get_widget_by_action(1));
	}
	function get_compose_menu_item() {
		$itemfact=$this->itemf;
		return ($itemfact->get_widget_by_action(10));
	}

}
//End of class
?>
