<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class printer_dialog extends GtkWindow {
		var $print_separator;
		var $print_header;
		
		function printer_dialog($conn,$msg_uid) {
			global $config;
			
			$this->GtkWindow();

			$this->set_title("Print Message");
			$this->set_border_width(10);
			$this->realize();

			$txt_label = &new GtkLabel("Enter Printer Name Below:");

			$command_text = &new GtkEntry();
			$command_text->set_text($config[preferences][def_printer]);
			$print_button = &new PictureButton("Print","images/stock_print.xpm",$this,HORZ,"Print Message");
			$print_button->connect('clicked',array(&$this,print_message),$conn,$msg_uid,$command_text);
			$cancel_button = &new PictureButton("Cancel","images/stock_button_cancel.xpm",$this,HORZ,"Close This Window Without Printing");
			$cancel_button->connect('clicked',array($this,destroy_dialog));
			$help_button = &new PictureButton("Help","images/stock_help.xpm",$this,HORZ,"Get Help");

			$separator_check_box = &new GtkCheckButton("Suppress Separator");
			$separator_check_box->set_active(TRUE);
			$separator_check_box->connect('toggled',array(&$this,set_value),"print_separator");
			$msghdr_check_box = &new GtkCheckButton("Full Message Header");
			$msghdr_check_box->connect('toggled',array(&$this,set_value),"print_header");
	

			$main_box = &new GtkVbox(FALSE,5);
			$button_box = &new GtkHBox(FALSE,5);
			$button_box->pack_start($print_button);
			$button_box->pack_start($cancel_button);
			$button_box->pack_start($help_button);

			$check_button_table = &new GtkTable(2,2,false);
			$check_button_table->attach($separator_check_box,1,2,1,2);	
			$check_button_table->attach($msghdr_check_box,3,4,1,2);
			
			$main_box->pack_start($txt_label);	
			$main_box->pack_start($command_text);
			$main_box->pack_start($check_button_table);
			$main_box->pack_start($button_box);
			$this->add($main_box);
			$this->show_all();
	}

/* #################################################################################################
	Actually handle the printing, needs some work, very basic at the moment
*/ #################################################################################################
	function print_message ($widget,$conn, $msg_uid,$command_text) {
		global $config;
		
		
		//First we need to construct the command line based upon user options
		$cmdline=$this->build_cmd_line($command_text);

		if ($this->print_header == 1)
			$header=imap_fetchheader($conn,$msg_uid,FT_UID);		
		else
			$header=$this->build_header($conn,$msg_uid);

		$msg_body=imap_body($conn,$msg_uid,FT_UID);
		$tempfile=$config[paths][temp].$msg_uid.".prt";
		$file_contents=$header."\n".$msg_body;
		$fp=fopen($tempfile,"w");
		fwrite($fp,$file_contents);
	        fclose($fp);
		
		$cmdline = $cmdline." -P".$config[preferences][def_printer]." ".$tempfile;
		exec ("$cmdline >/dev/null 2>&1 &");
		$this->destroy_dialog(null);
	}
/* #################################################################################################
	Build the "standard" message header for printing
*/ #################################################################################################
	function build_header($conn,$msg_uid) {
		$msg_no=imap_msgno($conn,$msg_uid);
		$header=imap_headerinfo($conn,$msg_no);
		return "To: ".$header->toaddress."\n From: ".$header->fromaddress."\n CC: ".$header->ccaddress."\n Date: ".$header->Date."\n Subject: ".$header->subject."\n\n";
	}

/* #################################################################################################
	Build the command line for lpr
*/ #################################################################################################
	function build_cmd_line($entry) {
		global $config;

		$return=$config[preferences][lpr_command];
		if ($this->print_separator == 1)
			$return=$return." -h ";

		return $return;

	}

/* #################################################################################################
	fairly self explanitory
*/ #################################################################################################
	function destroy_dialog($widget) {
		$this->destroy();
	}

/* #################################################################################################
	Change the class vars to match the current GUI selection. We pass in the widget that
	caused the change, and the name of the class var to change.
*/ #################################################################################################
	function set_value ($widget,$var_to_change) {
		$new_val = $widget->get_active();	
		$this->$var_to_change=$new_val;
	}
}
