<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

	// Window to handle the subscription of new IMAP folders

Class subscribe_window extends GtkWindow {
	var $ok_button;

	function subscribe_window($current_server,$main_folder_tree) {
		$this->GtkWindow();
		global $servers;

		$title = "Subscribe/Unsubscribe Folders For ".$servers[$current_server][name];
		$this->set_title($title);
		$this->set_default_size(100,250);
		$this->realize();

		$master_table=&new GtkVBox(false,10);
		$master_table->set_border_width(5);
		$bottom_table=&new GtkHBox(false,10);

		$button_table = &new GtkTable(1,6,false);
		$button_table->set_row_spacings(10);
		$button_table->set_col_spacings(5);
		$button_table->set_border_width(2);

		$scroll_window = &new GtkScrolledWindow();
		$scroll_window->set_policy(GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
		$scroll_window->set_usize(450,100);
		$titles = array("Folder Name","Sub","Message");
		$folder_tree = &new GtkCTree(3,0,$titles);
		$folder_tree->set_column_width(0,300);
		$folder_tree->set_column_width(1,35);
		$scroll_window->add_with_viewport($folder_tree);
		$this->server_selected(NULL,$folder_tree,$current_server);

		$expand_button = &new GtkButton("Expand");
		$expand_button->connect('clicked',array($this,expand_tree),$folder_tree);
		$colapse_button = &new GtkButton("Colapse");
		$colapse_button->connect('clicked',array($this,collapse_tree),$folder_tree);
		$refresh_button = &new GtkButton("Refresh List");
		$refresh_button->connect('clicked',array($this,server_selected),$folder_tree,$current_server);
		$subscribe_button = &new GtkButton("Subscribe");
		$subscribe_button->connect('clicked',array($this,subscribe_folder),$current_server,$folder_tree,$main_folder_tree);
		$unsubscribe_button = &new GtkButton("UnSubscribe");
		$unsubscribe_button->connect('clicked',array($this,unsubscribe_folder),$current_server,$folder_tree,$main_folder_tree);

		
		$ok_button = &new GtkButton("OK");
		$this->ok_button=$ok_button;
		$ok_button->connect('clicked',array($this,destroy_window));

		$button_table->attach($refresh_button,1,2,1,2,GTK_FILL,GTK_SHRINK);
		$button_table->attach($expand_button,1,2,2,3,GTK_FILL,GTK_SHRINK);
		$button_table->attach($colapse_button,1,2,3,4,GTK_FILL,GTK_SHRINK);
		$button_table->attach($subscribe_button,1,2,4,5,GTK_FILL,GTK_SHRINK);
		$button_table->attach($unsubscribe_button,1,2,5,6,GTK_FILL,GTK_SHRINK);
		$button_table->attach($this->ok_button,1,2,6,7,GTK_FILL,GTK_SHRINK);
	
		$bottom_table->pack_start($scroll_window,TRUE,TRUE);
		$bottom_table->pack_start($button_table,FALSE,FALSE);
	
		$server_label = &new GtkLabel("Server: ");
		$server_list = &new GtkLabel();
		$server_list->set_text($servers[$current_server][name]);
		
		$top_box = &new GtkTable(2,1,false);
		$top_box->attach($server_label,1,2,1,2);
		$top_box->attach($server_list,2,3,1,2);
		$master_table->pack_start($top_box,FALSE,FALSE);
		$master_table->pack_start($bottom_table,TRUE,TRUE);
		
		$this->add($master_table);
		$this->show_all();		
		

	}
/*#####################################################################################################################
	Go out to the mail server and load all of the folder, add them all into the tree and put a check by those that are subscribed
*/#####################################################################################################################	
	function server_selected ($widget,$ctree,$current_server) {
		global $servers;
		
		$ctree->freeze();
		$ctree->clear();
		$parent=$ctree->insert_node(null,null,array($servers[$current_server][name],"",""),5,null,null,null,null,false,true);
		list ($pixmap, $mask) = Gdk::pixmap_create_from_xpm($this->window,null,"images/mini.checkmark.xpm");

		$mailhost = "{".$servers[$current_server][host].":".$servers[$current_server][port]."}";
		$folders = imap_listmailbox ($servers[$current_server][conn], "$mailhost", "*");
		$subed_folders = imap_listsubscribed($servers[$current_server][conn],"$mailhost","*");
			
		if (($folders == false) || ($subed_folders == false)) 
                              echo "Call failed".imap_last_error()."\n";
		else {
                               while (list ($key, $val) = each ($folders)) {
				while (gtk::events_pending())
					 gtk::main_iteration();
				$status=imap_status($servers[$current_server][conn],$val,SA_ALL);				
				$text=array($val,null,$status->messages);
				$sibling=$ctree->insert_node($parent,$sibling,$text,5,null,null,null,null,true,false);	
				if (in_array($val, $subed_folders)) 
					$ctree->node_set_pixtext($sibling,1,"",5,$pixmap,$mask);
			}
		}
		$ctree->thaw();
	}
/*#####################################################################################################################
	Subscribe to the folder, if successful add it to the ctree in the teak main window
*/#####################################################################################################################	
	function subscribe_folder ($widget,$current_server,$ctree,$main_folder_tree) {
		global $servers;
		
		$row=$ctree->selection[0];
		$folder=$ctree->node_get_pixtext($row,0);
		$success=imap_subscribe($servers[$current_server][conn],$folder[0]);
		if ($success == 1) {
			list ($pixmap, $mask) = Gdk::pixmap_create_from_xpm($this->window,null,"images/mini.checkmark.xpm");
			list($pixmap_open, $mask_open) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_open.xpm");
			list($pixmap_closed, $mask_closed) = Gdk::pixmap_create_from_xpm($this->window,null,"images/folder_closed.xpm");
			$ctree->node_set_pixtext($row,1,"",5,$pixmap,$mask);
			
			$parent=$this->find_parent_node($main_folder_tree,$main_folder_tree->selection[0]);
			$folder_name = substr($folder[0],strrpos($folder[0],"}")+1);
			$status = imap_status($servers[$current_server][conn],$folder[0],SA_ALL);
			$sibling = $main_folder_tree->insert_node($parent,$sibling,array($folder_name,$status->messages,$status->unseen),5,$pixmap_closed,$mask_closed,$pixmap_open,$mask_open,FALSE,TRUE);
		}
	}

/*#####################################################################################################################
	UnSubscribe to the folder, if successful remove it from the ctree in the teak main window
*/#####################################################################################################################
	function unsubscribe_folder ($widget,$current_server,$ctree,$main_folder_tree) {
		global $servers;
		
		$row=$ctree->selection[0];
		$folder=$ctree->node_get_pixtext($row,0);
		$success=imap_unsubscribe($servers[$current_server][conn],$folder[0]);
		if ($success == 1) {
			$ctree->node_set_text($row,1,"");
			for ($i=0;$i<$main_folder_tree->rows;$i++) {
				$node = $main_folder_tree->node_nth($i);
				list($name,$spacing,$pixmap,$mask)=$ctree->node_get_pixtext($node,0);
				$folder_name = substr($folder[0],strrpos($folder[0],"}")+1);
				if ($name == $folder_name) {
					$main_folder_tree->remove_node($node);
					return;
				}
			}
		}
	}


/* ################################################################################################
        Find the parent of a given node in the tree
*/ ################################################################################################
        function find_parent_node ($ctree, $node) {
                $parent_node=$node->parent;

                if ($parent_node == NULL) {
                        return $node;
                        }
                else
                        $parent_node=$this->find_parent_node($ctree, $parent_node);

        return $parent_node;
        }


	function destroy_window() {
		$this->hide();
	}
	
	function expand_tree($widget, $tree) {
		$tree->expand_recursive();
	}
	function collapse_tree($widget, $tree) {
		$tree->collapse_recursive();
	}
	
	
}

?>
