<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/
	Class HeaderBlock extends GtkFrame {
		var $labels;
		
		function HeaderBlock() {
			global $config;
			
			$this->GtkFrame();
			
			$table = &new GtkVBox(FALSE,0);
			
			$top_row = &new GtkHBox(FALSE,0);
			$bottom_row = &new GtkHBox(FALSE,0);
			
			$to = &new GtkLabel("To: ");
			$from = &new GtkLabel("From: ");
			$subj = &new GtkLabel("Subj: ");
			$cc = &new GtkLabel("Cc: ");
			
			$label_style = $to->get_style();
			$new_style = $label_style->copy();
			
			//Set up the tags with a bold font
			$temp = Gdk::font_load($config[preferences][bold_font]);
			$new_style->font=$temp;
			$to->set_style($new_style);
			$from->set_style($new_style);
			$subj->set_style($new_style);
			$cc->set_style($new_style);		
			
			$to_label = &new GtkLabel();
			$from_label = &new GtkLabel();
			$subj_label = &new GtkLabel();
			$cc_label = &new GtkLabel();
			$this->labels=array($to_label,$from_label,$subj_label,$cc_label);
			
			$top_row->pack_start($to,FALSE,FALSE);
			$top_row->pack_start($to_label,TRUE,TRUE);
			
			$top_row->pack_start($from,FALSE,FALSE);
			$top_row->pack_start($from_label,TRUE,TRUE);
			$bottom_row->pack_start($cc,FALSE,FALSE);
			$bottom_row->pack_start($cc_label,TRUE,TRUE); 
			
			$bottom_row->pack_start($subj,FALSE,FALSE);
			$bottom_row->pack_start($subj_label,TRUE,TRUE);
	
			$table->pack_start($top_row,FALSE,FALSE);
			$table->pack_start($bottom_row,FALSE,FALSE);
			
			$all_labels=array($to,$from,$subj,$cc,$to_label,$from_label,$subj_label,$cc_label);
			
			for ($i=0;$i<count($all_labels);$i++) {
				$all_labels[$i]->set_justify(GTK_JUSTIFY_LEFT);
				$all_labels[$i]->set_line_wrap(TRUE);
			}
			
			$this->add($table);
			$this->show_all();
	}
/* ###################################################################################################################
	Push the appropriate text into each label
###################################################################################################################*/	
	function set_values ($to,$from,$subj,$cc) {
		$labels=$this->labels;
		$labels[0]->set_text(trim($to));
		$labels[1]->set_text(trim($from));
		$labels[2]->set_text(trim($subj));
		if (isset($cc))
			$labels[3]->set_text(trim($cc));
	
	}
/* ###################################################################################################################
	Reset all the text boxes to nothing
###################################################################################################################*/
	function clear() {
		$labels=$this->labels;
		foreach ($labels as $current_label)
			$current_label->set_text(NULL);
	
	}
}