	<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* 
	Here we just build our own button that has an icon and a text label on it. I use this throughout Teak so it makes sense
	to create our own subclass
	We pass to it:
		$text = text label to appear on the button
		$image_name = text string of the image to load
		$window = The parent window, we need the GdkWindow from there for loading the pixmap
		$orientation = one of VERT or HORZ, tells us to make a GtkVBox or GtkHbox in the button
		$tt_text = ToolTip Text (if any)
*/

Class PictureButton extends GtkButton {
	function PictureButton ($text, $image_name, $window, $orientation, $tt_text) {
		$this->GtkButton();
		
		list($pixmap, $mask) = Gdk::pixmap_create_from_xpm($window->window,null,$image_name);
		$button_image = &new GtkPixmap($pixmap, $mask);
		
		switch ($orientation) {
			case VERT:
			$button_box = &new GtkVBox();
			break;
			
			case HORZ:
			$button_box = &new GtkHBox();
			break;
			
			default:
			$button_box = &new GtkHBox();
			break;
		}
		$button_label = &new GtkLabel($text);
		
		$button_box->pack_start($button_image);
		$button_box->pack_start($button_label);
		
		if ($tt_text !== NULL) {
			$tt = &new GtkTooltips();
			$tt->set_delay(300);
			$tt->set_tip($this, $tt_text, '');
			$tt->enable();
		}
		
		$this->add($button_box);
	}
}

?>
