<?php
/*

	Copyright (C) 2001 Richard D. Payne

	 This file is part of Teak (http://teak.sourceforge.net).

    Teak is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    Teak is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Teak; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/*

	We extend the base GtkText class and do some basic URL handling.

*/

	Class TeakText extends GtkText {
		var $search_for_urls;
		var $url_array;
				
		// Constructor
		function TeakText() {
			$this->GtkText();
			
			$this->connect_object('button_press_event',array($this, mouse_clicked));
		}
			
/* ####################################################################################################################
	Inserts text into the GtkText widget. 
	$text should be the entire string we want in the widget, we don't append but rather delete the contents and start from scratch
####################################################################################################################*/
		function teak_text_set_text ($text) {
		
			global $config;
			global $url_array;
			
			$url_array = NULL;
			
			$this->freeze();
			$this->set_point(0);
			$length = $this->get_length();
			$this->forward_delete($length);
			
			// OK this should match http, https, ftp and mailto tags and stuffs the URL into an array
			if (($return=preg_match_all("/[hf]tt*p.*\n|mailto.*\n/i",$text,$matches)) && ($config[preferences][parse_urls] == TRUE)) {
				$url_col = &new GdkColor(0,0,65535);
				
				$start_pos = 0;
				
				for ($i=0;$i<$return;$i++) {
					
					// Find the beginning of the URL
					$url_pos = strpos($text,($matches[0][$i]),$start_pos);
					
					// Find the end
					$end_pos = $url_pos + strlen($matches[0][$i]);
															
					//insert into the text box everything up to this URL
					$this->insert(null,null,null,substr($text,$start_pos,($url_pos - $start_pos)),-1);
					
					//Now the URL
					$this->insert(null, $url_col,null,substr($text, $url_pos, ($end_pos - $url_pos)),-1);
					$url_array[] = array($pos,$end_pos, trim(substr($text,$url_pos,($end_pos - $url_pos))));
					
					// Set the start to be our current end a go again.
					$start_pos = $end_pos;
				}
				// Insert any additional text after the last URL
				if ($end_pos < strlen($text)) 
					$this->insert(null,null,null, substr($text,$end_pos,(strlen($text) - $end_pos)));
				
			}
			else
				// The user doesn't want us to look for URLs
				$this->insert(null,null,null,$text,-1);
				
				
				
			$this->thaw();
			
		}
/* ###################################################################################################################
	Called when the users clicks the mouse in this widget. We only respond if it's a double click within one of our known URLs
	
	This should really be handled by main_window.....why you ask? Because we have a set of IMAP connection already setup in main_window
	and we create a compose_window here but don't pass the imap connection to it....not good.
###################################################################################################################*/
		function mouse_clicked ($event) {
			global $config;
			global $url_array;
			
			if (($event->button == 1) && ($event->type == GDK_2BUTTON_PRESS)) {
				$click_pos = $this->get_position();
				for ($i=0;$i<count($url_array);$i++) {
					if (($url_array[$i][0] <= $click_pos) && ($click_pos < $url_array[$i][1])) {
						if (strncasecmp("mailto",$url_array[$i][2],6) == 0) {
							//First strip off any mailto: tag
							$to_address = substr($url_array[$i][2],strpos($url_array[$i][2],":")+1);
							
							// While the email addres doesn't match this regex, strip one char of the end
							// Regex = any number of chars ending with a letter, this gets rid of ] and so on
							while (!(preg_match("/.*[a-zA-Z]\$/",$to_address))) 
								$to_address = substr($to_address,0,strlen($to_address) -1);
							
						$composer = &new Compose_Window($to_address,null,null,null,null,null);
						}
						// We have just a regulat ftp/http/https url
						else {
							$run_string = $config[preferences][browser]." ".$url_array[$i][2];
							exec ("$run_string >/dev/null 2>&1");
						}
						return;
					}
						
				}
			}			
		}
}
?>
